Package: CaDrA
Type: Package
Title: Candidate Driver Analysis
Version: 1.10.0
Authors@R: 
  c(person(given="Reina", family="Chau", role=c("aut","cre"), 
           email="rchau88@bu.edu", comment=c(ORCID="0000-0003-3012-1404")), 
    person(given="Katia", family="Bulekova", role=c("aut"), 
           email="ktrn@bu.edu", comment=c(ORCID="0000-0003-1560-2146")),
    person(given="Vinay", family="Kartha", role=c("aut"), 
           email="vkartha@bu.edu"), 
    person(given="Stefano", family="Monti", role=c("aut"), 
           email="smonti@bu.edu", comment=c(ORCID="0000-0002-9376-0660"))
   )
Description: Performs both stepwise and backward heuristic search for 
  candidate (epi)genetic drivers based on a binary multi-omics dataset. 
  CaDrA's main objective is to identify features which, together, are 
  significantly skewed or enriched pertaining to a given vector of 
  continuous scores (e.g. sample-specific scores representing a phenotypic 
  readout of interest, such as protein expression, pathway activity, etc.), 
  based on the union occurence (i.e. logical OR) of the events.
Depends: R (>= 4.4.0)
LazyData: false
License: GPL-3 + file LICENSE
URL: https://github.com/montilab/CaDrA/
Packaged: 2026-04-28 21:02:11 UTC; biocbuild
Encoding: UTF-8
RoxygenNote: 7.3.3
Imports: doParallel, ggplot2, gplots, graphics, grid, gtable, knnmi,
        MASS, methods, misc3d, plyr, ppcor, R.cache, reshape2, stats,
        SummarizedExperiment
Suggests: BiocManager, devtools, knitr, pheatmap, rmarkdown, testthat
        (>= 3.1.6)
Config/testthat/edition: 3
biocViews: Microarray, RNASeq, GeneExpression, Software,
        FeatureExtraction
VignetteBuilder: knitr
BugReports: https://github.com/montilab/CaDrA/issues
git_url: https://git.bioconductor.org/packages/CaDrA
git_branch: RELEASE_3_23
git_last_commit: 17d98f6
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: yes
Author: Reina Chau [aut, cre] (ORCID: <https://orcid.org/0000-0003-3012-1404>),
  Katia Bulekova [aut] (ORCID: <https://orcid.org/0000-0003-1560-2146>),
  Vinay Kartha [aut],
  Stefano Monti [aut] (ORCID: <https://orcid.org/0000-0002-9376-0660>)
Maintainer: Reina Chau <rchau88@bu.edu>

<!-- README.md is generated from README.Rmd. Please edit that file -->

# CaDrA

![build](https://github.com/montilab/cadra/workflows/rcmdcheck/badge.svg)
![Gitter](https://img.shields.io/gitter/room/montilab/cadra) ![GitHub
issues](https://img.shields.io/github/issues/montilab/cadra) ![GitHub
last commit](https://img.shields.io/github/last-commit/montilab/cadra)

**Ca**ndidate **Dr**ivers **A**nalysis: Multi-Omic Search for Candidate
Drivers of Functional Signatures

**CaDrA** is an R package that supports a heuristic search framework
aimed at identifying candidate drivers of a molecular phenotype of
interest.

The main function takes two inputs:

1)  A binary multi-omics dataset, which can be represented as a matrix
    of binary features or a **SummarizedExperiment** class object where
    the rows are 1/0 vectors indicating the presence/absence of ‘omics’
    features (e.g. somatic mutations, copy number alterations,
    epigenetic marks, etc.), and the columns are the samples.
2)  A molecular phenotype of interest which can be represented as a
    vector of continuous scores (e.g. protein expression, pathway
    activity, etc.)

Based on these two inputs, **CaDrA** implements a forward and/or
backward search algorithm to find a set of features that together is
maximally associated with the observed input scores, based on one of
several scoring functions (*Kolmogorov-Smirnov*, *Wilcoxon*,
*Conditional Mutual Information*, *K-Nearest Neighbor Mutual Information
Estimator*, *correlation*, or *custom-defined scoring function*), making
it useful to find complementary omics features likely driving the input
molecular phenotype.

Please see our [documentation](https://montilab.github.io/CaDrA/) for
additional examples.

# Web Interface

We developed an R Shiny Dashboard that would allow users to interact
with **CaDrA** directly without the need to install or maintain the
package.

See our web portal at <https://cadra.bu.edu/>

# Installation

- Using `devtools` package

``` r
library(devtools)
devtools::install_github("montilab/CaDrA")
```

- Using `BiocManager` package

``` r
# Install BiocManager
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

# Install CaDrA
BiocManager::install("CaDrA")

# Install SummarizedExperiment
BiocManager::install("SummarizedExperiment")
```

# Usage

Here, we are using a dataset of somatic mutations and CNAs extracted
from the TCGA Breast Cancer Dataset. We will query this Feature Set
based on an Input Score that measures the per-sample activity of YAP/TAZ
(two important regulators of the hippo pathway). This score represents
the projection on the TCGA BrCa dataset of a gene expression signature
of YAP/TAZ knockdown derived in breast cancer cell lines. Our question
of interest: what is the combination of genetic features (mutations and
copy number alterations) that best “explain” the YAP/TAZ activity?

## (i) Load R packages

``` r
library(CaDrA)
library(SummarizedExperiment)
```

## (ii) Format and filter data inputs

``` r
## Read in BRCA GISTIC+Mutation object
utils::data(BRCA_GISTIC_MUT_SIG)
eset_mut_scna <- BRCA_GISTIC_MUT_SIG

## Read in input score
utils::data(TAZYAP_BRCA_ACTIVITY)
input_score <- TAZYAP_BRCA_ACTIVITY

## Samples to keep based on the overlap between the two inputs
overlap <- base::intersect(base::names(input_score), base::colnames(eset_mut_scna))
eset_mut_scna <- eset_mut_scna[, overlap]
input_score <- input_score[overlap]

## Binarize FS to only have 0's and 1's
SummarizedExperiment::assay(eset_mut_scna)[SummarizedExperiment::assay(eset_mut_scna) > 1] <- 1.0

## Pre-filter FS based on occurrence frequency
eset_mut_scna_flt <- CaDrA::prefilter_data(
  FS = eset_mut_scna,
  max_cutoff = 0.6,  # max event frequency (60%)
  min_cutoff = 0.03  # min event frequency (3%)
)  
```

## (iii) Run CaDrA

Here, we repeat the candidate search starting from each of the top ‘N’
features and report the combined results as a heatmap (to summarize the
number of times each feature is selected across repeated runs).

**IMPORTANT NOTE**: The legacy function `topn_eval()` is equivalent to
the new recommended `candidate_search()` function.

``` r
topn_res <- CaDrA::candidate_search(
  FS = eset_mut_scna_flt,
  input_score = input_score,
  method = "ks_pval",          # Use Kolmogorow-Smirnow scoring function 
  method_alternative = "less", # Use one-sided hypothesis testing
  weights = NULL,              # If weights is provided, perform a weighted-KS test
  search_method = "both",      # Apply both forward and backward search
  top_N = 7,                   # Evaluate top 7 starting points for each search
  max_size = 7,                # Maximum size a meta-feature matrix can extend to
  do_plot = FALSE,             # Plot after finding the best features
  best_score_only = FALSE      # Return all results from the search
)
```

## (iv) Visualize the results

### Meta-feature plot

This plot produces 3 graphics stacked on top of each other:

1.  A density diagram of observed input scores sorted from highest to
    lowest
2.  A tile plot for the top meta-features that associated with a
    molecular phenotype of interest (e.g. input_score)
3.  A KS enrichment plot of the meta-feature set (this correspond to the
    logical OR of the features)

``` r
## Fetch the meta-feature set corresponding to its best scores over top N features searches
topn_best_meta <- CaDrA::topn_best(topn_res)

# Visualize the best results with the meta-feature plot
CaDrA::meta_plot(topn_best_list = topn_best_meta, input_score_label = "YAP/TAZ Activity")
```

![](./man/figures/visualize.best-1.png)<!-- -->

### Top-N plot

This plot is a heatmap of overlapping meta-features by repeating
`candidate_search` over top N feature searches.

``` r
# Evaluate results across top N features you started from
CaDrA::topn_plot(topn_res) 
```

![](./man/figures/summarize-1.png)<!-- -->

# Additional Guides

- [How to run CaDrA within a Docker
  environment](https://montilab.github.io/CaDrA/articles/docker.html)

# Acknowledgements

This project is funded in part by the
[NIH/NIDCR](https://www.nidcr.nih.gov/) (3R01DE030350-01A1S1,
R01DE031831), [Find the Cause Breast Cancer
Foundation](https://findthecausebcf.org), and
[NIH/NIA](https://www.nia.nih.gov/) (UH3 AG064704).

#' Permutation Best Scores Plot
#'
#' Plot the Empirical Null Distribution of Permutation Best Scores returned from
#' \code{CaDrA} function
#'
#' @param perm_res a list of objects returned from \code{CaDrA} function.
#' The returning object contains a list of key parameters that are used to run
#' the permutation-based testing, a vector of permuted best scores for a given 
#' \code{n_perm}, an observed best score, and a computed permutation p-value.
#'
#' @return a density plot
#' @examples
#'
#' # Load pre-computed permutation results
#' data(perm_res)
#'
#' # Plot the permutation results
#' permutation_plot(perm_res)
#'
#' @export
#' @import gplots
#' @importFrom graphics legend
permutation_plot <- function(perm_res){

  ## Extract values from the the permutation results
  top_N <- perm_res[["key"]][["top_N"]]
  search_start <- perm_res[["key"]][["search_start"]]
  perm_best_scores <- perm_res[["perm_best_scores"]]
  perm_pval <- perm_res[["perm_pval"]]
  obs_best_score <- perm_res[["obs_best_score"]]

  plot_title <- paste("Emperical Null distribution (N = ",
                      length(perm_best_scores),
                      ")\n Permutation p-val <= ",
                      round(perm_pval, 5),
                      "\nBest observed score: ",
                      round(obs_best_score, 5), sep="")

  if(!is.null(top_N)){
    plot_title <- paste0(plot_title, "\n Top N: ", top_N)
  }else{
    plot_title <- paste0(plot_title, "\n Seed: ", 
                         paste0(search_start, collapse=", "))
  }

  # Here, let us plot the absolute values of the permutation p-values,
  # for simplicity
  #You only consider absolute values when calculating the permutation p-values
  g <- ggplot(data = data.frame("x" = perm_best_scores), aes(x = .data$x)) +
    geom_histogram(fill = "black", color = "gray") +
    theme_classic() +
    theme(
      axis.line.x=element_line(color = "black"),
      axis.line.y=element_line(color = "black")
    )

  g <- g + geom_vline(xintercept = obs_best_score, linetype = "longdash",
                      colour = "red") +   # linewidth = 1.5
    labs(
      title = plot_title,
      x = "Score",
      y = "Count"
    ) +
    theme(plot.title = element_text(hjust = 0.5)) +
    scale_x_continuous(expand = c(0, 0)) +
    scale_y_continuous(expand = c(0, 0))

  g

}

test_that("permutation_plot works", {
  
  data(perm_res)
  
  # Plot the permutation results
  g <- permutation_plot(perm_res)
  
  expect_type(g, "object")
  expect_s3_class(g$layers[[1]], "LayerInstance")
  expect_s3_class(g$layers[[1]]$geom, "GeomBar")
  expect_s3_class(g$layers[[2]], "LayerInstance")
  expect_s3_class(g$layers[[2]]$geom, "GeomVline")
  
  expect_identical(g$labels$x, "Score")
  expect_identical(g$labels$y, "Count")
  
})

#' Calculate row-wise scores of a given binary feature set based on
#' a given scoring method
#'
#' @param FS a matrix of binary features or a SummarizedExperiment class object
#' from SummarizedExperiment package where rows represent features of interest
#' (e.g. genes, transcripts, exons, etc...) and columns represent the samples.
#' The assay of FS contains binary (1/0) values indicating the presence/absence
#' of omics features.
#' @param input_score a vector of continuous scores representing a phenotypic
#' readout of interest such as protein expression, pathway activity, etc.
#'
#' NOTE: \code{input_score} object must have names or labels that match the
#' column names of \code{FS} object.
#' @param meta_feature a vector of one or more features representing known
#' causes of activation or features associated with a response of interest
#' (\code{e.g. input_score}). Default is NULL.
#' @param method a character string specifies a scoring method that is
#' used in the search. There are 6 options: (\code{"ks_pval"} or \code{ks_score}
#' or \code{"wilcox_pval"} or \code{wilcox_score} or
#' \code{"revealer"} (conditional mutual information from REVEALER) or
#' \code{"knnmi"} (k-Nearest Neighbor Mutual Information Estimator from knnmi) or
#' \code{"correlation"} (based on simple correlation - pearson or spearman) or
#' \code{"custom"} (a user-defined scoring method)).
#' Default is \code{ks_pval}.
#' @param method_alternative a character string specifies an alternative
#' hypothesis testing (\code{"two.sided"} or \code{"greater"} or \code{"less"}).
#' Default is \code{less} for left-skewed significance testing.
#'
#' NOTE: This argument only applies to \code{ks_pval} and \code{wilcox_pval}
#' method
#' @param cmethod correlation method to use - spearman or pearson. Default is "spearman"
#' #' NOTE: This argument only applies to \code{correlation} method only
#' @param custom_function if method is \code{"custom"}, specifies
#' a user-defined function here. Default is \code{NULL}.
#'
#' NOTE: \code{custom_function} must take \code{FS} and \code{input_score}
#' as its input arguments, and its final result must return a vector of row-wise
#' scores where its labels or names matched the row names of \code{FS} object.
#' @param custom_parameters if method is \code{"custom"}, specifies a list of
#' additional arguments (excluding \code{FS} and \code{input_score}) to be
#' passed to \code{custom_function}. For example:
#' custom_parameters = list(alternative = "less"). Default is \code{NULL}.
#' @param weights If method is \code{ks_score} or \code{ks_pval}, specifying a
#' vector of weights will perform a weighted-KS testing. Default is \code{NULL}.
#'
#' NOTE: \code{weights} must have names or labels that match the names or labels
#' of \code{input_score}.
#' @param do_check a logical value indicates whether or not to validate if the
#' given parameters (\code{FS} and \code{input_score}) are valid inputs.
#' Default is \code{TRUE}.
#' @param verbose a logical value indicates whether or not to print the
#' diagnostic messages. Default is \code{FALSE}.
#' @param ... additional parameters to be passed to \code{custom_function}
#'
#' @return return a vector of row-wise positive scores where it is ordered from
#' most significant to least significant (e.g. from highest to lowest values)
#' and its labels or names must match the row names of \code{FS} object
#'
#' @examples
#'
#' # Create a feature matrix
#' mat <- matrix(c(1,0,1,0,0,0,0,0,1,0,
#'                 0,0,1,0,1,0,1,0,0,0,
#'                 0,0,0,0,1,0,1,0,1,0), nrow=3)
#'
#' colnames(mat) <- 1:10
#' row.names(mat) <- c("TP_1", "TP_2", "TP_3")
#'
#' # Create a vector of observed input scores
#' set.seed(42)
#' input_score = rnorm(n = ncol(mat))
#' names(input_score) <- colnames(mat)
#'
#' # Run the ks method
#' ks_rowscore_result <- calc_rowscore(
#'   FS = mat,
#'   input_score = input_score,
#'   meta_feature = NULL,
#'   method = "ks_pval",
#'   method_alternative = "less",
#'   weights = NULL
#' )
#'
#' # Run the wilcoxon method
#' wilcox_rowscore_result <- calc_rowscore(
#'   FS = mat,
#'   input_score = input_score,
#'   meta_feature = NULL,
#'   method = "wilcox_pval",
#'   method_alternative = "less"
#' )
#'
#' # Run the revealer method
#' revealer_rowscore_result <- calc_rowscore(
#'   FS = mat,
#'   input_score = input_score,
#'   meta_feature = NULL,
#'   method = "revealer"
#' )
#' 
#' # Run the revealer method
#' knnmi_rowscore_result <- calc_rowscore(
#'   FS = mat,
#'   input_score = input_score,
#'   meta_feature = NULL,
#'   method = "knnmi"
#' )
#' 
#' # Run the correlation method
#'  corr_result <- calc_rowscore(
#'    FS = mat,
#'    input_score = input_score,
#'    meta_feature = NULL,
#'    method = "correlation",
#'    cmethod = "spearman"
#' )
#'
#' # A customized function using ks-test function
#' customized_ks_rowscore <- function(FS, input_score, meta_feature=NULL, alternative="less"){
#'
#'   # Check if meta_feature is provided
#'   if(!is.null(meta_feature)){
#'     # Getting the position of the known meta features
#'     locs <- match(meta_feature, row.names(FS))
#'
#'     # Taking the union across the known meta features
#'     if(length(locs) > 1) {
#'       meta_vector <- as.numeric(ifelse(colSums(FS[locs,]) == 0, 0, 1))
#'     }else{
#'       meta_vector <- as.numeric(FS[locs,])
#'     }
#'
#'     # Remove the meta features from the binary feature matrix
#'     # and taking logical OR btw the remaining features with the meta vector
#'     FS <- base::sweep(FS[-locs, , drop=FALSE], 2, meta_vector, `|`)*1
#'
#'     # Check if there are any features that are all 1s generated from
#'     # taking the union between the matrix
#'     # We cannot compute statistics for such features and thus they need
#'     # to be filtered out
#'     if(any(rowSums(FS) == ncol(FS))){
#'       warning("Features with all 1s generated from taking the matrix union ",
#'               "will be removed before progressing...\n")
#'       FS <- FS[rowSums(FS) != ncol(FS), , drop=FALSE]
#'     }
#'   }
#'
#'   # KS is a ranked-based method
#'   # So we need to sort input_score from highest to lowest values
#'   input_score <- sort(input_score, decreasing=TRUE)
#'
#'   # Re-order the matrix based on the order of input_score
#'   FS <- FS[, names(input_score), drop=FALSE]
#'
#'   # Compute the scores using the KS method
#'   ks <- apply(FS, 1, function(r){
#'     x = input_score[which(r==1)];
#'     y = input_score[which(r==0)];
#'     res <- ks.test(x, y, alternative=alternative)
#'     return(c(res$statistic, res$p.value))
#'   })
#'
#'   # Obtain score statistics
#'   stat <- ks[1,]
#'
#'   # Obtain p-values and change values of 0 to the machine lowest value
#'   # to avoid taking -log(0)
#'   pval <- ks[2,]
#'   pval[which(pval == 0)] <- .Machine$double.xmin
#'
#'   # Compute the -log(pval)
#'   # Make sure scores has names that match the row names of FS object
#'   scores <- -log(pval)
#'   names(scores) <- rownames(FS)
#'
#'   return(scores)
#'
#' }
#'
#' # Search for best features using a custom-defined function
#' custom_rowscore_result <- calc_rowscore(
#'   FS = mat,
#'   input_score = input_score,
#'   meta_feature = NULL,
#'   method = "custom",
#'   custom_function = customized_ks_rowscore,
#'   custom_parameters = NULL
#' )
#'
#' @export
#' @import SummarizedExperiment
calc_rowscore <- function(
    FS,
    input_score,
    meta_feature = NULL,
    method = c("ks_pval", "ks_score", "wilcox_pval", "wilcox_score",
               "revealer", "knnmi", "correlation", "custom"),
    method_alternative = c("less", "greater", "two.sided"),
    cmethod = c("spearman", "pearson"),
    custom_function = NULL,
    custom_parameters = NULL,
    weights = NULL,
    do_check = TRUE,
    verbose = FALSE,
    ...
){

  # Set up verbose option
  options(verbose = verbose)

  # Match arguments
  method <- match.arg(method)
  method_alternative <- match.arg(method_alternative)

  if (method == "correlation") {
    cmethod <- match.arg(cmethod)
  }

  # Check if FS is a matrix or a SummarizedExperiment class object
  if(!is(FS, "SummarizedExperiment") && !is(FS, "matrix"))
    stop("'FS' must be a matrix or a SummarizedExperiment class object
         from SummarizedExperiment package")

  # Retrieve the binary feature matrix
  if(is(FS, "SummarizedExperiment")){
    FS_mat <- SummarizedExperiment::assay(FS)
  }else{
    FS_mat <- FS
  }

  # Check if FS and input_score are valid inputs
  if(do_check == TRUE)
    check_data_input(FS_mat = FS_mat, input_score = input_score,
                     meta_feature = meta_feature, do_check = do_check)

  # Define metric value based on a given scoring method
  if(length(grep("score", method)) > 0){
    metric <- "stat"
  }else{
    metric <- "pval"
  }

  # Extract only the method value (e.g. ks/wilcox/revealer/custom)
  # based on a given method string
  method <- gsub("_score|_pval", "", method)

  # Select the appropriate method to compute row-wise directional scores
  rscores <- switch(
    method,
    ks = ks_rowscore(
      FS = FS_mat,
      input_score = input_score,
      meta_feature = meta_feature,
      weights = weights,
      alternative = method_alternative,
      metric = metric
    ),
    wilcox = wilcox_rowscore(
      FS = FS_mat,
      input_score = input_score,
      meta_feature = meta_feature,
      alternative = method_alternative,
      metric = metric
    ),
    revealer = revealer_rowscore(
      FS = FS_mat,
      input_score = input_score,
      meta_feature = meta_feature,
      assoc_metric = "IC"
    ),
    knnmi = knnmi_rowscore(
      FS = FS_mat,
      input_score = input_score,
      meta_feature = meta_feature
    ),
    correlation = corr_rowscore(
      FS = FS,
      input_score = input_score,
      meta_feature = meta_feature,
      corr_method = cmethod
    ),
    custom = custom_rowscore(
      FS = FS,
      input_score = input_score,
      meta_feature = meta_feature,
      method = method,
      alternative = method_alternative,
      custom_function = custom_function,
      custom_parameters = custom_parameters,
      weights = weights,
      do_check = do_check,
      verbose = verbose,
      ...
    )
  )

  return(rscores)

}

test_that("check_top_N returns expected result ",{
  
  data(sim_FS)
  data(sim_Scores)
  
  set.seed(21)
  
  rowscore <- calc_rowscore(
    FS = sim_FS,
    input_score = sim_Scores,
    meta_feature = NULL,
    method = "ks_pval",
    alternative = "less",
    weights = NULL
  )
  
  # Re-order rowscore in a decreasing order (from highest to lowest values)
  # This comes in handy when doing the top-N evaluation of
  # top N 'best' features
  rowscore <- rowscore[order(rowscore, decreasing=TRUE)]
  
  top_N_index <- check_top_N(
    rowscore = rowscore,
    top_N = 7,
    search_start = NULL,
    feature_names = rownames(sim_FS)
  )
  
  expect_type(top_N_index, "integer")
  expect_length(top_N_index, 7L)
  expect_identical(top_N_index, c(8L, 9L, 10L, 6L, 948L, 706L, 995L))
  
})

## ----set.up, include=FALSE, echo=FALSE, message=FALSE, warning=FALSE----------
knitr::opts_chunk$set(message=FALSE, collapse = TRUE, comment="")

# R packages
library(SummarizedExperiment)
library(pheatmap)
library(devtools)
load_all()

## ----load.data----------------------------------------------------------------
# Load pre-computed feature set
data(sim_FS)
 
# Load pre-computed input scores
data(sim_Scores)

## ----heatmap------------------------------------------------------------------
mat <- SummarizedExperiment::assay(sim_FS)
pheatmap::pheatmap(mat[1:100, ], color = c("white", "red"), cluster_rows = FALSE, cluster_cols = FALSE)

## ----ks.method----------------------------------------------------------------
ks_topn_l <- CaDrA::candidate_search(
  FS = sim_FS,
  input_score = sim_Scores,
  method = "ks_pval",          # Use Kolmogorov-Smirnov scoring function 
  method_alternative = "less", # Use one-sided hypothesis testing
  weights = NULL,              # If weights is provided, perform a weighted-KS test
  search_method = "both",      # Apply both forward and backward search
  top_N = 3,                   # Evaluate top 3 starting points for the search
  max_size = 10,               # Allow at most 10 features in meta-feature matrix
  do_plot = FALSE,             # We will plot it AFTER finding the best hits
  best_score_only = FALSE      # Return all results from the search
)

# Now we can fetch the feature set of top N features that corresponded to the best scores over the top N search
ks_topn_best_meta <- topn_best(ks_topn_l)

# Visualize best meta-feature result
meta_plot(topn_best_list = ks_topn_best_meta)

## ----wilcox.method------------------------------------------------------------
wilcox_topn_l <- CaDrA::candidate_search(
  FS = sim_FS,
  input_score = sim_Scores,
  method = "wilcox_pval",      # Use Wilcoxon Rank-Sum scoring function
  method_alternative = "less", # Use one-sided hypothesis testing
  search_method = "both",      # Apply both forward and backward search
  top_N = 3,                   # Evaluate top 3 starting points for the search
  max_size = 10,               # Allow at most 10 features in meta-feature matrix
  do_plot = FALSE,             # We will plot it AFTER finding the best hits
  best_score_only = FALSE      # Return all results from the search
)

# Now we can fetch the feature set of top N feature that corresponded to the best scores over the top N search
wilcox_topn_best_meta <- topn_best(topn_list = wilcox_topn_l)

# Visualize best meta-feature result
meta_plot(topn_best_list = wilcox_topn_best_meta)

## ----revealer.method----------------------------------------------------------
revealer_topn_l <- CaDrA::candidate_search(
  FS = sim_FS,
  input_score = sim_Scores,
  method = "revealer",         # Use REVEALER's CMI scoring function
  search_method = "both",      # Apply both forward and backward search
  top_N = 3,                   # Evaluate top 3 starting points for the search
  max_size = 10,               # Allow at most 10 features in meta-feature matrix
  do_plot = FALSE,             # We will plot it AFTER finding the best hits
  best_score_only = FALSE      # Return all results from the search
)

# Now we can fetch the ESet of top feature that corresponded to the best scores over the top N search
revealer_topn_best_meta <- topn_best(topn_list = revealer_topn_l)

# Visualize best meta-feature result
meta_plot(topn_best_list = revealer_topn_best_meta)

## ----knnmi.method-------------------------------------------------------------
knnmi_topn_l <- CaDrA::candidate_search(
  FS = sim_FS,
  input_score = sim_Scores,
  method = "knnmi",            # Use knnmi scoring function
  search_method = "both",      # Apply both forward and backward search
  top_N = 3,                   # Evaluate top 3 starting points for the search
  max_size = 10,               # Allow at most 10 features in meta-feature matrix
  do_plot = FALSE,             # We will plot it AFTER finding the best hits
  best_score_only = FALSE      # Return all results from the search
)

# Now we can fetch the ESet of top feature that corresponded to the best scores over the top N search
knnmi_topn_best_meta <- topn_best(topn_list = knnmi_topn_l)

# Visualize best meta-feature result
meta_plot(topn_best_list = knnmi_topn_best_meta)

## ----correlation.method-------------------------------------------------------
corr_topn_l <- CaDrA::candidate_search(
  FS = SummarizedExperiment::assay(sim_FS),
  input_score = sim_Scores,
  method = "correlation",      # Use correlation scoring function
  cmethod = "spearman",        # Use spearman correlation scoring function
  top_N = 3,                   # Evaluate top 3 starting points for the search
  max_size = 10,               # Allow at most 10 features in meta-feature matrix
  do_plot = FALSE,             # We will plot it AFTER finding the best hits
  best_score_only = FALSE      # Return all results from the search
)

# Now we can fetch the feature set of top N feature that corresponded to the best scores over the top N search
corr_topn_best_meta <- topn_best(topn_list = corr_topn_l)

# Visualize best meta-feature result
meta_plot(topn_best_list = corr_topn_best_meta)

## ----custom.method------------------------------------------------------------
# A customized function using ks-test
customized_ks_rowscore <- function(FS, input_score, weights=NULL, meta_feature=NULL, alternative="less", metric="pval"){
  
  metric <- match.arg(metric)
  alternative <- match.arg(alternative)
  
  # Check if meta_feature is provided
  if(!is.null(meta_feature)){
    # Getting the position of the known meta features
    locs <- match(meta_feature, row.names(FS))
    
    # Taking the union across the known meta features
    if(length(locs) > 1) {
      meta_vector <- as.numeric(ifelse(colSums(FS[locs,]) == 0, 0, 1))
    }else{
      meta_vector <- as.numeric(FS[locs, , drop=FALSE])
    }
    
    # Remove the meta features from the binary feature matrix
    # and taking logical OR btw the remaining features with the meta vector
    FS <- base::sweep(FS[-locs, , drop=FALSE], 2, meta_vector, `|`)*1
    
    # Check if there are any features that are all 1s generated from
    # taking the union between the matrix
    # We cannot compute statistics for such features and thus they need
    # to be filtered out
    if(any(rowSums(FS) == ncol(FS))){
      verbose("Features with all 1s generated from taking the matrix union ",
              "will be removed before progressing...\n")
      FS <- FS[rowSums(FS) != ncol(FS), , drop=FALSE]
      # If no features remained after filtering, exist the function
      if(nrow(FS) == 0) return(NULL)
    }
  }
    
  # KS is a ranked-based method
  # So we need to sort input_score from highest to lowest values
  input_score <- sort(input_score, decreasing=TRUE)
  
  # Re-order the matrix based on the order of input_score
  FS <- FS[, names(input_score), drop=FALSE]  
  
  # Check if weights is provided
  if(length(weights) > 0){
    # Check if weights has any labels or names
    if(is.null(names(weights)))
      stop("The weights object must have names or labels that ",
           "match the labels of input_score\n")

    # Make sure its labels or names match the
    # the labels of input_score 
    weights <- as.numeric(weights[names(input_score)])
  }

  # Get the alternative hypothesis testing method
  alt_int <- switch(alternative, two.sided=0L, less=1L, greater=-1L, 1L)

  # Compute the ks statistic and p-value per row in the matrix
  ks <- .Call(ks_genescore_mat_, FS, weights, alt_int)

  # Obtain score statistics from KS method
  # Change values of 0 to the machine lowest value to avoid taking -log(0)
  stat <- ks[1,]

  # Obtain p-values from KS method
  # Change values of 0 to the machine lowest value to avoid taking -log(0)
  pval <- ks[2,]
  pval[which(pval == 0)] <- .Machine$double.xmin
  
  # Compute the scores according to the provided metric
  scores <- ifelse(rep(metric, nrow(FS)) %in% "pval", -log(pval), stat)
  names(scores) <- rownames(FS)

  return(scores)
  
}

# Search for best features using a custom-defined function
custom_topn_l <- CaDrA::candidate_search(
  FS = SummarizedExperiment::assay(sim_FS),
  input_score = sim_Scores,
  method = "custom",                        # Use custom scoring function
  custom_function = customized_ks_rowscore, # Use a customized scoring function
  custom_parameters = NULL,                 # Additional parameters to pass to custom_function
  weights = NULL,                           # If weights is provided, perform a weighted test
  search_method = "both",                   # Apply both forward and backward search
  top_N = 3,                                # Evaluate top 3 starting points for the search
  max_size = 10,                            # Allow at most 10 features in meta-feature matrix
  do_plot = FALSE,                          # We will plot it AFTER finding the best hits
  best_score_only = FALSE                   # Return all results from the search
)

# Now we can fetch the feature set of top N feature that corresponded to the best scores over the top N search
custom_topn_best_meta <- topn_best(topn_list = custom_topn_l)

# Visualize best meta-feature result
CaDrA::meta_plot(topn_best_list = custom_topn_best_meta)

# Evaluate results across top N features you started from
CaDrA::topn_plot(custom_topn_l) 

## -----------------------------------------------------------------------------
topn_res <- CaDrA::candidate_search(
  FS = sim_FS,
  input_score = sim_Scores,
  method = "ks_pval",          # Use Kolmogorov-Smirnov scoring function 
  method_alternative = "less", # Use one-sided hypothesis testing
  weights = NULL,              # If weights is provided, perform a weighted-KS test
  search_method = "both",      # Apply both forward and backward search
  top_N = 3,                   # Evaluate top 7 starting points for each search
  max_size = 10,               # Maximum size a meta-feature matrix can extend to
  do_plot = FALSE,             # Plot after finding the best features
  best_score_only = FALSE      # Return all results from the search
)

## Fetch the meta-feature set corresponding to its best scores over top N features searches
topn_best_meta <- topn_best(topn_res)

# Visualize the best results with the meta-feature plot
meta_plot(topn_best_list = topn_best_meta)

# Evaluate results across top N features you started from
topn_plot(topn_res) 

## ----RsessionInfo-------------------------------------------------------------
sessionInfo()

#' Customized Scoring Method
#'
#' Compute a row-wise score for each row of a given binary feature matrix
#' using a custom-defined function
#'
#' @param FS a matrix of binary features or a SummarizedExperiment class object 
#' from SummarizedExperiment package where rows represent features of interest 
#' (e.g. genes, transcripts, exons, etc...) and columns represent the samples. 
#' The assay of FS contains binary (1/0) values indicating the presence/absence 
#' of omics features.
#' @param input_score a vector of continuous scores representing a phenotypic
#' readout of interest such as protein expression, pathway activity, etc.
#' The \code{input_score} object must have names or labels that match the column
#' names of \code{FS} object.
#' @param meta_feature a vector of one or more features representing known 
#' causes of activation or features associated with a response of interest 
#' (\code{e.g. input_score}). Default is NULL.
#' @param custom_function a customized function which computes a row-wise 
#' score for each row of a given binary feature set (FS).
#' 
#' NOTE: \code{custom_function()} must take \code{FS} and \code{input_score} as 
#' its input arguments, and its final result must return a vector of row-wise 
#' scores ordered from most significant to least significant where its labels 
#' or names matched the row names of FS object.
#' @param custom_parameters a list of additional arguments to be passed to  
#' \code{custom_function()} (excluding \code{FS} and \code{input_score}).
#' Default is NULL.
#' @param ... additional parameters to be passed to \code{custom_function}
#' 
#' @noRd
#' 
#' @examples 
#' 
#' # A customized function using ks-test function
#' customized_ks_rowscore <- function(FS, input_score, meta_feature=NULL, alternative="less"){
#'   
#'   # Check if meta_feature is provided
#'   if(!is.null(meta_feature)){
#'     # Getting the position of the known meta features
#'     locs <- match(meta_feature, row.names(FS))
#'
#'     # Taking the union across the known meta features
#'     if(length(locs) > 1) {
#'       meta_vector <- as.numeric(ifelse(colSums(FS[locs,]) == 0, 0, 1))
#'     }else{
#'       meta_vector <- as.numeric(FS[locs,])
#'     }
#'      
#'     # Remove the meta features from the binary feature matrix
#'     # and taking logical OR btw the remaining features with the meta vector
#'     FS <- base::sweep(FS[-locs,], 2, meta_vector, `|`)*1
#'      
#'     # Check if there are any features that are all 1s generated from
#'     # taking the union between the matrix
#'     # We cannot compute statistics for such features and thus they need
#'     # to be filtered out
#'     if(any(rowSums(FS) == ncol(FS))){
#'       warning("Features with all 1s generated from taking the matrix union ",
#'               "will be removed before progressing...\n")
#'       FS <- FS[rowSums(FS) != ncol(FS), , drop=FALSE]
#'     }
#'   }
#'    
#'   # KS is a ranked-based method
#'   # So we need to sort input_score from highest to lowest values
#'   input_score <- sort(input_score, decreasing=TRUE)
#'    
#'   # Re-order the matrix based on the order of input_score
#'   FS <- FS[, names(input_score), drop=FALSE]  
#'   
#'   # Compute the scores using the KS method
#'   ks <- apply(FS, 1, function(r){ 
#'     x = input_score[which(r==1)]; 
#'     y = input_score[which(r==0)];
#'     res <- ks.test(x, y, alternative=alternative)
#'     return(c(res$statistic, res$p.value))
#'   })
#'   
#'   # Obtain score statistics
#'   stat <- ks[1,]
#'   
#'   # Obtain p-values and change values of 0 to the machine lowest value 
#'   # to avoid taking -log(0)
#'   pval <- ks[2,]
#'   pval[which(pval == 0)] <- .Machine$double.xmin
#'   
#'   # Compute the -log(pval)
#'   # Make sure scores has names that match the row names of FS object
#'   scores <- -log(pval)
#'   names(scores) <- rownames(FS)
#'   
#'   return(scores)
#'   
#' }
#' 
#' mat <- matrix(c(1,0,1,0,0,0,0,0,1,0, 
#'                 0,0,1,0,1,0,1,0,0,0,
#'                 0,0,0,0,1,0,1,0,1,0), nrow=3)
#' 
#' colnames(mat) <- 1:10
#' row.names(mat) <- c("TP_1", "TP_2", "TP_3")
#' 
#' set.seed(42)
#' input_score = rnorm(n = ncol(mat))
#' names(input_score) <- colnames(mat)
#'
#' # Search for best features using a custom-defined function
#' custom_rs <- custom_rowscore(
#'   FS = mat,
#'   input_score = input_score,
#'   meta_feature = NULL,
#'   custom_function = customized_ks_rowscore,            
#'   custom_parameters = NULL  
#' )
#' 
#' @return return a vector of row-wise positive scores where its labels or names 
#' must match the row names of \code{FS} object
#' 
custom_rowscore <- function
(
  FS,
  input_score,
  meta_feature = NULL,
  custom_function,
  custom_parameters = NULL,
  ...
)
{
  
  # Check if the custom_function is indeed a function
  if(!is.function(custom_function))
    stop("custom_function must be a function.")
  
  # If custom_parameters is provided, check if it is a list and 
  # has labels or names that associated with each of its value
  # e.g. custom_parameters = list(alternative = 'less')
  if((!is.null(custom_parameters) && !is.list(custom_parameters)) || 
     (!is.null(custom_parameters) && is.list(custom_parameters) && 
      is.null(names(custom_parameters))))    
    stop("custom_parameters must be a list with labels or names ",
         "that attach to each of its values. \nFor example: ",
         "custom_parameters = list(alternative = 'less')")
  
  # Extract all formal arguments required by custom_function()
  custom_args <- formals(custom_function)
  
  # Check if custom_function() requires 'FS' as its argument
  if(!"FS" %in% names(custom_args))
    stop("custom_function() must take 'FS'as ",
         "one of its arguments (required).")
  
  # Check if custom_function() requires 'input_score' as its argument
  if(!"input_score" %in% names(custom_args))
    stop("custom_function() must take 'input_score' ",
         "as one of its arguments (required).")
  
  # Check if custom_function() requires 'meta_feature' as its argument
  if(!"meta_feature" %in% names(custom_args))
    stop("custom_function() must take 'meta_feature' ",
         "as one of its arguments (required).")
  
  ## Create a list with only the required variables 
  req_parameters <- list(FS=FS, input_score=input_score, meta_feature=meta_feature)
  
  # Obtain additional parameters
  additional_parameters <- list(...)
  
  # Combine custom_parameters, required variables, and a list of 
  # known parameters together 
  # However, we must exclude FS, input_score from custom_parameters 
  # excluding FS, input_score, and custom_parameters from known parameters 
  # as they would be redundant
  combined_parameters <- c(
    req_parameters, 
    custom_parameters[
      which(!names(custom_parameters) %in% names(req_parameters))],
    additional_parameters[
      which(!names(additional_parameters) %in% c(names(req_parameters), 
                                            names(custom_parameters)))]
  )
  
  # Extract a list of custom_function() parameters that existed in 
  # combined variables
  included_parameters <- combined_parameters[
    which(names(combined_parameters) %in% names(custom_args))] 
  
  # Check if some parameters not existed in a list of combined variables
  excluded_parameters <- custom_args[
    which(!names(custom_args) %in% names(combined_parameters))]
  
  # If some parameters are excluded, 
  # check to see if that argument has a default value
  # Finally, return all necessarily arguments to be passed to custom_function()
  all_parameters <- c(
    included_parameters, 
    lapply(seq_along(excluded_parameters), function(s){
      #s=2;
      if(!is.null(excluded_parameters[[s]]) && excluded_parameters[[s]] == "")
        stop("argument '", names(excluded_parameters)[s], 
             "' is missing from custom_function() with no default value") 
      else
        return(excluded_parameters[s])
    }) |> unlist())
  
  ## Check if the function runs with no errors
  custom <- tryCatch({
    base::do.call(custom_function, all_parameters)
  }, error = function(err){
    stop(err)
  })

  # Make sure custom_function() returns a vector of scores with no NAs
  # where it has labels or feature names that match the row names of FS 
  # (or FS) object
  if(length(custom) == 0 || any(!is.numeric(custom)) || any(is.na(custom)) || 
     is.null(names(custom)) || any(!names(custom) %in% rownames(FS)))
    stop("The custom_function must return a vector of continuous scores ",
         "(with no NAs) where its feature names or labels must match ",
         "the row names of FS object.\n")
  
  return(custom)
  
}

test_that("custom_rowscore returns correct results", {
  
  mat <- matrix(c(1,0,1,0,0,0,0,0,1,0, 
                  0,0,1,0,1,0,1,0,0,0,
                  0,0,0,0,1,0,1,0,1,0), nrow=3)
  
  colnames(mat) <- 1:10
  row.names(mat) <- c("TP_1", "TP_2", "TP_3")
  
  set.seed(42)
  input_score = rnorm(n = ncol(mat))
  names(input_score) <- colnames(mat)
  custom_function <- wilcox_rowscore
  
  result <- custom_rowscore(
    FS = mat, 
    input_score = input_score,
    meta_feature = NULL,
    custom_function = wilcox_rowscore,
    custom_parameters = list(alternative="less")
  )
  
  testthat::expect_length(result, 3L)
  testthat::expect_type(result, "double")
  testthat::expect_identical(result, c(TP_1=3, TP_2=13, TP_3=5))
  
})

## --------------------------------------------------- ##
test_that("custom_rowscore issues error messages when needed", {
  
  mat <- matrix(c(1,0,1,0,0,0,0,0,1,0, 
                  0,0,1,0,1,0,1,0,0,0,
                  0,0,0,0,1,0,1,0,1,0), nrow=3)
  
  colnames(mat) <- 1:10
  row.names(mat) <- c("TP_1", "TP_2", "TP_3")
  
  set.seed(42)
  input_score = rnorm(n = ncol(mat))
  names(input_score) <- colnames(mat)
  custom_function <- wilcox_rowscore

  # error if custom function is not given 
  expect_error( 
    custom_rowscore(
      FS = mat, 
      input_score = input_score,
      meta_feature = NULL,
      custom_function = "wilcox_rowscore",
      method = "custom_pval", 
      custom_parameters = list(alternative="less") 
    )
  )
  
  # error if custom parameters are not given in a list
  expect_error( 
    custom_rowscore(
      FS = mat, 
      input_score = input_score,
      meta_feature = NULL,
      custom_function = custom_function,
      method = "custom_pval", 
      custom_parameters = c(alternative="less")
    )
  )
  
  # error if function does not have "input_score" and "meta_feature" arguments
  err_function <- function(FS){ return(0) }
  expect_error( 
    custom_rowscore(
      FS = mat, 
      input_score = input_score,
      meta_feature = NULL,
      custom_function = err_function,
      method = "custom_pval"
    )
  )
  
  # error if function does not have "FS" and "meta_feature" arguments
  err_function <- function(input_score){ return(0) }
  expect_error( 
    custom_rowscore(
      FS = mat, 
      input_score = input_score,
      meta_feature = NULL,
      custom_function = err_function,
      method = "custom_pval"
    )
  )
  
})

#'
#' Kolmogorov-Smirnov Scoring Method
#'
#' Compute directional KS scores for each row of a given binary feature matrix
#'
#' @param FS a matrix of binary features where 
#' rows represent features of interest (e.g. genes, transcripts, exons, etc...)
#' and columns represent the samples.
#' @param input_score a vector of continuous scores representing a phenotypic
#' readout of interest such as protein expression, pathway activity, etc.
#' The \code{input_score} object must have names or labels that match the column
#' names of FS object.
#' @param meta_feature a vector of one or more features representing known causes
#' of activation or features associated with a response of interest
#' (\code{e.g. input_score}). Default is NULL.
#' @param weights a vector of weights to perform a \code{weighted-KS} test.
#' Default is \code{NULL}. If not NULL, \code{weights} must have labels or names
#' that match names or labels of \code{input_score}.
#' @param alternative a character string specifies an alternative hypothesis
#' testing (\code{"two.sided"} or \code{"greater"} or \code{"less"}).
#' Default is \code{less} for left-skewed significance testing.
#' @param metric a character string specifies a metric to search for 
#' best features. \code{"pval"} or \code{"stat"} may be used which is 
#' corresponding to p-value or score statistic. Default is \code{pval}. 
#' 
#' @noRd
#' 
#' @useDynLib CaDrA ks_genescore_mat_
#' 
#' @examples 
#' 
#' mat <- matrix(c(1,0,1,0,0,0,0,0,1,0, 
#'                 0,0,1,0,1,0,1,0,0,0,
#'                 0,0,0,0,1,0,1,0,1,0), nrow=3)
#'
#' colnames(mat) <- 1:10
#' row.names(mat) <- c("TP_1", "TP_2", "TP_3")
#'
#' set.seed(42)
#' input_score = rnorm(n = ncol(mat))
#' names(input_score) <- colnames(mat)
#' 
#' ks_rs <- ks_rowscore(
#'    FS = mat,
#'    input_score = input_score,
#'    meta_feature = NULL,
#'    weights = NULL,
#'    alternative = "less",
#'    metric = "pval"
#' )
#'
#' @return return a vector of row-wise scores where its labels or names 
#' must match the row names of \code{FS} object
ks_rowscore <- function
(
  FS,
  input_score,
  meta_feature = NULL,
  weights = NULL,
  alternative = c("less", "greater", "two.sided"),
  metric = c("stat", "pval")
)
{

  metric <- match.arg(metric)
  alternative <- match.arg(alternative)
  
  # Check if meta_feature is provided
  if(!is.null(meta_feature)){
    # Getting the position of the known meta features
    locs <- match(meta_feature, row.names(FS))
    
    # Taking the union across the known meta features
    if(length(locs) > 1) {
      meta_vector <- as.numeric(ifelse(colSums(FS[locs,]) == 0, 0, 1))
    }else{
      meta_vector <- as.numeric(FS[locs, , drop=FALSE])
    }
    
    # Remove the meta features from the binary feature matrix
    # and taking logical OR btw the remaining features with the meta vector
    FS <- base::sweep(FS[-locs, , drop=FALSE], 2, meta_vector, `|`)*1
    
    # Check if there are any features that are all 1s generated from
    # taking the union between the matrix
    # We cannot compute statistics for such features and thus they need
    # to be filtered out
    if(any(rowSums(FS) == ncol(FS))){
      verbose("Features with all 1s generated from taking the matrix union ",
              "will be removed before progressing...\n")
      FS <- FS[rowSums(FS) != ncol(FS), , drop=FALSE]
      # If no features remained after filtering, exist the function
      if(nrow(FS) == 0) return(NULL)
    }
  }
    
  # KS is a ranked-based method
  # So we need to sort input_score from highest to lowest values
  input_score <- sort(input_score, decreasing=TRUE)
  
  # Re-order the matrix based on the order of input_score
  FS <- FS[, names(input_score), drop=FALSE]  
  
  # Check if weights is provided
  if(length(weights) > 0){
    # Check if weights has any labels or names
    if(is.null(names(weights)))
      stop("The weights object must have names or labels that ",
           "match the labels of input_score\n")

    # Make sure its labels or names match the
    # the labels of input_score 
    weights <- as.numeric(weights[names(input_score)])
  }

  # Get the alternative hypothesis testing method
  alt_int <- switch(alternative, two.sided=0L, less=1L, greater=-1L, 1L)

  # Compute the ks statistic and p-value per row in the matrix
  ks <- .Call(ks_genescore_mat_, FS, weights, alt_int)

  # Obtain score statistics from KS method
  # Change values of 0 to the machine lowest value to avoid taking -log(0)
  stat <- ks[1,]

  # Obtain p-values from KS method
  # Change values of 0 to the machine lowest value to avoid taking -log(0)
  pval <- ks[2,]
  pval[which(pval == 0)] <- .Machine$double.xmin
  
  # Compute the scores according to the provided metric
  scores <- ifelse(rep(metric, nrow(FS)) %in% "pval", -log(pval), stat)
  names(scores) <- rownames(FS)

  return(scores)
  
}


#' Compute KS scores for each row of a given matrix
#'
#' Compute directional Kolmogorov-Smirnov scores for each row of a
#' given binary matrix
#' @param mat matrix of binary features to compute row-wise ks scores for
#' @param alt an integer value specifying the alternative hypothesis
#' (\code{"two.sided"} or \code{"greater"} or \code{"less"}).
#' Default is \code{less} for left-skewed significance testing.
#' @param weights a vector of weights to use if performing a weighted-KS test
#' 
#' @noRd
#' @useDynLib CaDrA ks_genescore_mat_
#'
#' @return Two lists: score and p-value
ks_rowscore_calc <- function(
    mat,
    alt = c("less", "greater", "two.sided"),
    weights
){

  if(!is.matrix(mat))
    stop("Input argument to ks_gene_score_mat function is not a matrix")

  if(length(alt) > 0){
    alt_int<- switch(alt, two.sided=0L, less=1L, greater=-1L, 1L)
  } else {
    alt_int <- 1L
  }

  # Ensure the right type of input
  mat.num <- matrix(as.numeric(mat), ncol=ncol(mat), nrow=nrow(mat))
  weights <- if( length(weights) > 1 ) as.numeric(weights)
  res <- .Call(ks_genescore_mat_, mat.num, weights, alt_int)
  res

}



#' ks_genescore wrapper
#'
#' Compute directional Kolmogorov-Smirnov scores for each row of a given vector
#' @param n_x length of ranked list
#' @param y positions of geneset items in ranked list (ranks)
#' @param weights a vector of weights
#' @param alt alternative hypothesis for p-value calculation
#' (\code{"two.sided"} or \code{"greater"} or \code{"less"}).
#' Default is \code{less} for left-skewed significance testing.
#' 
#' @noRd
#' @useDynLib CaDrA ks_genescore_wrap_
#'
#' @return a numeric vector of length 2 with 2 values: score and p-value
ks_genescore_wrap <- function(
    n_x, 
    y, 
    weights,
    alt = c("less", "greater", "two.sided")
){
  
  if(length(alt) > 0){
    alt_int<- switch(alt, two.sided=0L, less=1L, greater=-1L, 1L)
  } else {
    alt_int <- 1L
  }
  
  # Ensure the right type of input
  y <- as.integer(y)
  n_x <- as.integer(n_x)
  if(length(weights) > 1) weights <- as.numeric(weights)
  res <- .Call(ks_genescore_wrap_, n_x, y, weights, alt_int)
  res
  
}

test_that("ks_rowscore returns correct results", {
  
  mat <- matrix(c(1,0,1,0,0,0,0,0,1,0, 
                  0,0,1,0,1,0,1,0,0,0,
                  0,0,0,0,1,0,1,0,1,0), nrow=3)
  
  colnames(mat) <- 1:10
  row.names(mat) <- c("TP_1", "TP_2", "TP_3")
  
  set.seed(42)
  input_score = rnorm(n = ncol(mat))
  names(input_score) <- colnames(mat)
  
  result <- ks_rowscore(
    FS = mat, 
    input_score = input_score, 
    meta_feature = NULL,
    weights = NULL,
    alternative = "less"
  )
  
  testthat::expect_length(result, 3L)
  testthat::expect_type(result, "double")
  testthat::expect_equal(result, c(TP_1=0.5,TP_2=-0.6,TP_3=0.4))
  
  weights <- c(0.5, 0.75, 0.25, 1, 0.5, 0.25, 0.75, 0.5, 0.5, 0 )
  names(weights) <- colnames(mat)
  result <- ks_rowscore(
    FS = mat,  
    input_score = input_score,
    meta_feature = NULL,
    weights = weights
  )
  
  testthat::expect_length(result, 3L)
  testthat::expect_type(result, "double")
  testthat::expect_named(result, c("TP_1", "TP_2", "TP_3"))
  testthat::expect_equal(round(result,7), 
                         c(TP_1=0.7142857, TP_2=0.8750000, TP_3=0.6666667))
  
})

## --------------------------------------------------- ##
test_that("ks_rowscore issues error messages when needed", {
  
  FS <-  data.frame(a = rnorm(10), b = rnorm (10))
  set.seed(42)
  input_score <- rnorm(n = ncol(FS))
  names(input_score) <- colnames(FS)
  
  expect_error( 
    ks_rowscore(
      FS = FS,  
      input_score = input_score,
      meta_feature = NULL,
      weights = NULL
    )
  )
  
  mat <- matrix(c(1,0,1,0,0,0,0,0,1,0, 
                  0,0,1,0,1,0,1,0,0,0,
                  0,0,0,0,1,0,1,0,1,0), nrow=3)
  
  colnames(mat) <- paste0("COL_", 1:10)
  
  set.seed(42)
  input_score <- rnorm(n = ncol(mat))
  names(input_score) <- colnames(mat)
  weights <- runif(n = ncol(mat))
  
  expect_error( 
    ks_rowscore(
      FS = mat,  
      input_score = input_score,
      meta_feature = NULL,
      weights = weights
    )
  )
  
})

#' Genomic Data from CCLE MUT + SCNA
#'
#' A SummarizedExperiment object consists of 17,724 genomic features across 
#' 82 samples.
#'
#' @docType data
#'
#' @usage data(CCLE_MUT_SCNA)
#'
#' @format An object of class \code{SummarizedExperiment} from 
#' \code{SummarizedExperiment} package
#' containing a matrix of 17,724 rows (features) and 82 columns (samples).
#' See \code{SummarizedExperiment} for more details.
#' 
#' @return a SummarizedExperiment object
#' 
#' @references Kim, J., Botvinnik, O., Abudayyeh, O. et al.
#' Characterizing genomic alterations in cancer by complementary functional
#' associations. Nat Biotechnol 34, 539–546 (2016).
#' \href{https://doi.org/10.1038/nbt.3527}{https://doi.org/10.1038/nbt.3527}
#'
"CCLE_MUT_SCNA"

#' Pre-computed permutation results for simulated data (\code{sim_FS}) 
#'
#' The permutation result returned from \code{CaDrA} 
#' using pre-simulated dataset
#' (\code{FS = sim_FS}), pre-simulated input scores 
#' (\code{input_score = sim_Scores}), 
#' \code{top_N = 7}, \code{method = "ks_pval"}, \code{alternative = "less"}, 
#' \code{search_method = "both"}, \code{max_size = 10},
#' \code{obs_best_score = NULL} and \code{n_perm = 1000} 
#' as inputs to the function.
#'
#' @docType data
#'
#' @usage data(perm_res)
#'
#' @format A list of objects returned from \code{CaDrA} function. The resulting 
#' object contains a list of key parameters that was used to run the
#' permutation-based testing, a vector of permuted best scores for 
#' a given n_perm, an observed best score, and a permuted p-value.
#'
#' To visualize the Empirical Null Distribution of the permuted best scores over 
#' n_perm iterations, just pass the resulting list to \code{permutation_plot}.
#' 
#' See \code{permutation_plot} for more details.
#'
#' @return a list of objects returned from \code{CaDrA} function
#'
#' @references Kartha VK, Kern JG, Sebastiani P, Zhang L,
#' Varelas X, Monti S (2017) CaDrA: A computational framework for performing
#' candidate driver analyses using binary genomic features.
#' (\href{https://www.frontiersin.org/articles/10.3389/fgene.2019.00121/full}{Frontiers in Genetics})
#'
#' @examples
#'
#' # Load the pre-computed permutation results for sim_FS
#' data(perm_res)
#'
#' # Plot the Empirical Null Distribution of the permuted best scores
#' # against its observed best score
#' permutation_plot(perm_res = perm_res)
#'
"perm_res"

#'
#' REVEALER Scoring Method
#'
#' Compute conditional mutual information of \code{x} and \code{y}
#' given \code{z} for each row of a given binary feature matrix
#' @param FS a matrix of binary features where rows represent features of 
#' interest (e.g. genes, transcripts, exons, etc...) and columns represent 
#' the samples.
#' @param input_score a vector of continuous scores representing a phenotypic
#' readout of interest such as protein expression, pathway activity, etc.
#' The \code{input_score} object must have names or labels that match the column
#' names of FS object.
#' @param meta_feature a vector of one or more features representing known 
#' causes of activation or features associated with a response of interest 
#' (\code{e.g. input_score}). Default is NULL.
#' @param assoc_metric an association metric: \code{"IC"} for information
#' coefficient or \code{"COR"} for correlation. Default is \code{IC}.
#' 
#' @noRd
#' 
#' @examples 
#'  
#' mat <- matrix(c(1,0,1,0,0,0,0,0,1,0, 
#'                 0,0,1,0,1,0,1,0,0,0,
#'                 0,0,0,0,1,0,1,0,1,0), nrow=3)
#' 
#' colnames(mat) <- 1:10
#' row.names(mat) <- c("TP_1", "TP_2", "TP_3")
#' 
#' set.seed(42)
#' input_score = rnorm(n = ncol(mat))
#' names(input_score) <- colnames(mat)
#' 
#' revealer_rs <- revealer_rowscore(
#'   FS = mat, 
#'   input_score = input_score, 
#'   assoc_metric = "IC"
#' )
#' 
#' @return return a vector of row-wise scores where its labels or names 
#' must match the row names of \code{FS} object
#' 
revealer_rowscore <- function(
    FS,
    input_score,
    meta_feature = NULL,
    assoc_metric = c("IC", "COR")
) {
  assoc_metric <- match.arg(assoc_metric)

  # Check if meta_feature is provided
  if (is.null(meta_feature)) {
    meta_vector <- as.vector(rep(0, ncol(FS)))
  } else {
    # Getting the position of the known meta features
    locs <- match(meta_feature, row.names(FS))
    # Taking the union across the known meta features
    if (length(locs) > 1) {
      meta_vector <- as.numeric(ifelse(colSums(FS[locs, ]) == 0, 0, 1))
    } else {
      meta_vector <- as.numeric(FS[locs, ])
    }
    names(meta_vector) <- names(input_score)
    # Remove the seeds from the binary feature matrix
    FS <- FS[-locs, , drop = FALSE]
  }
  # Assume the score direction is always positive
  # So we need to sort input_score from highest to lowest values
  input_score <- sort(input_score, decreasing = TRUE)

  # Re-order the matrix based on the order of input_score
  FS <- FS[, names(input_score), drop = FALSE]

  # Compute CMI given known seed features
  cmi_1 <- apply(X = FS, MARGIN = 1, function(x) {
    revealer_score(
      x = input_score,
      y = x,
      z = meta_vector,
      assoc_metric = assoc_metric
    )
  })
  names(cmi_1) <- rownames(FS)

  return(cmi_1)
}

#' Compute Conditional Mutual Information of x and y given z from 
#' \code{REVEALER}
#'
#' @param x a vector of continuous values of
#' a given functional response of interest
#' @param y a binary present/absent feature typically representing
#' genome-wide alterations (mutations, cnvs, amplifications/deletions)
#' @param z a consolidated or summarized vector of values obtained from
#' one or more binary features(s) which representing known “causes”
#' of activation or features associated with a given response of interest
#' @param assoc_metric an association metric: information coefficient
#' (\code{"IC"} by default) or correlation (\code{"COR"}) from \code{REVEALER}.
#'
#' @noRd
#' 
#' @return a score statistics value
#'
#' @importFrom MASS kde2d bcv
#' @importFrom misc3d kde3d
#' @importFrom stats cor median sd
#' @importFrom ppcor pcor.test
revealer_score <- function(
    x, y, z,
    assoc_metric = c("IC", "COR")
) {
  assoc_metric <- match.arg(assoc_metric)

  # Compute CMI
  cmi <- suppressWarnings(
    cond_assoc(x = x, y = y, z = z, metric = assoc_metric)
  )
  # Revealer only returns score statistics value
  return(c(score = cmi))
}

# Compute the conditional mutual information of x and y given z
cond_assoc <- function(x, y, z, metric) {
  # Association of x and y given z
  #
  # Conditional mutual information I(x, y | z)

  if (length(unique(x)) == 1 || length(unique(y)) == 1) {
    return(0)
  }
  if (length(unique(z)) == 1) { # e.g. for NULLSEED
    if (metric == "IC") {
      return(mutual_inf_v2(x = x, y = y, n.grid = 25)$IC)
    } else if (metric == "COR") {
      return(cor(x, y))
    }
  } else {
    if (metric == "IC") {
      return(cond_mutual_inf(x = x, y = y, z = z, n.grid = 25)$CIC)
    } else if (metric == "COR") {
      return(pcor.test(x, y, z)$estimate)
    }
  }
}

# Computes the conditional mutual information x, y | z
cond_mutual_inf <- function(
    x, y, z,
    n.grid = 25,
    delta = 0.25 * c(
      MASS::bcv(x), MASS::bcv(y),
      MASS::bcv(z))
) {
  # Computes the Conditional mutual information:
  # I(X, Y | X) = H(X, Z) + H(Y, Z) - H(X, Y, Z) - H(Z)
  # The 0.25 in front of the bandwidth is because different conventions
  # between bcv and kde3d

  # Compute correlation-dependent bandwidth

  rho <- cor(x, y)
  rho2 <- ifelse(rho < 0, 0, rho)
  delta <- delta * (1 + (-0.75) * rho2)

  # Kernel-based prob. density

  kde3d.xyz <- misc3d::kde3d(x = x, y = y, z = z, h = delta, n = n.grid)
  X <- kde3d.xyz$x
  Y <- kde3d.xyz$y
  Z <- kde3d.xyz$z
  PXYZ <- kde3d.xyz$d + .Machine$double.eps
  dx <- X[2] - X[1]
  dy <- Y[2] - Y[1]
  dz <- Z[2] - Z[1]

  # Normalize density and calculate marginal densities and entropies

  PXYZ <- PXYZ / (sum(PXYZ) * dx * dy * dz)
  PXZ <- colSums(aperm(PXYZ, c(2, 1, 3))) * dy
  PYZ <- colSums(PXYZ) * dx
  PZ <- rowSums(aperm(PXYZ, c(3, 1, 2))) * dx * dy
  PXY <- colSums(aperm(PXYZ, c(3, 1, 2))) * dz
  PX <- rowSums(PXYZ) * dy * dz
  PY <- rowSums(aperm(PXYZ, c(2, 1, 3))) * dx * dz

  HXYZ <- -sum(PXYZ * log(PXYZ)) * dx * dy * dz
  HXZ <- -sum(PXZ * log(PXZ)) * dx * dz
  HYZ <- -sum(PYZ * log(PYZ)) * dy * dz
  HZ <- -sum(PZ * log(PZ)) * dz
  HXY <- -sum(PXY * log(PXY)) * dx * dy
  HX <- -sum(PX * log(PX)) * dx
  HY <- -sum(PY * log(PY)) * dy

  MI <- HX + HY - HXY
  CMI <- HXZ + HYZ - HXYZ - HZ

  SMI <- sign(rho) * MI
  SCMI <- sign(rho) * CMI

  IC <- sign(rho) * sqrt(1 - exp(-2 * MI))
  CIC <- sign(rho) * sqrt(1 - exp(-2 * CMI))

  return(list(
    CMI = CMI, MI = MI,
    SCMI = SCMI, SMI = SMI,
    HXY = HXY, HXYZ = HXYZ,
    IC = IC, CIC = CIC
  ))
}

# Computes the Mutual Information/Information Coefficient IC(x, y)
mutual_inf_v2 <- function(
    x, y, n.grid = 25,
    delta = c(MASS::bcv(x), MASS::bcv(y))
) {
  # Computes the Mutual Information/Information Coefficient IC(x, y)
  #
  # Compute correlation-dependent bandwidth

  rho <- cor(x, y)
  rho2 <- abs(rho)
  delta <- delta * (1 + (-0.75) * rho2)

  # Kernel-based prob. density

  kde2d.xy <- MASS::kde2d(x, y, n = n.grid, h = delta)

  FXY <- kde2d.xy$z + .Machine$double.eps
  dx <- kde2d.xy$x[2] - kde2d.xy$x[1]
  dy <- kde2d.xy$y[2] - kde2d.xy$y[1]
  PXY <- FXY / (sum(FXY) * dx * dy)
  PX <- rowSums(PXY) * dy
  PY <- colSums(PXY) * dx
  HXY <- -sum(PXY * log(PXY)) * dx * dy
  HX <- -sum(PX * log(PX)) * dx
  HY <- -sum(PY * log(PY)) * dy

  PX <- matrix(PX, nrow = n.grid, ncol = n.grid)
  PY <- matrix(PY, byrow = TRUE, nrow = n.grid, ncol = n.grid)

  MI <- sum(PXY * log(PXY / (PX * PY))) * dx * dy
  rho <- cor(x, y)
  SMI <- sign(rho) * MI

  # Use pearson correlation the get the sign (directionality)

  IC <- sign(rho) * sqrt(1 - exp(-2 * MI))

  NMI <- sign(rho) * ((HX + HY) / HXY - 1)

  return(list(MI = MI, SMI = SMI, HXY = HXY, HX = HX, HY = HY, NMI = NMI, IC = IC))
}

test_that("revealer_rowscore returns correct results", {
  
  mat <- matrix(c(1,0,1,0,0,0,0,0,1,0, 
                  0,0,1,0,1,0,1,0,0,0,
                  0,0,0,0,1,0,1,0,1,0), nrow=3)
  
  colnames(mat) <- 1:10
  row.names(mat) <- c("TP_1", "TP_2", "TP_3")
  
  # Set seed
  set.seed(42)
  
  input_score = rnorm(n = ncol(mat))
  names(input_score) <- colnames(mat)
  
  result <- revealer_rowscore(
    FS = mat, 
    input_score = input_score, 
    meta_feature = NULL,
    assoc_metric = "IC"
  )
  
  testthat::expect_length(result, 3L)
  testthat::expect_type(result, "double")
  testthat::expect_identical(sort(names(result)), sort(row.names(mat)))
  testthat::expect_equal(round(result, 7), 
                         c(TP_1=0.4573207, TP_2=-0.4266714, TP_3=0.3867053))
  
  result <- revealer_rowscore(
    FS = mat, 
    input_score = input_score, 
    meta_feature = NULL,
    assoc_metric = "COR"
  )
  
  testthat::expect_length(result, 3L)
  testthat::expect_type(result, "double")
  testthat::expect_identical(sort(names(result)), sort(row.names(mat)))
  testthat::expect_equal(round(result, 7), 
                         c(TP_1=0.5924383, TP_2=-0.3985206, TP_3=0.5067436))
  
})

## --------------------------------------------------- ##
test_that("revealer_score returns correct results", {
  
  # Set seed
  set.seed(42)
  
  input_score <- rnorm(n = 10)
  x <- c(1,0,1,0,0,0,0,0,1,0)
  meta_vector <- rep(0, 10)
    
  result <- revealer_score(
    x = input_score,
    y = x,
    z = meta_vector,
    assoc_metric = "IC"
  )
  
  testthat::expect_type(result, "double")
  testthat::expect_named(result, "score")
  testthat::expect_equal(round(result, 7), c(score=0.4400776) )
  
})

## --------------------------------------------------- ##
test_that("cond_assoc returns correct results", {
  
  # Set seed
  set.seed(42)

  result <- suppressWarnings(
    cond_assoc(
      x = rnorm(n = 10),
      y = c(1,0,1,0,0,0,0,0,1,0),
      z = rep(0, 10),
      metric = "IC"
    )
  )
  
  testthat::expect_type(result, "double")
  testthat::expect_equal(round(result, 7), c(0.4400776) )
  
})
  

## --------------------------------------------------- ##
test_that("mutual_inf_v2 returns correct results", {
  
  # Set seed
  set.seed(42)
  
  x <- rnorm(n = 10)
  y <- x + rnorm(n = 10, 0, 0.01)
  
  result <- suppressWarnings(
    mutual_inf_v2(
      x = x,
      y = y
    )
  )
  
  testthat::expect_type(result, "list")
  testthat::expect_named(result, 
                         c("MI", "SMI", "HXY", "HX", "HY", "NMI", "IC") )
  
  testthat::expect_equal(round(result$MI, 5), 1.11879 )
  testthat::expect_equal(round(result$SMI, 5), 1.11879 )
  testthat::expect_equal(round(result$HXY, 5), 0.42585 )
  testthat::expect_equal(round(result$HX, 6), 0.779993 )
  testthat::expect_equal(round(result$HY, 7), 0.7646444 )
  testthat::expect_equal(round(result$NMI, 6), 2.627207 )
  testthat::expect_equal(round(result$IC, 6),  0.945137 )
  
})

# Function to whether print diagnostic messages or not
verbose <- function(...){

  # Fetch verbose option set in candidate_search() function
  opt <- getOption("verbose", FALSE)
  if(!opt) return(invisible(NULL))
  msgs <- list(...)
  message(msgs,"\n")

}

#' Pre-filter features
#'
#' Pre-filter a dataset prior running \code{candidate_search} to avoid
#' testing features that are too prevalent or too sparse across samples in
#' the dataset
#' @param FS a matrix of binary features or a SummarizedExperiment class object 
#' from SummarizedExperiment package where rows represent features of interest 
#' (e.g. genes, transcripts, exons, etc...) and columns represent the samples. 
#' The assay of FS contains binary (1/0) values indicating the presence/absence 
#' of ‘omics’ features.
#' @param max_cutoff a numeric value between 0 and 1 describing the absolute
#' prevalence of a feature across all samples in the FS object which the
#' feature will be filtered out. Default is 0.6 (feature that occur in
#' 60 percent or more of the samples will be removed)
#' @param min_cutoff a numeric value between 0 and 1 describing the absolute
#' prevalence of a feature across all samples in the FS object which the
#' feature will be filtered out. Default is 0.03 (feature that occur in
#' 3 percent or less of the samples will be removed)
#' @param verbose a logical value indicates whether or not to print the
#' diagnostic messages. Default is \code{FALSE}.
#' 
#' @return A SummarizedExperiment object with only the filtered-in features
#' given the filtered thresholds
#' 
#' @examples
#'
#' # Load pre-computed feature set
#' data(sim_FS)
#'
#' # Filter out features having < 3% and > 60% prevalence across all samples
#' # by (default)
#' sim_FS_filt1 <- prefilter_data(FS = sim_FS)
#'
#' # Change the min cut-off to 1% prevalence, instead of the default of 3%
#' sim_FS_filt2 <- prefilter_data(FS = sim_FS, min_cutoff  = 0.01)
#'
#' # Change the max cut-off to 65% prevalence, instead of the default of 60%
#' sim_FS_filt3 <- prefilter_data(FS = sim_FS, max_cutoff = 0.65)
#'
#' @export
#' @import SummarizedExperiment
prefilter_data <- function(
    FS,
    max_cutoff = 0.6,
    min_cutoff = 0.03,
    verbose = FALSE
){

  # Set up verbose option
  options(verbose = verbose)
  
  # Check if FS is a matrix or a SummarizedExperiment class object
  if(!is(FS, "SummarizedExperiment") && !is(FS, "matrix"))
    stop("'FS' must be a matrix or a SummarizedExperiment class object
         from SummarizedExperiment package")
  
  # Retrieve the binary feature matrix
  if(is(FS, "SummarizedExperiment")){
    FS_mat <- SummarizedExperiment::assay(FS)
  }else{
    FS_mat <- FS
  }
  
  # Check if FS must contain at least one row feature with binary values 0s or 1s
  if(nrow(FS_mat) == 0 || any(!FS_mat %in% c(0,1)))
    stop("FS object must contain at least one row feature with 
         binary values 0s or 1s.")
  
  # Compute the frequency of feature occurrence across all samples
  # (i.e. fraction of samples having the feature)
  frac <- round(rowSums(FS_mat)/ncol(FS_mat), 2)
  
  verbose("Pre-filtering features...\n")
  verbose("Removing features having < ", min_cutoff*100, "% and > ",
          max_cutoff*100, "% occurence in sample set\n")
  
  FS_mat <- FS_mat[(frac >= min_cutoff) & (frac <= max_cutoff), , drop=FALSE]
  
  if(nrow(FS_mat) > 0){
    verbose(nrow(FS_mat), " features retained out of ", length(frac),
            " supplied features in the FS object\n")
    # If the class of FS is originally a SummarizedExperiment object
    # Convert the matrix to SummarizedExperiment
    # This makes sure the original class of FS object does not change 
    if(is(FS, "SummarizedExperiment")){
      FS_mat <- SummarizedExperiment::SummarizedExperiment(assays=FS_mat)
    }  
    return(FS_mat)
  }else{
    stop("Zero feature retained out of ", length(frac), 
         " supplied features in the FS object.")
  }
  
}


#' Checks if feature set and input scores are valid dataset
#'
#' @param FS_mat a matrix of binary features where rows represent features of 
#' interest (e.g. genes, transcripts, exons, etc...) and columns represent 
#' the samples. 
#' @param input_score a vector of continuous scores of a molecular phenotype of
#' interest such as protein expression, pathway activity, etc.
#' NOTE: The \code{input_score} object must have names or labels that 
#' match the column names of FS_mat object.
#' @param meta_feature a vector of one or more features representing known causes
#' of activation or features associated with a response of interest.
#' Default is NULL.
#' @param do_check a logical value indicates whether or not to validate if the  
#' given parameters (FS_mat and input_score) are valid inputs. 
#' Default is \code{TRUE}
#'
#' @noRd
#' 
#' @examples 
#' 
#' # Create a feature matrix
#' FS_mat <- matrix(c(1,0,1,0,0,0,0,0,1,0, 
#'                 0,0,1,0,1,0,1,0,0,0,
#'                 0,0,0,0,1,0,1,0,1,0), nrow=3)
#' 
#' colnames(FS_mat) <- 1:10
#' row.names(FS_mat) <- c("TP_1", "TP_2", "TP_3")
#' 
#' # Create a vector of observed input scores
#' set.seed(42)
#' input_score = rnorm(n = ncol(FS_mat))
#' names(input_score) <- colnames(FS_mat)
#'
#' # Check data inputs
#' check_data_input(
#'  FS_mat = FS_mat,
#'  input_score = input_score,
#'  meta_feature = NULL
#' )
#' 
#' @return If do_check=FALSE, return NULL, otherwise, check if FS_mat and 
#' input_score are valid inputs 
check_data_input <- function(
    FS_mat,
    input_score,
    meta_feature = NULL,
    do_check = TRUE
){
  
  if(do_check == FALSE) return(NULL)

  # Check if FS must contain at least one row feature with binary values 0s or 1s
  if(nrow(FS_mat) == 0 || any(!FS_mat %in% c(0,1)))
    stop("FS object must contain at least one row feature with 
         binary values 0s or 1s.")
  
  # Make sure the FS object has row names for features tracking
  if(is.null(rownames(FS_mat)))
    stop("The FS object does not have row names to ",
         "track features by. Please provide unique features or row names ",
         "for the FS object.\n")
  
  # Make sure the FS object has row names for features tracking
  if(is.null(colnames(FS_mat)))
    stop("The FS object does not have column names to ",
         "track samples by. Please provide unique sample names ",
         "for the FS object.\n")
  
  # Check if input_score is provided and contains a vector of continuous values 
  # (with no NAs). Additionally, check if it has names or labels that match 
  # the column names of the FS object
  if(length(input_score) == 0 || any(!is.numeric(input_score)) || 
     any(is.na(input_score)) || is.null(names(input_score)) ||
     any(!names(input_score) %in% colnames(FS_mat)))
    stop("input_score must contain a vector of continuous scores ",
         "(with no NAs), and its vector names or labels must match the column ",
         "names of the FS object.\n")
  
  # Check if the features have either all 0s or 1s values
  if(any(rowSums(FS_mat) %in% c(0, ncol(FS_mat))))
    stop("The FS object has features that are either all 0s or 1s. ",
         "These features must be removed from the FS object as ",
         "they are uninformative.")
  
  if(length(meta_feature) > 0 && any(!meta_feature %in% rownames(FS_mat)))
    stop("The provided meta feature(s): ", 
         paste0(meta_feature[which(!meta_feature %in% rownames(FS_mat))], 
                collapse=", "),
         " do(es) not exist among the row names of the FS object.\n")
  
}


#' Check top_N value for candidate_search()
#'
#' Checks top_N value is valid and return a list of indices of top N features 
#' with the best scores to start candidate_search()
#'
#' @param rowscore a vector of directional scores computed based on a
#' given scoring method, feature set (FS), and input score (input_score) using
#' calc_rowscore() function. The scores are ordered from most significant 
#' to least significant.
#' @param feature_names a list of feature names (or row names) in FS object
#' @param top_N an integer specifies the number of features to start the
#' search over (e.g. starting from the top 'N' features with the best scores). 
#' Default is 1.
#' If \code{top_N} is provided, then \code{search_start} parameter 
#' will be ignored. 
#' @param search_start a list of character strings (separated by commas)
#' which specify a list of feature names to start the search with. 
#' If \code{search_start} is provided, then \code{top_N} parameter 
#' will be ignored. Default is \code{NULL}.
#' 
#' @noRd
#' 
#' @examples 
#' 
#' # Load library
#' library(SummarizedExperiment)
#' 
#' # Load pre-computed feature set
#' data(sim_FS)
#'
#' # Load pre-computed input-score
#' data(sim_Scores)
#'
#' rowscore <- calc_rowscore(
#'  FS_mat = SummarizedExperiment::assay(sim_FS),
#'  input_score = sim_Scores,
#'  method = "ks_pval",
#'  alternative = "less",
#'  weights = NULL
#' )
#' 
#' top_N_index <- check_top_N(
#'  rowscore = rowscore,
#'  top_N = 7,
#'  search_start = NULL,
#'  feature_names = rownames(sim_FS)
#' )
#'
#' @return If top_N is given, a vector of indices of top N features with 
#' their corresponding best scores will be returned. These features will later 
#' use to start the candidate_search() with. Otherwise, the candidate_search() 
#' will start the heuristic search with a list of indices of starting features 
#' defined in search_start.
check_top_N <- function(
    rowscore, 
    feature_names,
    top_N = 1, 
    search_start = NULL
){
  
  # Check if search_start is given
  if(is.null(search_start)){
    
    if(is.na(top_N) || length(top_N) == 0 || top_N <= 0)
      stop("Please specify a NUMERIC top_N value to evaluate over top N ",
           "features (top_N must be >= 1).\n")
    
    if(top_N > length(feature_names))
      stop("Please specify a top_N value that is less than the number of ",
           "features in the FS object.\n")
    
    # Getting the top N features with the biggest scores
    top_features <- names(rowscore[seq_len(top_N)])
    
    # Retrieve the indexes of features with the best scores in FS object
    search_feature_index <- lapply(seq_along(top_features), function(f){
      #f=1;
      which(feature_names == top_features[f])
    }) |> unlist()
    
    verbose("Evaluating search over top ", length(search_feature_index), 
            " feature(s)\n")
    
  }else{
    
    search_start <- strsplit(as.character(search_start), ",", fixed=TRUE) |>
      unlist() |>
      trimws()
    
    if(length(search_start) == 0 || any(!search_start %in% feature_names))
      stop("The provided starting feature(s): ", 
           paste0(search_start[which(!search_start %in% feature_names)], 
                  collapse=", "),
           " do(es) not exist among the row names of the FS object.\n")
    
    # Get the index of the search_start strings
    search_feature_index <- lapply(seq_along(search_start), function(f){
      #f=1;
      which(feature_names == search_start[f])
    }) |> unlist()
    
    # User-specified feature names
    verbose("Starting with specified feature names...\n")
    
  }
  
  return(search_feature_index)
  
}



#' ks_test_d_wrap_ wrapper
#'
#' Compute directional Kolmogorov-Smirnov scores
#' @param n_x length of ranked list
#' @param y positions of geneset items in ranked list (ranks)
#' @param alt alternative hypothesis for p-value calculation
#' (\code{"two.sided"} or \code{"greater"} or \code{"less"}).
#' Default is \code{less} for left-skewed significance testing.
#' 
#' @noRd
#' @useDynLib CaDrA ks_test_d_wrap_
#'
#' @return need a return value here
ks_test_double_wrap <- function(n_x, y, alt=c("less", "greater", "two.sided")) {


  if(length(alt) > 0){
    alt_int<- switch(alt, two.sided=0L, less=1L, greater=-1L, 1L)
  } else {
    alt_int <- 1L
  }

  # If input is an empty vector
  if( n_x != length(y) | length(y) < 1) return (NULL)

  res <- .Call(ks_test_d_wrap_,  as.integer(n_x), as.numeric(y), alt_int)
  res

}


#' Random permutation matrix generator
#'
#' Produces a random permutation score matrix given a vector of sample-specific
#' scores representing a phenotypic readout of interest such as protein 
#' expression, pathway activity, etc.
#' @param input_score a vector of continuous scores of a molecular phenotype of 
#' interest such as protein expression, pathway activity, etc.
#' NOTE: The \code{input_score} object must have names or labels to track 
#' samples by.
#' @param n_perm a number of permutations to generate. This determines
#' the number of rows in the permutation matrix.
#' 
#' @return a matrix of values where each row contains scores of a single 
#' permuted \code{input_score}.
#'
#' @examples
#'
#' # Load pre-simulated scores
#' data(sim_Scores)
#'
#' # Set seed for permutation
#' set.seed(123)
#'
#' # Define number of permutations
#' n_perm = 1000
#'
#' # Generate permuted scores
#' perm_matrix <- generate_permutations(
#'   input_score = sim_Scores,
#'   n_perm = n_perm
#' )
#'
#' @export
generate_permutations <- function(
    input_score,
    n_perm
){
  
  # Check input_score is provided and is a continuous values with no NAs
  stopifnot("input_score must contain a vector of continuous values (no NAs)"= 
              length(input_score) > 0 && all(is.numeric(input_score)) && 
              all(!is.na(input_score)))
  
  # Make sure the input_score has names or labels to track samples by
  stopifnot("input_score object must have names or labels to track samples by"=
              !is.null(names(input_score)))
  
  # Get number of samples
  n <- length(input_score)
  
  # Create permutation matrix
  perm <- matrix(NA, nrow=n_perm, ncol=n)
  colnames(perm) <- names(input_score)

  # Sample the input scores
  for(i in seq_len(n_perm)){
    perm[i,] <- sample(input_score, n, replace=FALSE)
  }

  # Make sure permutations are unique
  stopifnot("Permutations are not unique. Try a different n_perm value." =
              (nrow(perm) == nrow(unique.matrix(perm))))
  
  return(perm)

}

test_that("generate_permutations returns expected results", {
  
  data(sim_Scores)
  set.seed(123)
  n_perm = 1000

  result <- generate_permutations(
    input_score = sim_Scores,
    n_perm = n_perm
  )
  
  testthat::expect_identical(dim(result), c(1000L, 100L))
  testthat::expect_type(result, "double")
})

test_that("prefilter_data outputs appropriate errors", {
  
  mat <- matrix(1:1000, nrow = 100)
  expect_error( prefilter_data(FS = mat))
  
})


test_that("prefilter_data returns expected result ",{
  
  set.seed(21)
  data(sim_FS)
  
  # Pass a numeric vector to the cadra_search and expect that it returns an error
  result <- prefilter_data(FS = sim_FS)
  
  testthat::expect_s4_class(result, "SummarizedExperiment")
  expect_identical(dim(SummarizedExperiment::assay(result)), c(1000L, 100L))
  
})

#'
#' Candidate Search
#'
#' Performs heuristic search on a set of binary features to determine whether
#' there are features whose union is more skewed (enriched at the extremes)
#' than either features alone. This is the main functionality of
#' the \code{CaDrA} package.
#'
#' NOTE: The legacy function \code{topn_eval} is equivalent to the recommended
#' \code{candidate_search} function
#'
#' @param FS a matrix of binary features or a SummarizedExperiment class object
#' from SummarizedExperiment package where rows represent features of interest
#' (e.g. genes, transcripts, exons, etc...) and columns represent the samples.
#' The assay of FS contains binary (1/0) values indicating the presence/absence
#' of omics features.
#' @param input_score a vector of continuous scores representing a phenotypic
#' readout of interest such as protein expression, pathway activity, etc.
#'
#' NOTE: \code{input_score} object must have names or labels that match the
#' column names of \code{FS} object.
#' @param method a character string specifies a scoring method that is
#' used in the search. There are 7 options: (\code{"ks_pval"} or \code{ks_score}
#' or \code{"wilcox_pval"} or \code{wilcox_score} or
#' \code{"revealer"} (conditional mutual information from REVEALER) or
#' \code{"knnmi"} (K-Nearest Neighbor Mutual Information Estimator from knnmi) or
#' \code{"correlation"} (based on simple correlation - pearson or spearman) or
#' \code{"custom"} (a user-defined scoring method)).
#' Default is \code{ks_pval}.
#' @param method_alternative a character string specifies an alternative
#' hypothesis testing (\code{"two.sided"} or \code{"greater"} or \code{"less"}).
#' Default is \code{less} for left-skewed significance testing.
#'
#' NOTE: This argument only applies to \code{ks_pval} and \code{wilcox_pval} method
#' @param cmethod correlation method to use - spearman or pearson. 
#' Default is "spearman".
#' 
#' NOTE: This argument only applies to \code{correlation} method only
#' @param custom_function if method is \code{"custom"}, specifies
#' a user-defined function here. Default is \code{NULL}.
#'
#' NOTE: \code{custom_function} must take FS and input_score as its
#' input arguments and its final result must return a vector of row-wise scores
#' where its labels or names match the row names of \code{FS} object.
#' @param custom_parameters if method is \code{"custom"}, specifies a list of
#' additional arguments (excluding \code{FS} and \code{input_score})
#' to be passed to the \code{custom_function}. For example:
#' custom_parameters = list(alternative = "less"). Default is \code{NULL}.
#' @param weights if method is \code{ks_score} or \code{ks_pval}, specifying a
#' vector of weights will perform a weighted-KS testing. Default is \code{NULL}.
#'
#' NOTE: \code{weights} must have names or labels that match the labels of
#' \code{input_score}.
#' @param search_start a vector of character strings (separated by commas)
#' specifies feature names in the \code{FS} object to start the search with.
#' If \code{search_start} is provided, then \code{top_N} parameter will be
#' ignored and vice versa. Default is \code{NULL}.
#' @param top_N an integer specifies the number of features to start the
#' search over. By default, it starts with the feature that has the highest
#' best score (top_N = 1).
#'
#' NOTE: If \code{top_N} is provided, then \code{search_start} parameter
#' will be ignored and vice versa. If top_N > 10, it may result in a longer
#' search time.
#' @param search_method a character string specifies an algorithm to filter
#' out the best features (\code{"forward"} or \code{"both"}). Default is
#' \code{both} (i.e. backward and forward).
#' @param max_size an integer specifies a maximum size that a meta-feature
#' can extend to do for a given search. Default is \code{7}.
#' @param best_score_only a logical value indicates whether or not to return
#' the best score corresponding to each top N searches only.
#' Default is \code{FALSE}.
#' @param do_plot a logical value indicates whether or not to plot the
#' overlapping features of the resulting meta-feature matrix.
#'
#' NOTE: plot can only be produced if the resulting meta-feature matrix contains
#' more than 1 feature (e.g. length(search_start) > 1 or top_N > 1).
#' Default is \code{FALSE}.
#' @param verbose a logical value indicates whether or not to print the
#' diagnostic messages. Default is \code{FALSE}.
#'
#' @return If \code{best_score_only = TRUE}, the heuristic search will return
#' the best feature whose its union meta-feature matrix has the highest score
#' among the \code{top_N} feature searches.
#' If \code{best_score_only = FALSE}, a list of objects pertaining to
#' \code{top_N} feature searches will be returned. For each top_N feature search,
#' the candidate search will contain 7 objects: (1) its best meta-feature matrix
#' (\code{feature_set}), (2) its observed input scores (\code{input_score}),
#' (3) its corresponding best score pertaining to the union meta-feature
#' matrix (\code{score}), (4) names of the best meta-features (\code{best_features}),
#' (5) rank of the best meta-features in term of their best scores (\code{best indices}),
#' (6) marginal scores of the best meta-features (\code{marginal_best_scores}),
#' (7) cumulative scores of the best meta-features (\code{cumulative_best_scores}).
#'
#' @examples
#'
#' # Load pre-computed feature set
#' data(sim_FS)
#'
#' # Load pre-computed input scores
#' data(sim_Scores)
#'
#' # Define additional parameters and run the function
#' candidate_search_result <- candidate_search(
#'   FS = sim_FS, input_score = sim_Scores,
#'   method = "ks_pval", method_alternative = "less", weights = NULL,
#'   search_start = NULL, top_N = 3, search_method = "both",
#'   max_size = 7, best_score_only = FALSE
#' )
#'
#' @export
#' @import SummarizedExperiment
candidate_search <- function(
    FS,
    input_score,
    method = c("ks_pval", "ks_score", "wilcox_pval", "wilcox_score",
               "revealer", "knnmi", "correlation", "custom"),
    method_alternative = c("less", "greater", "two.sided"),
    cmethod = c("spearman", "pearson"),
    custom_function = NULL,
    custom_parameters = NULL,
    weights = NULL,
    search_start = NULL,
    top_N = 1,
    search_method = c("both", "forward"),
    max_size = 7,
    best_score_only = FALSE,
    do_plot = FALSE,
    verbose = FALSE
){

  # Set up verbose option
  options(verbose = verbose)

  # Match arguments
  method <- match.arg(method)
  method_alternative <- match.arg(method_alternative)
  search_method <- match.arg(search_method)

  if (method == "correlation") {
    cmethod <- match.arg(cmethod)
  }

  # Select the appropriate method to compute scores based on
  # skewness of a given binary matrix
  # Return a vector of scores that already been ordered from
  # most significant to least significant
  # This comes in handy when doing the top-N evaluation of
  # the top N 'best' features
  rowscore <- calc_rowscore(
    FS = FS,
    input_score = input_score,
    meta_feature = NULL,
    method = method,
    method_alternative = method_alternative,
    cmethod = cmethod,
    custom_function = custom_function,
    custom_parameters = custom_parameters,
    weights = weights,
    search_start = search_start,
    top_N = top_N,
    search_method = search_method,
    max_size = max_size,
    best_score_only = best_score_only,
    do_plot = do_plot,
    do_check = TRUE,
    verbose = verbose
  )

  # Re-order rowscore in a decreasing order (from highest to lowest values)
  # This comes in handy when doing the top-N evaluation of
  # top N 'best' features
  rowscore <- rowscore[order(rowscore, decreasing=TRUE)]

  ###### INITIALIZE VARIABLES ###########
  #######################################

  # Check if top_N is given and is numeric
  top_N <- as.integer(top_N)

  # Get the indices of features to start the search
  search_feature_index <- check_top_N(
    rowscore = rowscore,
    feature_names = rownames(FS),
    top_N = top_N,
    search_start = search_start
  )

  ## Check the search_method variable ####
  back_search <- ifelse(search_method == "both", TRUE, FALSE)

  ## Check the max_size variable ####
  max_size <- as.integer(max_size)

  if(is.na(max_size) || length(max_size)==0 ||
     max_size <= 0 || max_size > nrow(FS))
    stop("Please specify a maximum size that a meta-feature matrix can extend ",
         "to do for a given search (e.g., max_size must be >= 1) ",
         "and max_size must be lesser than the number of features in FS.\n")

  # Performs the search based on the given indices of the starting best features
  topn_l <- lapply(seq_along(search_feature_index), function(x){
    # x=1;
    # Extract the index of the feature
    feature_best_index <- search_feature_index[x]

    # Get the name of the starting feature and its best score
    start_feature <- rownames(FS)[feature_best_index]
    best_feature <- start_feature
    best_score <- rowscore[best_feature]

    verbose("***Top Feature ", x, ": ", best_feature, "***\n")
    verbose("Score: ", best_score, "\n")

    # Update score and feature set since entry into the
    # loop means there is an improvement (i > 0)
    global_best_s <- best_score

    # Initiate list of global features, indices, and scores
    global_best_s_features <- c()
    global_best_s_scores <- c()

    # Counter variable for number of iterations
    i <- 0

    ###### BEGIN ITERATIONS ###############
    #######################################

    verbose("Beginning candidate search...\n")

    while((best_score > global_best_s | i == 0)
          && (length(global_best_s_features) < max_size)
          && (length(global_best_s_features) < nrow(FS))){

      verbose("- Iteration number: ", (i+1), "\n")
      verbose("Global best score: ", global_best_s, "\n")
      verbose("Previous score: ", best_score, "\n")

      # Update global score with current best score
      global_best_s <- best_score

      # Update meta-feature set, its indices, and best scores
      global_best_s_features <- c(global_best_s_features, best_feature)
      global_best_s_scores <- c(global_best_s_scores, best_score)

      verbose("Current meta-feature set:\n ", global_best_s_features, "\n")

      # Perform a backward check on the list of existing features and
      # update global scores/feature lists accordingly
      if(length(global_best_s_features) > 3 & back_search == TRUE){

        backward_search_results <- forward_backward_check(
          FS = FS,
          input_score = input_score,
          method = method,
          method_alternative = method_alternative,
          cmethod = cmethod,
          custom_function = custom_function,
          custom_parameters = custom_parameters,
          weights = weights,
          search_start = search_start,
          top_N = top_N,
          search_method = search_method,
          max_size = max_size,
          best_score_only = best_score_only,
          do_plot = do_plot,
          do_check = FALSE,  # MAKE SURE DO_CHECK IS SILENCE HERE
          verbose = verbose,
          glob_f = global_best_s_features,
          glob_s = global_best_s,
          glob_f_scores = global_best_s_scores
        )

        # Update global features, scores
        global_best_s_features <- backward_search_results[["best_features"]]
        global_best_s_scores <- backward_search_results[["best_scores"]]
        global_best_s <- backward_search_results[["score"]]

        verbose("Current meta-feature set after performing backward search:\n ",
                global_best_s_features, "\n")

      }

      # Compute row-wise directional scores given known meta features
      meta_rowscore <- calc_rowscore(
        FS = FS,
        input_score = input_score,
        meta_feature = global_best_s_features,
        method = method,
        method_alternative = method_alternative,
        cmethod = cmethod,
        custom_function = custom_function,
        custom_parameters = custom_parameters,
        weights = weights,
        search_start = search_start,
        top_N = top_N,
        search_method = search_method,
        max_size = max_size,
        best_score_only = best_score_only,
        do_plot = do_plot,
        do_check = FALSE,  # MAKE SURE DO_CHECK IS SILENCE HERE
        verbose = FALSE    # MAKE SURE VERBOSE IS SILENCE HERE
      )

      # Set up verbose option
      options(verbose = verbose)

      # Get index of highest best score
      best_index <- which.max(meta_rowscore)

      # Get the highest best score
      best_score <- meta_rowscore[best_index]

      # Get feature name of highest best score
      best_feature <- names(best_score)

      # If no improvement (exiting loop)
      if(best_score > global_best_s){
        verbose("Feature that produced best score in combination ",
                "with current meta-feature set: ", best_feature, "\n")
        verbose("Score: ", best_score, "\n")
      }else{
        verbose("No further improvement in score has been found.\n")
      }

      # Increment the next loop
      i <- i+1

    } ######### End of while loop

    verbose("\n\nFinished!\n")
    verbose("Number of iterations covered: ", i, "\n")
    verbose("Best score attained over ", i ,
            " iterations: ", global_best_s, "\n")

    if(length(global_best_s_features) == 1)
      verbose("No meta-feature that improves the enrichment was found.\n")

    verbose("Features returned in FS: ", global_best_s_features, "\n")

    # We don't just want the combination (meta-feature) at the end.
    # We want all the features that make up the meta-feature
    # This can be obtained using the list of indices that were progressively
    # excluded (if at all) in the step-wise procedure
    # If returning only those features that led to the best global score
    FS_best <- FS[global_best_s_features, , drop=FALSE]

    # Make a list containing two elements.
    #The first will be the FS with the features that gave the best meta-feature
    #The second will be the score corresponding to the meta-feature
    # (named by the starting feature that led to that score)
    # Assign the name of the best meta-feature score to be the
    # starting feature that gave that score
    names(global_best_s) <- start_feature

    # Get indices of best features
    global_best_s_indices <- which(names(rowscore) %in% global_best_s_features)
    names(global_best_s_indices) <- global_best_s_features

    # Get marginal scores of best features
    marginal_best_scores <- rowscore[which(names(rowscore) %in% global_best_s_features)]
    names(marginal_best_scores) <- global_best_s_features

    return(
      list("feature_set" = FS_best,
           "input_score" = input_score,
           "score" = global_best_s,
           "best_features" = global_best_s_features,
           "best_indices" = global_best_s_indices,
           "marginal_best_scores" = marginal_best_scores,
           "cumulative_best_scores" = global_best_s_scores
      )
    )

  })

  # length of search_feature must be greater 2 in order to generate topn_plot
  if(do_plot) topn_plot(topn_list = topn_l)

  # best_score_only
  if(best_score_only == TRUE){

    # Extract best score from each top N run
    scores_l <- lapply(seq_along(topn_l), function(l){ topn_l[[l]][['score']] })

    # Obtain the best scores with its associated feature names
    best_meta_scores <- unlist(scores_l)

    # Fetch the best score with the highest value
    best_score <- best_meta_scores[order(best_meta_scores, decreasing = TRUE)][1]

    return(best_score)

  }

  # By Default, the function returns the top N candidate search results as
  # a list of lists
  return(topn_l)

}


# Performance backward selection
#' @param FS a matrix of binary features or a SummarizedExperiment class object
#' from SummarizedExperiment package where rows represent features of interest
#' (e.g. genes, transcripts, exons, etc...) and columns represent the samples.
#' The assay of FS contains binary (1/0) values indicating the presence/absence
#' of ‘omics’ features.
#' @param input_score a vector of continuous scores representing a phenotypic
#' readout of interest such as protein expression, pathway activity, etc.
#' The \code{input_score} object must have names or labels that match the column
#' names of FS object.
#' @param method a character string specifies a scoring method that is
#' used in the search. There are 4 options: (\code{"ks"} or \code{"wilcox"} or
#' \code{"revealer"} (conditional mutual information from REVEALER) or
#' \code{"custom"} (a user customized scoring method)). Default is \code{ks}.
#' @param custom_function if method is \code{"custom"}, specifies
#' the customized function here. Default is \code{NULL}.
#' @param custom_parameters if method is \code{"custom"}, specifies a list of
#' arguments to be passed to the \code{custom_function}. Default is \code{NULL}.
#' @param method_alternative a character string specifies an alternative hypothesis
#' testing (\code{"two.sided"} or \code{"greater"} or \code{"less"}).
#' Default is \code{less} for left-skewed significance testing.
#' @param weights if method is \code{ks_pval} or \code{ks_score}, specifying
#' a vector of weights will perform a weighted-KS testing. Default is
#' \code{NULL}.
#' @param glob_f a vector containing the features (or row names) whose
#' union gives the best score (so far) in the search.
#' Feature names should match those of the provided FS object
#' @param glob_f_s a vector of scores corresponding to the union of the
#' specified vector of features
#' @param verbose a logical value indicates whether or not to print the
#' diagnostic messages. Default is \code{FALSE}.
#' @param ... additional parameters to be passed to the \code{custom_function}
#'
#' @noRd
#'
#' @return return the set of features with its current best score that is
#' better than the existing meta-feature best score
#'
#' @import SummarizedExperiment
forward_backward_check <- function
(
  FS,
  input_score,
  method,
  method_alternative,
  cmethod,
  custom_function,
  custom_parameters,
  weights,
  glob_f,
  glob_s,
  glob_f_scores,
  verbose = FALSE,
  ...
){

  # Set up verbose option
  options(verbose = verbose)

  verbose("Performing backward search...\n")
  verbose("Iterating over ", length(glob_f), " chosen features...\n")

  # Retrieve binary feature matrix of only global best features so far
  if(is(FS, "SummarizedExperiment")){
    gmat <- SummarizedExperiment::assay(FS)[glob_f,]
  }else{
    gmat <- FS[glob_f,]
  }

  # Here, we make a list that should store the features and their
  # corresponding meta-feature score for each leave-one-out run
  f_names <- list()
  f_indices <- list()
  f_scores <- list()
  scores <- c()

  # We want to see if leaving anyone feature out improves the overall
  # meta-feature score
  # Here we only consider previous features in the meta-feature matrix
  # (i.e. not the last one which was just added)
  for(n in seq_len(length(glob_f)-1)){
    #n=1;
    # Store features to list
    f_names[[n]] <- glob_f[-n]
    f_scores[[n]] <- glob_f_scores[-n]

    # Take the leave-one-out union of features will result in a single
    # vector to compute the scores on
    f_union <- ifelse(colSums(gmat[-n,]) == 0, 0, 1)

    # Here we are getting the union of the meta-features
    u_mat <- matrix(f_union, nrow=1, byrow=TRUE,
                    dimnames=list(c("UNION"), colnames(FS)))

    # If the class of FS is originally a SummarizedExperiment object
    # Convert the matrix to SummarizedExperiment
    # This makes sure the original class of FS object does not change
    if(is(FS, "SummarizedExperiment")){
      u_FS <- SummarizedExperiment::SummarizedExperiment(assays=u_mat)
    }else{
      u_FS <- u_mat
    }

    # Compute row scores for this meta feature
    u_rowscore <- calc_rowscore(
      FS = u_FS,
      input_score = input_score,
      meta_feature = NULL,
      method = method,
      method_alternative = method_alternative,
      cmethod = cmethod,
      custom_function = custom_function,
      custom_parameters = custom_parameters,
      weights = weights,
      verbose = FALSE,
      ...
    )

    # Get the highest best score
    scores <- c(scores, u_rowscore[which.max(u_rowscore)])

  } # end for loop

  # Set up verbose option
  options(verbose = verbose)

  # Obtain index of union meta-feature that gives the best score
  f_best_index <- which.max(scores)

  # Obtain best score of the union meta-feature
  f_best_score <- scores[f_best_index]

  # Here, we check if the new meta-feature has a computed best score better than
  # the previous meta-feature's score
  if(f_best_score > glob_s){

    verbose("Found improvement on removing existing features...\n")
    verbose("New feature set: ", f_names[[f_best_index]], "\n")
    verbose("New global best score: ", f_best_score, "\n")

    # Return a set of features that gave a better score than
    # the existing best score and its new best score as well
    return(list(best_features = f_names[[f_best_index]],
                best_scores = f_scores[[f_best_index]],
                score = f_best_score))

  }else{

    # Don't change anything. Return the existing
    # best set of features and its corresponding score
    return(list(best_features = glob_f,
                best_scores = glob_f_scores,
                score = glob_s))

  }

}

test_that("candidate_search receives correct input arguments ", {
  
  # Pass a numeric vector to the cadra_search and expect that it returns an error
  expect_error(candidate_search(1:10))
  
})


test_that("candidate_search returns expected result ",{
  
  # Load pre-computed feature set
  data(sim_FS)
  
  # Load pre-computed input-score
  data(sim_Scores)
  
  # Define additional parameters and run the function
  result <- candidate_search(
    FS = sim_FS, 
    input_score = sim_Scores, 
    method = "ks_pval", 
    method_alternative = "less", 
    weights = NULL, 
    search_start = NULL, 
    search_method = "both", 
    top_N = 1,
    max_size = 7, 
    best_score_only = FALSE
  )
  
  testthat::expect_length(result, 1L)
  testthat::expect_type(result, "list")
  testthat::expect_length(result[[1]], 7L)
  testthat::expect_s4_class(result[[1]][[1]], "SummarizedExperiment")
  
  testthat::expect_length(result[[1]][[2]], 100L)
  testthat::expect_equal(round(result[[1]][[2]][c(1:3, 100)],9),
                         c("1"=2.187332993, "2"=2.168955965, 
                           "3"=2.050084686, "100"=-2.309168876))
  
  testthat::expect_length(result[[1]][[3]], 1L)
  testthat::expect_equal(round(result[[1]][[3]],5), c("TP_8"=14.13128))
  

  # Run candidate_search with wilcox method
  result <- candidate_search(
    FS = sim_FS, 
    input_score = sim_Scores, 
    method = "wilcox_pval",
    method_alternative = "less", 
    weights = NULL, 
    search_start = NULL, 
    search_method = "both",
    top_N = 1,
    max_size = 7, 
    best_score_only = FALSE
  )
  
  testthat::expect_length(result, 1L)
  testthat::expect_type(result, "list")
  testthat::expect_length(result[[1]], 7L)
  testthat::expect_s4_class(result[[1]][[1]], "SummarizedExperiment")
  
  testthat::expect_length(result[[1]][[2]], 100L)
  testthat::expect_equal(round(result[[1]][[2]][c(1:3, 100)],6),
                         c("1"=2.187333, "2"=2.168956, 
                           "3"=2.050085, "100"=-2.309169))
  
  testthat::expect_length(result[[1]][[3]], 1L)
  testthat::expect_equal(round(result[[1]][[3]],5), c("TN_129"=21.35299))
  
  # Run candidate_search with revealer method
  result <- suppressWarnings(
    candidate_search(
      FS = sim_FS, 
      input_score = sim_Scores, 
      method = "revealer",
      method_alternative = "less", 
      weights = NULL,
      search_start = NULL,
      search_method = "both", 
      top_N = 1,
      max_size = 7,
      best_score_only = FALSE
    )
  )
  
  testthat::expect_length(result, 1L)
  testthat::expect_type(result, "list")
  testthat::expect_length(result[[1]], 7L)
  testthat::expect_s4_class(result[[1]][[1]], "SummarizedExperiment")
  
  testthat::expect_length(result[[1]][[2]], 100L)
  testthat::expect_equal(round(result[[1]][[2]][c(1:3, 100)], 6),
                         c("1"=2.187333, "2"=2.168956, 
                           "3"=2.050085, "100"=-2.309169))
  
  testthat::expect_length(result[[1]][[3]], 1L)
  testthat::expect_equal(round(result[[1]][[3]], 5), c("TN_985"=0.37856))

})

#'
#' Candidate Drivers Search Plot
#'
#' By utilizing the top N results obtained from \code{candidate_search},
#' we can find the best meta-feature among the top N searches using
#' \code{topn_best}. \code{meta_plot} is then used to produce graphics
#' including a tile plot for the top meta-features that associated with  
#' a molecular phenotype of interest (e.g. input_score), 
#' the KS enrichment plot of the meta-features, 
#' and lastly, a density diagram of the distribution of the observed
#' input scores sorted from largest to smallest at the top.
#' @param topn_best_list a list of objects returned from \code{candidate_search} 
#' corresponding to the search of top N features given by top_N value.
#' The topn_best_list contains the best meta-feature matrix, its 
#' corresponding best score, its observed input scores, rank of the best 
#' features based on their scores, marginal best scores, and cumulative 
#' best scores.
#' @param input_score_label a label that references to the \code{input_score}
#' variable that was used to compute the top N best features. 
#' Default is \code{NULL}.
#' @param plot_title a title to the plot. Default is \code{NULL}.
#' 
#' @return 3 plots stacked on top of each other: 
#' 1. a density diagram of observed input scores sorted from highest to lowest 
#' 2. a tile plot of the top features within the meta-feature set 
#' 3. a KS enrichment plot of the meta-feature set (this correspond to the 
#' logical OR of the features)
#' 
#' @examples
#'
#' # Load pre-computed Top-N list generated for sim_FS dataset
#' data(topn_list)
#'
#' # With the results obtained from top-N evaluation,
#' # We can find the combination of features that gives the best score in
#' # top N searches
#' topn_best_meta <- topn_best(topn_list = topn_list)
#'
#' # Now we can plot this set of best meta-feature
#' meta_plot(topn_best_list = topn_best_meta)
#'
#' @export
#' @import SummarizedExperiment ggplot2 reshape2
#' @importFrom grid unit.pmax grid.draw
meta_plot <- function(topn_best_list, input_score_label=NULL, plot_title=NULL){

  # Get best meta-feature set and observed input score from top N best results
  best_feature_set <- topn_best_list[["feature_set"]]
  obs_input_score <- topn_best_list[["input_score"]]
  
  ## Order input score from largest to lowest values
  input_score <- obs_input_score[order(obs_input_score, decreasing = TRUE)]
  
  # Re-order the matrix based on the order of input_score
  # Retrieve the binary feature matrix
  feature_set <- best_feature_set[, names(input_score), drop=FALSE]

  # Plot y axis label
  y_lab <- ifelse(is.null(input_score_label), "input_score",
                  input_score_label)
  
  # Plot x axis label
  x_lab <- paste("Samples (n = ", ncol(feature_set),")", sep="")
  
  # Make dataframe of measure and sample information,
  # with rows arranged in specific order of measure used for search
  # Here we assume that input_score provided is ordered in the order
  # that the stepwise search was run for the dataset
  var_d <- data.frame(
    "measure" = input_score,
    "sample" = factor(colnames(feature_set), levels=colnames(feature_set))
  )
  
  # This plot assumes that there are two columns in the data frame
  # called 'sample' and 'measure'
  # The 'sample' variable has to be a factor with ordered levels
  # for displaying in the correct sample order
  # adding ".data" to avoid a warning during check:
  # no visible binding for global variable
  m_plot <- ggplot(data=var_d,
                   aes(x=.data$sample, y=.data$measure, group=1)) +
    geom_area(alpha=0.6, fill="deepskyblue4",
              linetype=1,  color="black") +
    scale_y_continuous(expand = c(0,0)) +
    scale_x_discrete(expand = c(0,0)) +
    theme_classic() +
    labs(title = plot_title, x=x_lab, y=y_lab) +
    theme(
      plot.title = element_text(hjust = 0.5),
      axis.text.x=element_blank(),
      axis.ticks.x=element_blank(),
      axis.line.x=element_line(color="black"),
      axis.line.y=element_line(color="black")
    )
  
  # Extract the feature binary matrix
  if(is(feature_set, "SummarizedExperiment")){
    mat <- SummarizedExperiment::assay(feature_set)
  }else{
    mat <- feature_set
  } 
  
  # Add on the OR function of all the returned entries
  or <- ifelse(colSums(mat)==0, 0, 1)
  
  # Combine meta-feature with OR function
  mat <- rbind(mat, or)
  
  # Give the last row no row name (this is just for the purpose of plotting)
  rownames(mat)[nrow(mat)] <- ""
  
  # Make the OR function have a higher value of 2 rather than 0 and 1
  # This is just for the purpose of plotting
  mat[nrow(mat),] <- 2*(mat[nrow(mat),])
  
  # create the meta plot
  x <- mat
  x_m <- reshape2::melt(x)
  
  # Make factor for genes so it stays in order of dataset (feature feature_set)
  # Here we need to reverse the order of the levels because geom_tile
  # plots ascending from bottom to top
  x_m$Var1 <- factor(as.character(x_m$Var1),
                     levels=rev(unique(as.character(x_m$Var1))))
  
  # Plot for mutation/CNA feature profile (with summary OR)
  feature_plot <- ggplot(data=x_m, 
                         aes(x=factor(.data$Var2),
                             y=.data$Var1, fill=.data$value)) +
    geom_tile(colour=NA) +
    scale_fill_gradient2(
      high="red",
      mid="black",
      low = "white",
      midpoint = 1
    ) +
    theme(
      line=element_blank(),
      axis.text.x=element_blank(),
      axis.text.y=element_text(size=8,colour="black",face="bold"),
      panel.border=element_rect(colour="black",fill=NA)
    ) +
    labs(x="", y="Feature")
  
  # Get x and y axis data for ks enrichment plot of 
  # cumulative function of individual features (i.e. the OR function)
  enrichment_dat <- ks_plot_coordinates(
    n_x = length(or),
    y = which(or==1),
    weights = NULL,
    alt = "less"
  )
  
  # Plot for feature_set scores
  enrichment_plot <- ks_plot(df = enrichment_dat)
  
  # Align the three plots, adjusting the widths to match
  plot_tab <- stacked_gtable_max(ggplotGrob(m_plot),
                                 ggplotGrob(feature_plot +
                                              theme(legend.position="none")),
                                 ggplotGrob(enrichment_plot))
  
  # Set heights for each panel
  plot_tab <- setup_tab_heights(plot_tab, c(2,1.25,3))
  
  # Draw combined plot to canvas
  grid.draw(plot_tab)
  
}

# Function to convert units depending on the version of R
# (for adjusting the dimensions of the ggplots)
setup_tab_heights <- function(plot_tab, dims) {

  panels <- plot_tab$layout$t[grep("panel", plot_tab$layout$name)]
  has_unit_vec <- getRversion() > '3.3'

  if(has_unit_vec) {
    plot_tab$heights[panels] <- unit(dims, units="null")
  }else {
    plot_tab$heights[panels] <- lapply(dims, unit, "null")
  }

  return(plot_tab)

}


# Solution to drawing arbitrary number of plots stacked above one another
# Each plot will be left-aligned
# Each plot should first be made a ggplotGrob object
# Ex: grid.draw(stacked_gtable_max(ggplotGrob(ggplot1), ggpotGrob(ggplot2)))
#' @import gtable
#' @importFrom grid unit.pmax
stacked_gtable_max <- function(...){

  gtl <- list(...)

  stopifnot(
    all(lapply(gtl, is.gtable) |> unlist())
  )

  bind2 <- function(x, y){

    stopifnot(ncol(x) == ncol(y))

    if (nrow(x) == 0)
      return(y)
    if (nrow(y) == 0)
      return(x)
    y$layout$t <- y$layout$t + nrow(x)
    y$layout$b <- y$layout$b + nrow(x)
    x$layout <- rbind(x$layout, y$layout)

    # Katia This line causes a warning during the package check() and
    # and considered to be not a good practice
    # See the note in ?`:::` about the use of this operator
    #x$heights <- gtable:::insert.unit(x$heights, y$heights)
    x$heights <- grid::unit.c(x$heights, y$heights)
    x$rownames <- c(x$rownames, y$rownames)
    x$widths <- grid::unit.pmax(x$widths, y$widths)
    x$grobs <- append(x$grobs, y$grobs)
    x

  }

  Reduce(bind2, gtl)

}

#' KS Enrichment Plot
#'
#' An enrichment plot of a sum statistic across a given meta-feature 
#' using KS method. 
#' The x and y-axis data for the KS enrichment plot can be returned 
#' from ks_plot_coordinates()
#' @param df a data frame object with columns 'X' and 'Y' containing the
#' x, y coordinates for the KS enrichment plot
#' @return A graphic of enrichment scores for a given distribution 
#' using KS method
#' 
#' @noRd
#'
#' @examples
#'
#' # Load R library
#' library(SummarizedExperiment)
#'
#' # Load pre-computed Top-N list generated for sim_FS dataset
#' data(topn_list)
#'
#' # With the results obtained from top-N evaluation,
#' # We can find the combination of features that gives
#' # the best score in top N searches
#' topn_best_meta <- topn_best(topn_list=topn_list)
#'
#' # Extract the best meta-feature set
#' best_meta_feature <-  topn_best_meta[["feature_set"]]
#'
#' # Get the meta-feature matrix
#' mat <- as.matrix(SummarizedExperiment::assay(best_meta_feature))
#'
#' # Compute logical OR of all returned features in meta-feature matrix
#' or <- ifelse(colSums(mat)==0, 0, 1)
#'
#' # Extract x and y axis data for KS enrichment plot of
#' # cumulative function of individual features (e.g. logical OR function)
#' ks_enrichment_coordinates <- ks_plot_coordinates(
#'    n_x = length(or),
#'    y = which(or==1),
#'    weights = NULL,
#'    alt = "less"
#' )
#'
#' # Plot the enrichment scores
#' ks_plot(df = ks_enrichment_coordinates)
#'
#' @import ggplot2
ks_plot <- function(df){

  # Katia: adding ".data" to avoid a warning during check:
  # no visible binding for global variable
  g <- ggplot(data = df, aes(x=.data$X, y=.data$Y))

  g <- g +
    #geom_line(size=1.25,colour="blueviolet")+
    geom_line(colour="darkgoldenrod1") +
    #geom_line(linewidth=1.25, colour="darkgoldenrod1") +
    geom_hline(yintercept=0, linetype=2) +
    # Katia: adding ".data" to avoid a warning during check:
    # no visible binding for global variable
    geom_point(data=df[which.max(df$Y),], aes(x=.data$X, y=.data$Y),
               colour="black", fill="red", size=3, shape=21) +
    annotate("text", x=df[which.max(df$Y),1]+8, y=max(df$Y),
             label=as.character(round(max(df$Y),3)), size=3) +
    scale_x_continuous(expand = c(0,0)) +
    scale_y_reverse() + # This inverts the feature_set score statistic line
    theme_classic() +
    theme(panel.border=element_rect(colour="black", fill=NA)) +
    labs(x="", y="Enrichment Score")

  g

}




#' x, y coordinates for creating ks plot
#'
#' Return a data frame with x, y coordinates using ks method
#' which will later used to generate the enrichment plot
#' @param n_x length of ranked list
#' @param y positions of geneset items in ranked list (ranks)
#' @param weights a vector of weights
#' @param alt alternative hypothesis for p-value calculation
#' (\code{"two.sided"} or \code{"greater"} or \code{"less"}).
#' Default is \code{less} for left-skewed significance testing.
#'
#' @useDynLib CaDrA ks_plot_wrap_
#' @noRd
#'
#' @return return a data frame with x, y coordinates to pass to ks_plot()
ks_plot_coordinates <- function(n_x, y, weights, 
                                alt=c("less", "greater", "two.sided")){
  
  if(length(alt) > 0){
    alt_int<- switch(alt, two.sided=0L, less=1L, greater=-1L, 1L)
  } else {
    alt_int <- 1L
  }
  y <- as.integer(y)
  n_x <- as.integer(n_x)
  res <- .Call(ks_plot_wrap_, n_x, y, weights, alt_int)
  res <- res[!is.na(res$X), ]
  res
  
}

test_that("ks_plot works", {
  
  library(SummarizedExperiment)
  data(topn_list)
  topn_best_meta <- topn_best(topn_list=topn_list)
  best_meta_feature <-  topn_best_meta[["feature_set"]]
  mat <- as.matrix(SummarizedExperiment::assay(best_meta_feature))
  or <- ifelse(colSums(mat)==0, 0, 1)
  ks_enrichment_coordinates <- ks_plot_coordinates(
    n_x = length(or),
    y = which(or==1),
    weights = NULL,
    alt = "less"
  )
  
  # Plot the enrichment scores
  g <- ks_plot(df = ks_enrichment_coordinates)
  expect_type(g, "object")
  expect_s3_class(g$layers[[1]], "LayerInstance")
  expect_s3_class(g$layers[[1]]$geom, "GeomLine")
  expect_s3_class(g$layers[[2]], "LayerInstance")
  expect_s3_class(g$layers[[2]]$geom, "GeomHline")
  expect_s3_class(g$layers[[3]], "LayerInstance")
  expect_s3_class(g$layers[[3]]$geom, "GeomPoint")
  expect_identical(g$labels$y, "Enrichment Score")
  
})

test_that("meta_plot works", {
  
  # Load pre-computed Top-N list generated for sim_FS dataset
  data(topn_list)

  # With the results obtained from top-N evaluation,
  # We can find the combination of features that gives the best score in
  # top N searches
  topn_best_meta <- topn_best(topn_list = topn_list)

  # Now we can plot this set of best meta-feature
  expect_silent(meta_plot(topn_best_list = topn_best_meta))

})

#'
#' knnmi Scoring Method
#'
#' Compute k-Nearest Neighbor Mutual Information Estimator of \code{x} and 
#' \code{y} given \code{z}
#' @param FS a matrix of binary features where rows represent features of 
#' interest (e.g. genes, transcripts, exons, etc...) and columns represent 
#' the samples.
#' @param input_score a vector of continuous scores representing a phenotypic
#' readout of interest such as protein expression, pathway activity, etc.
#' The \code{input_score} object must have names or labels that match the column
#' names of FS object.
#' @param meta_feature a vector of one or more features representing known 
#' causes of activation or features associated with a response of interest, 
#' \code{e.g. input_score}. Default is NULL.
#'
#' @noRd
#'
#' @examples 
#'  
#' mat <- matrix(c(1,0,1,0,0,0,0,0,1,0, 
#'                 0,0,1,0,1,0,1,0,0,0,
#'                 0,0,0,0,1,0,1,0,1,0), nrow=3)
#' 
#' colnames(mat) <- 1:10
#' row.names(mat) <- c("TP_1", "TP_2", "TP_3")
#' 
#' set.seed(42)
#' input_score = rnorm(n = ncol(mat))
#' names(input_score) <- colnames(mat)
#' 
#' knnmi_rowscore <- knnmi_rowscore(
#'   FS = mat, 
#'   input_score = input_score,
#'   meta_feature = NULL
#' )
#' 
#' @return return a vector of row-wise scores where its labels or names 
#' must match the row names of \code{FS} object
#' 
#' @import knnmi
knnmi_rowscore <- function(
    FS,
    input_score,
    meta_feature = NULL
){
  
  # Check if meta_feature is provided
  if(!is.null(meta_feature)){
    # Getting the position of the known meta features
    locs <- match(meta_feature, row.names(FS))
    
    # Taking the union across the known meta features
    if(length(locs) > 1) {
      meta_vector <- as.numeric(ifelse(colSums(FS[locs,]) == 0, 0, 1))
    }else{
      meta_vector <- as.numeric(FS[locs, , drop=FALSE])
    }
    
    # Remove the meta features from the binary feature matrix
    # and taking logical OR btw the remaining features with the meta vector
    FS <- base::sweep(FS[-locs, , drop=FALSE], 2, meta_vector, `|`)*1
    
    # Check if there are any features that are all 1s generated from
    # taking the union between the matrix
    # We cannot compute statistics for such features and thus they need
    # to be filtered out
    if(any(rowSums(FS) == ncol(FS))){
      verbose("Features with all 1s generated from taking the matrix union ",
              "will be removed before progressing...\n")
      FS <- FS[rowSums(FS) != ncol(FS), , drop=FALSE]
      # If no features remained after filtering, exist the function
      if(nrow(FS) == 0) return(NULL)
    }
  }
  
  # Compute the knnmi
  cmi <- knnmi::mutual_inf_cd(input_score, FS)
  names(cmi) <- rownames(FS)
  
  return(cmi)
  
}

#' Simulated Genomic Data
#'
#' A simulated SummarizedExperiment object that comprises of 1000 genomic
#' features (rows) and 100 sample profiles (columns).
#' Each row is represented by a vector of binary values (1/0)
#' indicating the presence/absence of the feature in the samples.
#' This simulated data includes 10 left-skewed (i.e. True Positive or TP)
#' and 990 uniformly-distributed (i.e. True Null or TN) features.
#'
#' @docType data
#'
#' @usage data(sim_FS)
#'
#' @format An object of class \code{SummarizedExperiment} from
#' \code{SummarizedExperiment} package containing 
#' an assay of 1000 rows (features)
#' and 100 columns (samples). Each row is represented by 
#' a vector of binary values (1/0)
#' indicating the presence/absence of the feature in the samples.
#' 
#' See \code{?SummarizedExperiment} for more details.
#' 
#' @return a SummarizedExperiment object
#' 
#' @references Kartha VK, Kern JG, Sebastiani P, Zhang L,
#' Varelas X, Monti S (2019) CaDrA: A computational framework for performing
#' candidate driver analyses using binary genomic features.
#' (\href{https://www.frontiersin.org/articles/10.3389/fgene.2019.00121/full}{Frontiers in Genetics})
#'
"sim_FS"

#' Top 'N' Best Meta-Features
#'
#' Take the resulting list of meta-features returned from 
#' \code{candidate_search} over top N feature searches and 
#' fetch the meta-feature with the best score.
#' @param topn_list A nested list of objects that are returned 
#' from \code{candidate_search} using the following parameters:
#' \code{FS = sim_FS}, \code{input_score = sim_Scores}, 
#' \code{top_N = 7}, \code{method = "ks_pval"}, \code{alternative = "less"}, 
#' \code{search_method = "both"}, \code{max_size = 10}, and 
#' \code{best_score_only = FALSE}. 
#' 
#' @return A list of objects containing the best meta-feature matrix, its 
#' corresponding best score, its observed input scores, rank of best 
#' meta-features based on their scores, its marginal and cumulative best scores.
#' 
#' @examples
#'
#' # Load pre-computed Top-N list generated for sim_FS dataset
#' data(topn_list)
#'
#' # Get the best meta-features list
#' topn_best_meta <- topn_best(topn_list = topn_list)
#'
#' @export
topn_best <- function(topn_list){

  # get best score list
  scores_l <- lapply(seq_along(topn_list),
                     function(l){ topn_list[[l]][['score']] })
  
  # Working with scores for each top N run
  scores <- unlist(scores_l)
  
  # Fetch the index housing the best FS
  # Based on the statistics, the largest value will be the most significant
  n <- which.max(scores)
  
  # Obtain the best score
  top_score <- scores[n]
  
  # Corresponding FS object
  best_meta <- topn_list[[n]]$feature_set

  # Corresponding input_score
  best_input_score <- topn_list[[n]]$input_score
  
  # get indices of best features
  best_meta_indices <- topn_list[[n]]$best_indices
  
  # Get scores of best features
  marginal_best_scores <- topn_list[[n]]$marginal_best_scores

  # Get scores of best features
  cumulative_best_scores <- topn_list[[n]]$cumulative_best_scores  
  
  return(
    list(
      "feature_set" = best_meta,
      "input_score" = best_input_score,
      "score" = top_score,
      "best_indices" = best_meta_indices,
      "marginal_best_scores" = marginal_best_scores,
      "cumulative_best_scores" = cumulative_best_scores
    )
  )

}

test_that("topn_best returns expected results",{
  
  data(topn_list)
  result <- topn_best(topn_list = topn_list)
  
  testthat::expect_length(result, 6L)
  testthat::expect_type(result, "list")
  testthat::expect_named(result, c("feature_set", "input_score", "score", "best_indices", "marginal_best_scores", "cumulative_best_scores"))

  testthat::expect_s4_class(result$feature_set, "SummarizedExperiment")
  testthat::expect_identical(dim(result$feature_set), c(10L, 100L))
  testthat::expect_named(result$feature_set, 
                         c('TP_7', 'TP_2', 'TP_4', 'TP_6', 'TP_3', 'TP_1', 
                           'TP_8', 'TP_9', 'TP_10', 'TP_5'))
  
  testthat::expect_type(result$input_score, "double")
  testthat::expect_length(result$input_score, 100L)

  testthat::expect_type(result$score, "double")
  testthat::expect_length(result$score, 1L)
  testthat::expect_equal(round(result$score, 5), c("TN_938"=16.66667)) 
  
})

## generating a binary feature, and a set of 100 scores with increasing association with the feature.

setwd(file.path(Sys.getenv("CBMGIT"),"CaDrA","tests","data"))
PATH <- file.path(".")
do_save <- TRUE

N <- 100 # number of observations
M <- 50  # number of scores
SD <- 0.25

set.seed(123)
feature <- sample(seq(0,1),size = N, replace = TRUE)
scores <- sapply(
  seq(0, 5, length.out = M),
  function(delta) rnorm(n = N, mean = feature, sd = SD + delta)
)
toy <- data.frame(
  feature = feature,
  scores[,order(cor(feature,scores), decreasing = TRUE)]
)
## show correlation between feature and each of the 50 scores
COR <- cor(toy$feature, toy |> dplyr::select(-feature)) |> drop()
plot(COR, ylab = "correlation")
stopifnot(all(diff(COR)<0)) # check that correlations are in descending order

## show few entries
toy[1:10,1:5]

if (do_save) {
  saveRDS(toy, file = file.path(PATH,"toy_dataset2.rds"))
  write.csv(toy, file = file.path(PATH,"toy_dataset2.csv"), row.names = FALSE)
}

#'
#' Wilcoxon Rank Sum Scoring Method
#'
#' Compute directional Wilcoxon rank sum score for each row of a
#' given binary feature matrix
#'
#' @param FS a matrix of binary features where rows represent features of 
#' interest (e.g. genes, transcripts, exons, etc...) and columns represent 
#' the samples.
#' @param input_score a vector of continuous scores representing a phenotypic
#' readout of interest such as protein expression, pathway activity, etc.
#' The \code{input_score} object must have names or labels that match the column
#' names of FS object.
#' @param meta_feature a vector of one or more features representing known 
#' causes of activation or features associated with a response of interest
#' (\code{e.g. input_score}). Default is NULL.
#' @param alternative a character string specifies an alternative
#' hypothesis testing (\code{"two.sided"} or \code{"greater"} or
#' \code{"less"}). Default is \code{less} for left-skewed significance testing.
#' @param metric a character string specifies a metric to search for 
#' best features. \code{"pval"} or \code{"stat"} may be used which is 
#' corresponding to p-value or score statistic. Default is \code{pval}. 
#'  
#' @noRd
#' 
#' @examples 
#'  
#' mat <- matrix(c(1,0,1,0,0,0,0,0,1,0, 
#'                 0,0,1,0,1,0,1,0,0,0,
#'                 0,0,0,0,1,0,1,0,1,0), nrow=3)
#'
#' colnames(mat) <- 1:10
#' row.names(mat) <- c("TP_1", "TP_2", "TP_3")
#'
#' set.seed(42)
#' input_score = rnorm(n = ncol(mat))
#' names(input_score) <- colnames(mat)
#'
#' wilcox_rs <- wilcox_rowscore(
#'    FS = mat,
#'    input_score = input_score,
#'    meta_feature = NULL,
#'    alternative = "less",
#'    metric = "pval"
#' )
#'
#' @return return a vector of row-wise scores where its labels or names 
#' must match the row names of \code{FS} object
#' 
wilcox_rowscore <- function
(
  FS,
  input_score,
  meta_feature = NULL,
  alternative = c("less", "greater", "two.sided"),
  metric = c("stat", "pval")
)
{

  metric <- match.arg(metric)
  alternative <- match.arg(alternative)
  
  # Check if meta_feature is provided
  if(!is.null(meta_feature)){
    # Getting the position of the known meta features
    locs <- match(meta_feature, row.names(FS))
    
    # Taking the union across the known meta features
    if(length(locs) > 1) {
      meta_vector <- as.numeric(ifelse(colSums(FS[locs,]) == 0, 0, 1))
    }else{
      meta_vector <- as.numeric(FS[locs,])
    }
    
    # Remove the meta features from the binary feature matrix
    # and taking logical OR btw the remaining features with the meta vector
    FS <- base::sweep(FS[-locs, , drop=FALSE], 2, meta_vector, `|`)*1
    
    # Check if there are any features that are all 1s generated from
    # taking the union between the matrix
    # We cannot compute statistics for such features and thus they need
    # to be filtered out
    if(any(rowSums(FS) == ncol(FS))){
      warning("Features with all 1s generated from taking the matrix union ",
              "will be removed before progressing...\n")
      FS <- FS[rowSums(FS) != ncol(FS), , drop=FALSE]
    }
  }
  
  # Wilcox is a ranked-based method
  # So we need to sort input_score from highest to lowest values
  input_score <- sort(input_score, decreasing=TRUE)
  
  # Re-order the matrix based on the order of input_score
  FS <- FS[, names(input_score), drop=FALSE]  
  
  # Since input_score is already ordered from largest to smallest
  # We can assign ranks as 1:N (N: number of samples)
  ranks <- seq(1, ncol(FS))

  # Compute the wilcox rank sum statitic and p-value per row in the matrix
  wilcox <- apply(X=FS, MARGIN=1, function(x){
    wilcox_score(
      x = ranks[which(x==1)],
      y = ranks[which(x==0)],
      alternative = alternative
    )
  })
  
  # Obtain score statistics from KS method
  # Change values of 0 to the machine lowest value to avoid taking -log(0)
  stat <- wilcox[1,]
  
  # Obtain p-values from KS method
  # Change values of 0 to the machine lowest value to avoid taking -log(0)
  pval <- wilcox[2,]
  pval[which(pval == 0)] <- .Machine$double.xmin

  # Compute the scores according to the provided metric
  scores <- ifelse(rep(metric, nrow(FS)) %in% "pval", -log(pval), stat)
  names(scores) <- rownames(FS)
  
  return(scores)
  
}



#' Compute rank sum scores for a given binary feature
#'
#' @param x an integer ranked values for group 1
#' @param y an integer ranked values for group 2
#' @param mu a number uses as an optional parameter to form a null hypothesis.
#' Default is \code{0}.
#' @param alternative alternative hypothesis for p-value calculation
#' (\code{"two.sided"} or \code{"greater"} or \code{"less"}).
#' Default is \code{less} for left-skewed significance testing.
#' @param paired whether to perform paired test. Default is \code{FALSE}.
#' @param exact whether to compute exact p-value. Default is \code{FALSE}.
#' @param correct whether to consider continuity correction for p-value.
#' Default is \code{TRUE}.
#'
#' @noRd
#'
#' @return a vector with two values: \code{score} and \code{p_value}
#'
#' @importFrom stats pnorm pwilcox
wilcox_score <- function
(
  x,
  y,
  mu = 0,
  alternative = c("less", "greater", "two.sided"),
  paired = FALSE,
  exact = FALSE,
  correct = TRUE
)
{

  alternative <- match.arg(alternative)
  
  if (!missing(mu) && ((length(mu) > 1L) || !is.finite(mu)))
    stop("'mu' must be a single number")
  if (!is.numeric(x))
    stop("'x' must be numeric")
  if (!is.numeric(y))
    stop("'y' must be numeric")

  DNAME <- paste(deparse(substitute(x)), "and", deparse(substitute(y)))

  x <- x[is.finite(x)]
  y <- y[is.finite(y)]

  if (length(x) < 1L) {
    #print(x)
    stop("not enough (finite) 'x' observations")}

  if (length(y) < 1L){
    #print(y)
    stop("not enough 'y' observations")}

  METHOD <- "Wilcoxon rank sum test"

  ##### Modification ######
  # Take input as ranks instead of continuous measures
  # (normally internally ranked: see below)
  r <- c(x,y)

  #r <- rank(c(x - mu, y))

  n.x <- as.double(length(x))
  n.y <- as.double(length(y))

  if (is.null(exact))
    exact <- (n.x < 50) && (n.y < 50)

  STATISTIC <- c(W = sum(r[seq_along(x)]) - n.x * (n.x + 1)/2)
  TIES <- (length(r) != length(unique(r)))

  if (exact && !TIES) {

    PVAL <- switch(alternative, two.sided = {
      p <- if (STATISTIC > (n.x * n.y/2))
        pwilcox(STATISTIC - 1, n.x, n.y,
                lower.tail = FALSE) else pwilcox(STATISTIC, n.x, n.y)
      min(2 * p, 1)
    }, greater = {
      pwilcox(STATISTIC - 1, n.x, n.y, lower.tail = FALSE)
    }, less = pwilcox(STATISTIC, n.x, n.y))

  } else {

    NTIES <- table(r)
    z <- STATISTIC - n.x * n.y/2
    SIGMA <- sqrt((n.x * n.y/12) * ((n.x + n.y + 1) -
                                      sum(NTIES^3 - NTIES)/
                                      ((n.x + n.y) * (n.x + n.y - 1))))

    if (correct) {
      CORRECTION <- switch(alternative, two.sided = sign(z) *
                             0.5, greater = 0.5, less = -0.5)
      METHOD <- paste(METHOD, "with continuity correction")
    }

    z <- (z - CORRECTION)/SIGMA

    PVAL <- switch(alternative, less = pnorm(z),
                   greater = pnorm(z, lower.tail = FALSE),
                   two.sided = 2 * min(pnorm(z),
                                       pnorm(z, lower.tail = FALSE)))

    if (exact && TIES)
      warning("cannot compute exact p-value with ties")

  }

  names(mu) <- ifelse (paired || !is.null(y), "location shift", "location")

  RVAL <- list(statistic = STATISTIC,
               parameter = NULL, p.value = as.numeric(PVAL),
               null.value = mu, alternative = alternative, method = METHOD,
               data.name = DNAME)

  class(RVAL) <- "htest"

  return(c(score=RVAL$statistic, p_value=RVAL$p.value))

}

test_that("wilcox_rowscore returns correct results", {
  
  mat <- matrix(c(1,0,1,0,0,0,0,0,1,0, 
                  0,0,1,0,1,0,1,0,0,0,
                  0,0,0,0,1,0,1,0,1,0), nrow=3)
  
  colnames(mat) <- 1:10
  row.names(mat) <- c("TP_1", "TP_2", "TP_3")
  
  set.seed(42)
  input_score = rnorm(n = ncol(mat))
  names(input_score) <- colnames(mat)
  
  result <- wilcox_rowscore(
    FS = mat, 
    input_score = input_score, 
    meta_feature = NULL,
    alternative = "less"
  )
  
  testthat::expect_length(result, 3L)
  testthat::expect_type(result, "double")
  testthat::expect_identical(result, c(TP_1=3, TP_2=13,TP_3=5))
  
})

## --------------------------------------------------- ##
test_that("wilcox_rowscore issues error messages when needed", {
  
  FS <-  data.frame(a = rnorm(10), b = rnorm(10))
  set.seed(42)
  input_score = rnorm(n = ncol(FS))
  names(input_score) <- colnames(FS)
  
  expect_error( 
    wilcox_rowscore(
      FS = FS,  
      input_score = input_score,
      meta_feature = NULL
    )
  )
  
})


## --------------------------------------------------- ##
test_that("wilcox_score issues correct errors", {
  
  row <- c(1, 0, 1, 0, 0, 0, 0, 0, 1, 0)
  ranks <- 1:length(row)
  x = ranks[which(row == 1)]
  y = ranks[which(row == 0)]
  
  mu = NA
  expect_error(wilcox_score(x, y, mu))
  
  mu = 0
  expect_error(wilcox_score(x=c(), y, mu))
  expect_error(wilcox_score(x=x, y=c(), mu))
  
})
  
## --------------------------------------------------- ##
test_that("wilcox_score returns correct results", {
  
  row <- c(1, 0, 1, 0, 0, 0, 0, 0, 1, 0)
  ranks <- 1:length(row)
  x = ranks[which(row == 1)]
  y = ranks[which(row == 0)]
  mu = 0
  
  result <- wilcox_score(x=x, y=y, mu=mu)
  expect_named(result, c("score.W", "p_value"))
  expect_equal(result[1], c("score.W"=7.0))
  
  expect_equal(result[2], 
               c("p_value"= pnorm( (7 - 21/2 + 0.5)/sqrt(21 * 11/12))))
  
})

N <- 100 # number of observations
SD <- 1  # noise
MU <- 0  # mean of independent variables
         # conditional probability table
         # P(Z=1| X,Y == {00,01,10,11})
CPT <- c("00"=.1,"01"=.5,"10"=.3,"11"=.7) 
PATH <- file.path(".")

## Xc --> Zc <-- Yc
## all continuous
set.seed(123)
Xc <- rnorm(N, mean = MU, sd = SD)
Yc <- rnorm(N, mean = MU, sd = SD)
Zc_XcYc <- rnorm(N, mean = Xc+Yc, sd = SD)

## Xd --> Wc <-- Yc
## mixed discrete/continuous
set.seed(456)
Xd <- sample(c(0,1),size = N, replace = TRUE)
Wc_XdYc <- rnorm(N, mean = Xd + Yc, sd = SD)

## Xd --> Zd <-- Yd
## all discrete

## create conditional probability table P(Zd | Xd, Yd)
##
## generate data
set.seed(789)
Yd <- sample(c(0,1),size = N, replace = TRUE)
probs <- data.frame(Xd, Yd, XY = sprintf("%d%d", Xd, Yd)) |>
  dplyr::mutate(P1 = CPT[XY]) |>
  dplyr::mutate(P0 = 1 - P1)
head(probs)

set.seed(987)
Zd_XdYd <- apply(probs |> dplyr::select(P0,P1),1,function(P) sample(c(0,1),size=1,prob=P))

## Xd --> Zc <-- Yd
## continuous child, discrete parents
set.seed(654)
Zc_XdYd <- rnorm(N,mean = Xd + Yd, sd = SD)

toyDF <- data.frame(
  Xc, Yc, Zc_XcYc, Xd, Wc_XdYc, Yd, Zd_XdYd, Zc_XdYd
)
## marginal correlations
print(as.dist(round(cor(toyDF),3)))
## partial correlations for Xc --> Zc <-- Yc
print(as.dist(ppcor::pcor(toyDF |> dplyr::select(Xc,Yc,Zc_XcYc))$estimate))
## partial correlations for Xd --> Wc <-- Yc
print(as.dist(ppcor::pcor(toyDF |> dplyr::select(Xd,Yc,Wc_XdYc))$estimate))
## partial correlations for Xd --> Zd <-- Yd
print(as.dist(ppcor::pcor(toyDF |> dplyr::select(Xd,Yd,Zd_XdYd))$estimate))
## partial correlations for Xd --> Zc <-- Yd
print(as.dist(ppcor::pcor(toyDF |> dplyr::select(Xd,Yd,Zc_XdYd))$estimate))
## partial correlations of any two variables conditioned on all the others
print(as.dist(ppcor::pcor(toyDF)$estimate))

## save toy dataset
saveRDS(toyDF, file = file.path(PATH,"toy_dataset.rds"))
write.csv(toyDF, file = file.path(PATH,"toy_dataset.csv"))

#' Top 'N' Plot
#'
#' Generate a heatmap representation of overlapping meta-features across
#' top N feature searches using \code{candidate_search} function
#' @param topn_list a list of objects obtained from \code{candidate_search} 
#' using the following parameters: \code{FS = sim_FS}, 
#' \code{input_score = sim_Scores}, \code{top_N = 7}, 
#' \code{method = "ks_pval"}, \code{alternative = "less"}, 
#' \code{search_method = "both"}, \code{max_size = 10},
#' and \code{best_score_only = FALSE}.
#'
#' @return a heatmap of overlapping meta-features across top N 
#' feature searches
#' 
#' @examples
#'
#' # Load pre-computed Top-N list generated for sim_FS dataset
#' data(topn_list)
#'
#' # Get the overlapping top N plot
#' topn_plot(topn_list = topn_list)
#'
#' @export
#' @import gplots
#' @importFrom graphics legend
topn_plot <- function(
    topn_list
){

  # Get feature_set and best scores for top n features
  feature_set_l <- lapply(seq_along(topn_list),
                   function(l){ topn_list[[l]][['feature_set']] })
  
  scores_l <- lapply(seq_along(topn_list),
                     function(l){ topn_list[[l]][['score']] })

  # Get the list of feature names from each FS object
  f_list <- lapply(feature_set_l, rownames)

  # Get the union of all features that were returned across all top N runs
  f_union <- Reduce(f = union, f_list)

  f_checklist <- lapply(f_list, function(x, ref = f_union){
    return(f_union %in% x)
  })

  # Working with scores for each top N run
  scores <- unlist(scores_l)
  
  # Make a matrix indicating which features are found across each top n run
  mat <- do.call(cbind, f_checklist)*1
  
  # Assign row and column names to mat
  colnames(mat) <- names(scores)
  rownames(mat) <- f_union  
  
  if(ncol(mat) >= 2){
    
    # If ncol(mat) > 1, we can order matrix columns in decreasing order
    mat <- mat[, order(scores, decreasing = TRUE)]
    
    # Add index number and its best score to each of the columns names of mat
    colnames(mat) <- paste(colnames(mat), " [", seq(1, ncol(mat)), "] ",
                         round(scores,3), sep="")
    
    # Color all the overlapping features as red and others as white
    colcode <-
      if (all(mat == 1)) c("firebrick2", "white") else c("white", "firebrick2")
    
    verbose("Generating top N overlap heatmap...\n")
    
    # Create the overlapping heatmap
    heatmap.2(
      x = mat,
      col = colcode,
      Colv = FALSE,
      dendrogram = "none",
      margins = c(10,10),
      cexRow = 0.7,
      cexCol = 0.7,
      cex.main = 0.8,
      key = FALSE,
      trace = "none",
      sepwidth = c(0.1,0.1),
      sepcolor = "grey90",
      colsep = seq_len(ncol(mat)),
      rowsep = seq_len(nrow(mat))
    )
    
    legend(
      "topleft",
      legend=c("Present","Absent"),
      fill=c("firebrick2","white"),
      bty="n"
    )
    
  }else{
    
    warning("Cannot plot overlap matrix for N = 1. ",
            "Please use a larger value for evaluating top N visualization.")
    
  }
}

#' CaDrA Search
#'
#' Perform permutation-based testings on a sample of permuted input scores
#' using \code{candidate_search} as the main iterative function for each run.
#'
#' @param FS a matrix of binary features or a SummarizedExperiment class object
#' from SummarizedExperiment package where rows represent features of interest
#' (e.g. genes, transcripts, exons, etc...) and columns represent the samples.
#' The assay of FS contains binary (1/0) values indicating the presence/absence
#' of omics features.
#' @param input_score a vector of continuous scores representing a phenotypic
#' readout of interest such as protein expression, pathway activity, etc.
#'
#' NOTE: \code{input_score} object must have names or labels that match
#' the column names of \code{FS} object.
#' @param method a character string specifies a scoring method that is
#' used in the search. There are 6 options: (\code{"ks_pval"} or \code{ks_score}
#' or \code{"wilcox_pval"} or \code{wilcox_score} or
#' \code{"revealer"} (conditional mutual information from REVEALER) or
#' \code{"knnmi"} (K-Nearest Neighbor Mutual Information Estimator from knnmi) or
#' \code{"correlation"} or
#' \code{"custom"} (a user-defined scoring method)).
#' Default is \code{ks_pval}.
#' @param method_alternative a character string specifies an alternative
#' hypothesis testing (\code{"two.sided"} or \code{"greater"} or \code{"less"}).
#' Default is \code{less} for left-skewed significance testing.
#'
#' NOTE: This argument only applies to \code{ks_pval} and \code{wilcox_pval}
#' method
#' @param cmethod correlation method to use - spearman or pearson. 
#' Default is "spearman".
#' 
#' NOTE: This argument only applies to \code{correlation} method
#' @param custom_function If method is \code{"custom"}, specifies
#' a user-defined function here. Default is \code{NULL}.
#'
#' NOTE: \code{custom_function} must take \code{FS} and \code{input_score}
#' as its input arguments and its final result must return a vector of row-wise
#' scores where its labels or names match the row names of \code{FS} object.
#' @param custom_parameters If method is \code{"custom"}, specifies a list of
#' additional arguments (excluding \code{FS} and \code{input_score}) to be
#' passed to \code{custom_function}. For example:
#' custom_parameters = list(alternative = "less"). Default is \code{NULL}.
#' @param weights If method is \code{ks_score} or \code{ks_pval}, specifying a
#' vector of weights will perform a weighted-KS testing. Default is \code{NULL}.
#'
#' NOTE: \code{weights} must have names or labels that match the labels of
#' \code{input_score}.
#' @param search_start a vector of character strings (separated by commas)
#' specifies feature names in the FS object to start the search with.
#' If \code{search_start} is provided, then \code{top_N} parameter will be
#' ignored and vice versa. Default is \code{NULL}.
#' @param top_N an integer specifies the number of features to start the
#' search over. By default, it starts with the feature that has the highest
#' best score (top_N = 1).
#'
#' NOTE: If \code{top_N} is provided, then \code{search_start} parameter
#' will be ignored and vice versa. If top_N > 10, it may result in a longer
#' search time.
#' @param search_method a character string specifies an algorithm to filter out
#' the best candidates (\code{"forward"} or \code{"both"}). Default is
#' \code{both} (i.e., backward and forward).
#' @param max_size an integer specifies a maximum size that a meta-feature can
#' extend to do for a given search. Default is \code{7}.
#' @param n_perm an integer specifies the number of permutations to perform.
#' Default is \code{1000}.
#' @param perm_alternative an alternative hypothesis type for calculating
#' permutation-based p-value. Options: one.sided, two.sided. Default is
#' \code{one.sided}.
#' @param obs_best_score a numeric value corresponding to the best observed
#' score. This value is used to compare against the \code{n_perm} calculated best
#' scores. Default is \code{NULL}. If set to NULL, we will compute the observed
#' best score based on the given parameters.
#' @param smooth a logical value indicates whether or not to add a smoothing
#' factor of 1 to the calculation of permutation-based p-value. This option is
#' used to avoid a returned p-value of 0. Default is \code{TRUE}.
#' @param plot a logical value indicates whether or not to plot the empirical
#' null distribution of the permuted best scores. Default is \code{FALSE}.
#' @param ncores an integer specifies the number of cores to perform
#' parallelization for permutation-based testing. Default is \code{1}.
#' @param cache a logical value determines whether or not to cache the
#' permuted best scores. This helps to save time for future loading instead
#' of re-computing the permutation-based testing every time.
#' Default is \code{FALSE}.
#' @param cache_path a path to cache permuted best scores. Default is \code{NULL}.
#' If NULL, the cache path is set to system home directory
#' (e.g. \code{$HOME/.Rcache}) for future loading.
#' @param verbose a logical value indicates whether or not to print the
#' diagnostic messages. Default is \code{FALSE}.
#'
#' @return a list of 4 objects: \code{key}, \code{perm_best_scores},
#' \code{obs_best_score}, \code{perm_pval}
#'
#' -\code{key}: a list of parameters that was used to cache the
#' results of the permutation-based testing. This is useful as the
#' permuted best scores can be recycled to save time for future loading.
#'
#' -\code{perm_best_scores}: a vector of permuted best scores obtained
#' by performing \code{candidate_search} over \code{n_perm} iterations of
#' permuted input scores.
#'
#' -\code{obs_best_score}: a user-provided best score or an observed best score
#' obtained by performing \code{candidate_search} on a given dataset and input
#' parameters. This value is later used to compare against the permuted best
#' scores (\code{perm_best_scores}).
#'
#' \code{perm_pval}: a permutation-based p-value obtained by calculating
#' sum(perm_best_scores > obs_best_score)/n_perm
#'
#' NOTE: If smooth = TRUE, a smoothing factor of 1 will be added to the
#' calculation of \code{perm_pval}.
#'
#' e.g. (sum(perm_best_scores > obs_best_score) + 1) / (n_perm + c)
#'
#' This is just to not return a p-value of 0
#'
#' @examples
#'
#' # Load pre-computed feature set
#' data(sim_FS)
#'
#' # Load pre-computed input-score
#' data(sim_Scores)
#'
#' # Set seed for permutation
#' set.seed(21)
#'
#' # Define additional parameters and start the search function
#' cadra_result <- CaDrA(
#'   FS = sim_FS, input_score = sim_Scores, method = "ks_pval",
#'   weights = NULL, method_alternative = "less", top_N = 1,
#'   search_start = NULL, search_method = "both", max_size = 7,
#'   n_perm = 10, perm_alternative = "one.sided", plot = FALSE,
#'   smooth = TRUE, obs_best_score = NULL,
#'   ncores = 1, cache = FALSE, cache_path = NULL
#' )
#'
#' @export
#' @import R.cache doParallel ggplot2 plyr methods SummarizedExperiment
#'
CaDrA <- function(
    FS,
    input_score,
    method = c("ks_pval", "ks_score", "wilcox_pval", "wilcox_score",
               "revealer", "knnmi", "correlation", "custom"),
    method_alternative = c("less", "greater", "two.sided"),
    cmethod = c("spearman", "pearson"),
    custom_function = NULL,
    custom_parameters = NULL,
    weights = NULL,
    search_start = NULL,
    top_N = 1,
    search_method = c("both", "forward"),
    max_size = 7,
    n_perm = 1000,
    perm_alternative = c("one.sided", "two.sided"),
    obs_best_score = NULL,
    smooth = TRUE,
    plot = FALSE,
    ncores = 1,
    cache = FALSE,
    cache_path = NULL,
    verbose = FALSE
){

  # Set up verbose option
  options(verbose = verbose)

  # Match arguments
  method <- match.arg(method)
  method_alternative <- match.arg(method_alternative)
  search_method <- match.arg(search_method)
  perm_alternative <- match.arg(perm_alternative)

  if (method == "correlation") {
    cmethod <- match.arg(cmethod)
  }
  
  # Check n_perm
  stopifnot("invalid number of permutations (nperm)"=
              (length(n_perm)==1 && !is.na(n_perm) &&
                 is.numeric(n_perm) && n_perm > 0) )

  # Check ncores
  stopifnot("invalid number of CPU cores (ncores)"=
              (length(ncores)==1 && !is.na(ncores) &&
                 is.numeric(ncores) && ncores > 0) )

  # Retrieve the original class object of feature set
  # If FS is a SummarizedExperiment, convert it to a matrix object
  # used its matrix form as a default caching key
  if(is(FS, "SummarizedExperiment"))
    FS <- SummarizedExperiment::assay(FS)

  # Define the key for each cached result
  key <- list(FS = FS,
              input_score = if(method %in% c("revealer", "custom"))
              { input_score } else { NULL },
              method = method,
              method_alternative = method_alternative,
              cmethod = if(method %in% c("correlation"))
              { cmethod } else { NULL },
              custom_function = custom_function,
              custom_parameters = custom_parameters,
              weights = weights,
              top_N = top_N,
              search_start = search_start,
              search_method = search_method,
              max_size = max_size)

  ####### CACHE CHECKING #######

  # Set cache root path
  if(is.null(cache_path)){
    cache_path <- file.path(Sys.getenv("HOME"), ".Rcache")
    dir.create(cache_path, showWarnings = FALSE)
  }

  R.cache::setCacheRootPath(cache_path)

  if(cache == TRUE){

    message("Setting cache root path as: ", cache_path, "\n")

    # Load perm_best_scores with the given key parameters
    perm_best_scores <- R.cache::loadCache(key)

  }else{

    perm_best_scores <- NULL

  }

  # Start the 'clock' to see how long the process takes
  ptm <- proc.time()

  # Check if, given the dataset and search-specific parameters,
  # there is already a cached null distribution available
  n_perm <-  as.integer(n_perm)

  if(!is.null(perm_best_scores) & (length(perm_best_scores) >= n_perm)){

    if(length(perm_best_scores) == n_perm){
      verbose("Found ", length(perm_best_scores),
              " permutated scores for the specified dataset",
              " and search parameters in cache path\n")
      verbose("LOADING PERMUTATED SCORES FROM CACHE\n")
    }else{
      verbose("n_perm is set to ", n_perm, " but found ",
              length(perm_best_scores),
              " permutated scores for the specified dataset",
              " and search parameters in cache path\n")
      verbose("LOADING LARGER PERMUTATED SCORES FROM CACHE\n")
    }

  }else{

    if(is.null(perm_best_scores)){
      verbose("No permutated scores for the specified dataset and ",
              "search parameters were found in cache path\n")
      verbose("BEGINNING PERMUTATION-BASED TESTINGS\n")
    }else if (length(perm_best_scores) < n_perm) {
      verbose("n_perm is set to ", n_perm, " but found only ",
              length(perm_best_scores),
              " permutated scores for the specified dataset",
              " and search parameters in cache path\n")
      verbose("RE-COMPUTE PERMUTATION-BASED TESTINGS ",
              "WITH LARGER NUMBER OF PERMUTATIONS\n")
    }

    #######################################################################

    # Check ncores
    ncores <-  as.integer(ncores)

    # Sets up the parallel backend which will be utilized by Plyr.
    parallel <- FALSE
    progress <- "text"

    if(ncores > 1){
      doParallel::registerDoParallel(cores = ncores)
      parallel <- TRUE
      progress <- "none"
      verbose("Running tests in parallel...")
    }

    # Generate matrix of permuted input_score
    perm_labels_matrix <- generate_permutations(
      input_score = input_score,
      n_perm = n_perm
    )

    # Run permutation-based testing
    perm_best_scores_l <- plyr::alply(
      perm_labels_matrix,
      1,
      function(x){

        perm_input_score <- x
        names(perm_input_score) <- colnames(perm_labels_matrix)

        best_score <- candidate_search(
          FS = FS,
          input_score = perm_input_score,
          method_alternative = method_alternative,
          method = method,
          cmethod = cmethod,
          custom_function = custom_function,
          custom_parameters = custom_parameters,
          weights = weights,
          search_start = search_start,
          top_N = top_N,
          search_method = search_method,
          max_size = max_size,
          best_score_only = TRUE,
          do_plot = FALSE,
          verbose = FALSE
        )

        return(best_score)

      },
      .parallel = parallel,
      .progress = progress)

    # Set up verbose option
    options(verbose = verbose)

    # Extract the permuted best scores
    perm_best_scores <- lapply(
      seq_along(perm_best_scores_l),
      function(l){ perm_best_scores_l[[l]] }) |> unlist()

    # Save computed scores to cache
    verbose("Saving to cache...\n")
    R.cache::saveCache(perm_best_scores, key=key)

  } # end caching else statement block

  # Return to using just a single core
  doParallel::registerDoParallel(cores = 1)

  verbose("FINISHED\n")
  verbose("Time elapsed: ", round((proc.time()-ptm)[3]/60, 2), " mins \n\n")

  #########################################################################

  if(is.null(obs_best_score)){

    verbose("Computing observed best score...\n\n")

    obs_best_score <- candidate_search(
      FS = FS,
      input_score = input_score,
      method = method,
      method_alternative = method_alternative,
      cmethod = cmethod,
      custom_function = custom_function,
      custom_parameters = custom_parameters,
      weights = weights,
      search_start = search_start,
      top_N = top_N,
      search_method = search_method,
      max_size = max_size,
      best_score_only = TRUE,
      do_plot = FALSE,
      verbose = FALSE
    ) |> unlist()

  }else{

    # Check obs_best_score
    stopifnot("Invalid observed best score (obs_best_score)"=
                (length(obs_best_score)==1 && !is.na(obs_best_score) &&
                   is.numeric(obs_best_score)))

    verbose("Using provided value of observed best score...\n")

    obs_best_score <- as.numeric(obs_best_score)

  }

  # Set up verbose option
  options(verbose = verbose)

  verbose("Observed score: ", obs_best_score, "\n")

  ########### PERMUTATION P-VALUE COMPUTATION ############

  #Add a smoothing factor of 1 if smooth is specified
  #This is just to not return a p-value of 0
  c <- 0
  if(smooth) c <- 1

  onesided_perm_pval <- (sum(perm_best_scores > obs_best_score) + c)/
    (length(perm_best_scores) + c)

  if(perm_alternative == "two.sided"){
    perm_pval <- 2*min(onesided_perm_pval, 1-onesided_perm_pval)
  }else{
    perm_pval <- onesided_perm_pval
  }

  verbose("Permutation p-value: ", perm_pval, "\n")
  verbose("Number of permutations: ", length(perm_best_scores), "\n")

  ########### END PERMUTATION P-VALUE COMPUTATION ############
  perm_res <- list(
    key = key,
    perm_best_scores = perm_best_scores,
    obs_best_score = obs_best_score,
    perm_pval = perm_pval
  )

  # If plot = TRUE, produce the permutation plot
  if(plot == TRUE){
    permutation_plot(perm_res = perm_res)
  }

  return(perm_res)

}

test_that("CaDrA returns expected result for KS algorithm",{
  
  # Load pre-computed feature set
  data(sim_FS)
  
  # Load pre-computed input-score
  data(sim_Scores)
  
  # Set seed
  set.seed(21)
  
  # ks_pval
  result <- CaDrA(
    FS = sim_FS, 
    input_score = sim_Scores, 
    method = "ks_pval", 
    method_alternative = "less", 
    weights = NULL, 
    top_N = 1,
    search_start = NULL, 
    search_method = "both", 
    max_size = 7, 
    n_perm = 10, 
    plot = FALSE, 
    smooth = TRUE, 
    obs_best_score = NULL,
    ncores = 1, 
    cache = FALSE,
    cache_path = NULL
  )
  
  testthat::expect_length(result, 4L)
  testthat::expect_type(result, "list")
  testthat::expect_named(result, c("key","perm_best_scores","obs_best_score","perm_pval"))
  testthat::expect_equal(round(result$perm_best_scores[1:10], 5), 
                         c('TN_780'=3.85692,
                           'TN_989'=4.24386,
                           'TN_974'=4.64671,
                           'TN_271'=4.46158,
                           'TN_427'=5.7888,
                           'TN_983'=4.83556,
                           'TN_170'=4.59927,
                           'TN_669'=4.40737,
                           'TN_605'=4.50667,
                           'TN_874'=3.60332))
  testthat::expect_equal(round(result$obs_best_score, 5), c("TP_8"=14.13128))
  
  # A smooth factor of 1
  c <- 1
  
  # Add a smoothing factor of 1 
  # This is just to not return a p-value of 0
  testthat::expect_equal(
    round((sum(result$perm_best_scores[1:10] > result$obs_best_score)+c)/(10+c), 7), 
    c(0.0909091)
  )
  
})

# ========================================================================= #
test_that("CaDrA returns expected result for Wilcoxon algorithm",{
  
  # Load pre-computed feature set
  data(sim_FS)
  
  # Load pre-computed input-score
  data(sim_Scores)
  
  # Set seed
  set.seed(21)
  
  # wilcox_pval
  result <- CaDrA(
    FS = sim_FS, 
    input_score = sim_Scores, 
    method = "wilcox_pval", 
    method_alternative = "less", 
    weights = NULL, 
    top_N = 1,
    search_start = NULL, 
    search_method = "both", 
    max_size = 7, 
    n_perm = 10, 
    plot = FALSE, 
    smooth = TRUE, 
    obs_best_score = NULL,
    ncores = 1, 
    cache = FALSE,
    cache_path = NULL
  )
  
  testthat::expect_length(result, 4L)
  testthat::expect_type(result, "list")
  testthat::expect_named(result, c("key","perm_best_scores","obs_best_score","perm_pval"))
  testthat::expect_equal(round(result$perm_best_scores[1:10], 5), 
                         c('TN_780'=14.98171,
                           'TN_97'=16.91855,
                           'TN_974'=22.01412,
                           'TN_271'=19.23964,
                           'TN_141'=19.15244,
                           'TN_315'=19.56755,
                           'TN_689'=16.51065,
                           'TN_413'=20.50307,
                           'TN_940'=20.42022,
                           'TN_894'=17.80290))
  testthat::expect_equal(round(result$obs_best_score, 5), c("TN_129"=21.35299))
  
  # A smooth factor of 1
  c <- 1
  
  # Add a smoothing factor of 1 
  # This is just to not return a p-value of 0
  testthat::expect_equal(
    round((sum(result$perm_best_scores[1:10] > result$obs_best_score)+c)/(10+c), 6), 
    c(0.181818)
  )
  
})


# ========================================================================= #
test_that("CaDrA returns expected result for Revealer algorithm", {
  
  # Load pre-computed feature set
  data(sim_FS)
  
  # Load pre-computed input-score
  data(sim_Scores)
  
  # Set seed
  set.seed(21)
  
  # Revealer
  result <- CaDrA(
    FS = sim_FS, 
    input_score = sim_Scores, 
    method = "revealer", 
    method_alternative = "less", 
    weights = NULL, 
    top_N = 1,
    search_start = NULL, 
    search_method = "both", 
    max_size = 7, 
    n_perm = 10, 
    plot = FALSE, 
    smooth = TRUE, 
    obs_best_score = NULL,
    ncores = 1, 
    cache = FALSE,
    cache_path = NULL
  )
  
  testthat::expect_length(result, 4L)
  testthat::expect_type(result, "list")
  testthat::expect_named(result, c("key","perm_best_scores","obs_best_score","perm_pval"))
  testthat::expect_equal(round(result$perm_best_scores[1:10], 7), 
                         c('TN_780'=0.3901349,
                           'TN_97'=0.4065603,
                           'TN_974'=0.3892586,
                           'TN_393'=0.3805595,
                           'TN_369'=0.4212498,
                           'TN_983'=0.4050481,
                           'TN_681'=0.3577511,
                           'TN_125'=0.3747675,
                           'TN_940'=0.3845112,
                           'TN_351'=0.4654268))
  testthat::expect_equal(round(result$obs_best_score, 5), c("TN_985"=0.37856))
  
  # A smooth factor of 1
  c <- 1
  
  # Add a smoothing factor of 1 
  # This is just to not return a p-value of 0
  testthat::expect_equal(
    round((sum(result$perm_best_scores[1:10] > result$obs_best_score)+c)/(10+c), 6), 
    c(0.818182)
  )
  
})

#'
#' Correlation Scoring Method
#'
#' Calculate correlation scores between the input score and a feature set
#'
#' @param FS a matrix of binary features where
#' rows represent features of interest (e.g. genes, transcripts, exons, etc...)
#' and columns represent the samples.
#' @param input_score a vector of continuous scores representing a phenotypic
#' readout of interest such as protein expression, pathway activity, etc.
#' The \code{input_score} object must have names or labels that match the column
#' names of FS object.
#' @param meta_feature a vector of one or more features representing known causes
#' of activation or features associated with a response of interest
#' (\code{e.g. input_score}). Default is NULL.
#' @param corr_method correlation method - Pearson or Spearman. Default is
#' \code{spearman}
#' @return  returns a vector of row-wise scores where its labels or names
#' must match the row names of \code{FS} object
#'
#' @noRd
#'
#' @examples
#' mat <- matrix(c(1,0,1,0,0,0,0,0,1,0,
#'                 0,0,1,0,1,0,1,0,0,0,
#'                 0,0,0,0,1,0,1,0,1,0), nrow=3)
#'
#' colnames(mat) <- 1:10
#' row.names(mat) <- c("TP_1", "TP_2", "TP_3")
#'
#' set.seed(42)
#' input_score = rnorm(n = ncol(mat))
#' names(input_score) <- colnames(mat)
#'
#' corr_rs <- corr_rowscore(
#'    FS = mat,
#'    input_score = input_score,
#'    meta_feature = NULL,
#'    corr_method = "spearman"
#' )
#'
corr_rowscore <- function
(
  FS,
  input_score,
  meta_feature = NULL,
  corr_method = c("spearman", "pearson")
)
{

  corr_method <- match.arg(corr_method)

  # Check if meta_feature is provided
  if(!is.null(meta_feature)){
    # Getting the position of the known meta features
    locs <- match(meta_feature, row.names(FS))

    # Taking the union across the known meta features
    if(length(locs) > 1) {
      meta_vector <- as.numeric(ifelse(colSums(FS[locs,]) == 0, 0, 1))
    }else{
      meta_vector <- as.numeric(FS[locs, , drop=FALSE])
    }

    # Remove the meta features from the binary feature matrix
    # and taking logical OR btw the remaining features with the meta vector
    FS <- base::sweep(FS[-locs, , drop=FALSE], 2, meta_vector, `|`)*1

    # Check if there are any features that are all 1s generated from
    # taking the union between the matrix
    # We cannot compute statistics for such features and thus they need
    # to be filtered out
    if(any(rowSums(FS) == ncol(FS))){
      verbose("Features with all 1s generated from taking the matrix union ",
              "will be removed before progressing...\n")
      FS <- FS[rowSums(FS) != ncol(FS), , drop=FALSE]
      # If no features remained after filtering, exist the function
      if(nrow(FS) == 0) return(NULL)
    }
  }

  # correlation
  scores <- apply(FS, 1, function (x) cor(x, input_score, method = corr_method))

  return(scores)

}

## TESTING THE FOLLOWING FUNCTIONS
##
## mutual_inf_cc_1d
## mutual_inf_cc_2d
## mutual_inf_cd_1d
## mutual_inf_cd_2d
## cond_mutual_inf_ccc_1d
## cond_mutual_inf_cdd_1d
## cond_mutual_inf_ccc_2d
## cond_mutual_inf_cdd_2d
##  
setwd(file.path(Sys.getenv("CBMGIT"),"CaDrA","tests","data"))
N <- 100 # number of observations
SD <- 1  # noise
MU <- 0  # mean of independent variables
PATH <- file.path(".")
do_save <- TRUE

## Xc --> Zc <-- Yc (to test cc_1d and ccc_1d)
## all continuous
set.seed(123)
Xc <- rnorm(N, mean = MU, sd = SD)
Yc <- rnorm(N, mean = MU, sd = SD)
Zc_XcYc <- rnorm(N, mean = Xc + Yc, sd = SD)

## Xc --> Zc <-- Yc,Wc (to test cc_2d and ccc_2d)
## all continuous
Wc <- rnorm(N, mean = MU, sd = SD)
Zc_XcYcWc <- rnorm(N, mean = Xc + Yc + Wc, sd = SD)

## Xd --> Zc <-- Yd
## continuous child, discrete parents (to test cd_1d and cdd_1d)
set.seed(456)
Xd <- sample(c(0, 1), size = N, replace = TRUE)
Yd <- sample(c(0, 1), size = N, replace = TRUE)
Zc_XdYd <- rnorm(N, mean = Xd + Yd, sd = SD)

## Xd --> Zc <-- Yd,Wd
## continuous child, discrete parents (to test cd_2d and cdd_2d)
Wd <- sample(c(0, 1), size = N, replace = TRUE)
Zc_XdYdWd <- rnorm(N, mean = Xd + Yd + Wd, sd = SD)

toyDF <- data.frame(
  Xc, Yc, Wc, Zc_XcYc, Zc_XcYcWc, Xd, Yd, Wd, Zc_XdYd, Zc_XdYdWd
)
## marginal correlations
print(as.dist(round(cor(toyDF),3)))
## partial correlations for Xc --> Zc <-- Yc
print(as.dist(ppcor::pcor(toyDF |> dplyr::select(Xc,Yc,Zc_XcYc))$estimate))
## partial correlations for Xc --> Zc <-- Yc,Wc
print(as.dist(ppcor::pcor(toyDF |> dplyr::select(Xc,Yc,Wc,Zc_XcYcWc))$estimate))
## partial correlations for Xd --> Zc <-- Yd
print(as.dist(ppcor::pcor(toyDF |> dplyr::select(Xd,Yd,Zc_XdYd))$estimate))
## partial correlations for Xd --> Zc <-- Yd,Wd
print(as.dist(ppcor::pcor(toyDF |> dplyr::select(Xd,Yd,Wd,Zc_XdYdWd))$estimate))
## partial correlations of any two variables conditioned on all the others
print(as.dist(ppcor::pcor(toyDF)$estimate))

## save toy dataset
if (do_save) {
  saveRDS(toyDF, file = file.path(PATH,"toy_dataset.rds"))
  write.csv(toyDF, file = file.path(PATH,"toy_dataset.csv"))
}

#' Transcriptional Activity of Beta-Catenin in Cancers
#'
#' A vector of continuous scores represents the activation of B-catenin across
#' multiple cancer cell lines
#'
#' @docType data
#'
#' @usage data(CTNBB1_reporter)
#'
#' @format Consists of a vector of continuous scores of B-catenin
#' activity across 82 cancer cell lines. The mutation and copy number 
#' associated with this sample cohorts can be found in 
#' \code{CCLE_MUT_SCNA} dataset.
#' 
#' @return a vector of continuous scores
#' 
#' @references Kim, J., Botvinnik, O., Abudayyeh, O. et al.
#' Characterizing genomic alterations in cancer by complementary
#' functional associations.
#' Nat Biotechnol 34, 539–546 (2016).
#' \href{https://doi.org/10.1038/nbt.3527}{https://doi.org/10.1038/nbt.3527}
#'
"CTNBB1_reporter"

#' Simulated Input Scores
#'
#' A simulated vector of continuous scores generated from 
#' \code{rnorm(n=ncol(sim_FS), mean=0, sd=1)} with \code{set.seed(123)} 
#' based on the number of samples in the
#' simulated dataset (sim_FS)
#'
#' @docType data
#'
#' @usage data(sim_Scores)
#'
#' @format A vector of continuous scores randomly generated 
#' from \code{rnorm(n=ncol(sim_FS), mean=0, sd=1)} with \code{set.seed(123)} 
#' based on the number of samples in the
#' simulated dataset (sim_FS)
#' 
#' @return a vector of continuous scores
#' 
#' @references Kartha VK, Kern JG, Sebastiani P, Zhang L,
#' Varelas X, Monti S (2019) CaDrA: A computational framework for performing
#' candidate driver analyses using binary genomic features.
#' (\href{https://www.frontiersin.org/articles/10.3389/fgene.2019.00121/full}{Frontiers in Genetics})
#'
"sim_Scores"

#' Top-N Results for Simulated Data (\code{sim_FS})
#'
#' A list of objects returned from \code{candidate_search} 
#' using simulated dataset \code{FS = sim_FS}, \code{input_score = sim_Scores}, 
#' \code{top_N = 7}, \code{method = "ks_pval"}, \code{alternative = "less"}, 
#' \code{search_method = "both"}, \code{max_size = 10}, and 
#' \code{best_score_only = FALSE}.
#' 
#' NOTE: \code{max_size} is set to 10 as we would like to account
#' for the presence of 10 left-skewed (i.e. true positive or TP) features 
#' in \code{sim_FS} dataset.
#'
#' @docType data
#'
#' @usage data(topn_list)
#'
#' @format A list of objects returned from \code{candidate_search} including 
#' a set of best meta-feature matrix, its corresponding best score, its 
#' observed input scores, rank of the best features based on their scores, 
#' marginal best scores, and cumulative best scores. pertaining to each 
#' top N feature searches.
#' 
#' See \code{\link[CaDrA]{candidate_search}} for more information.
#' 
#' @return a list of objects returned from \code{candidate_search} function
#'
#' @references Kartha VK, Kern JG, Sebastiani P, Zhang L,
#' Varelas X, Monti S (2019) CaDrA: A computational framework for performing
#' candidate driver analyses using binary genomic features.
#' (\href{https://www.frontiersin.org/articles/10.3389/fgene.2019.00121/full}{Frontiers in Genetics})
#'
#' @examples
#'
#' # Load pre-computed Top-N list generated for sim_FS and sim_Scores dataset
#' data(topn_list)
#'
#' # Fetch the first meta-feature
#' topn_list[[1]]$feature_set
#'
#' # Fetch the second meta-feature
#' topn_list[[2]]$feature_set
#'
#' # Retrieve the meta-feature with the best score among top_N = 7 runs
#' topn_best_meta <- topn_best(topn_list = topn_list)
#'
#' # Visualize the best meta-feature using meta_plot function
#' meta_plot(topn_best_list = topn_best_meta)
#'
#' # Visualize overlap of meta-features across top_N = 7 
#' # using topn_plot function
#' topn_plot(topn_list = topn_list)
#'
"topn_list"

#' YAP/TAZ Activity in TCGA BRCA dataset
#'
#' A vector of continuous scores represents oncogenic YAP/TAZ activity
#' in human breast carcinomas
#'
#' @docType data
#'
#' @usage data(TAZYAP_BRCA_ACTIVITY)
#'
#' @format consists of a vector of continuous scores of YAP/TAZ activity
#' across 951 profiles. The mutation and copy number associated with this sample
#' cohorts can be found in \code{BRCA_GISTIC_MUT_SIG} dataset.
#' 
#' @return a vector of continuous scores
#' 
#' @references Kartha VK, Kern JG, Sebastiani P, Zhang L,
#' Varelas X, Monti S (2019) CaDrA: A computational framework for performing
#' candidate driver analyses using binary genomic features.
#' (\href{https://www.frontiersin.org/articles/10.3389/fgene.2019.00121/full}{Frontiers in Genetics})
#'
"TAZYAP_BRCA_ACTIVITY"

#' Genomic Data from TCGA BRCA MUT + GISTIC
#'
#' A SummarizedExperiment object consists of 16,873 genomic features 
#' across 951 samples.
#'
#' @docType data
#'
#' @usage data(BRCA_GISTIC_MUT_SIG)
#'
#' @format An object of class \code{SummarizedExperiment} from 
#' \code{SummarizedExperiment} package
#' containing an assay of 16,873 rows (features) and 951 columns (samples)
#' see \code{SummarizedExperiment} for more details.
#' 
#' @return a SummarizedExperiment object
#' 
#' @references Kartha VK, Kern JG, Sebastiani P, Zhang L,
#' Varelas X, Monti S (2019) CaDrA: A computational framework for performing
#' candidate driver analyses using binary genomic features.
#' (\href{https://www.frontiersin.org/articles/10.3389/fgene.2019.00121/full}{Frontiers in Genetics})
#'
"BRCA_GISTIC_MUT_SIG"

## ----set.up, include=FALSE, messages=FALSE, warnings=FALSE--------------------
knitr::opts_chunk$set(message=FALSE, collapse = TRUE, comment="")

# R packages
library(devtools)
load_all()

## ----load.data----------------------------------------------------------------
# Load pre-simulated feature set 
# See ?sim_FS for more information
data(sim_FS)

# Load pre-computed input-score
# See ?sim_Scores for more information
data(sim_Scores)

## ----ks.method----------------------------------------------------------------
candidate_search_res <- CaDrA::candidate_search(
  FS = sim_FS,
  input_score = sim_Scores,
  method = "ks_pval",          # Use Kolmogorow-Smirnow scoring function 
  method_alternative = "less", # Use one-sided hypothesis testing
  weights = NULL,              # If weights is provided, perform a weighted-KS test
  search_method = "both",      # Apply both forward and backward search
  top_N = 7,                   # Number of top features to kick start the search
  max_size = 10,               # Allow at most 10 features in meta-feature matrix
  best_score_only = FALSE      # Return all results from the search
)

## ----ks.meta.plot-------------------------------------------------------------
# Extract the best meta-feature result
topn_best_meta <- CaDrA::topn_best(topn_list = candidate_search_res)

# Visualize meta-feature result
CaDrA::meta_plot(topn_best_list = topn_best_meta)

## -----------------------------------------------------------------------------
# Set seed for permutation-based testing
set.seed(123)

perm_res <- CaDrA::CaDrA(
  FS = sim_FS, 
  input_score = sim_Scores, 
  method = "ks_pval",             # Use Kolmogorow-Smirnow scoring function 
  method_alternative = "less",    # Use one-sided hypothesis testing
  weights = NULL,                 # If weights is provided, perform a weighted-KS test
  search_method = "both",         # Apply both forward and backward search
  top_N = 7,                      # Repeat the search with the top N features
  max_size = 10,                  # Allow at most 10 features in the meta-feature matrix
  n_perm = 100,                   # Number of permutations to perform
  perm_alternative = "one.sided", # One-sided permutation-based p-value alternative type
  plot = FALSE,                   # We will plot later
  ncores = 2                      # Number of cores to perform parallelization
)

## ----ks.permutation.plot------------------------------------------------------
# Visualize permutation results
permutation_plot(perm_res = perm_res)

## ----RsessionInfo-------------------------------------------------------------
sessionInfo()

---
title: "Permutation-Based Testing"
output: rmarkdown::html_document
vignette: >
  %\VignetteIndexEntry{Permutation-Based Testing}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r set.up, include=FALSE, messages=FALSE, warnings=FALSE}
knitr::opts_chunk$set(message=FALSE, collapse = TRUE, comment="")

# R packages
library(devtools)
load_all()
```

By default, **CaDrA** performs both forward and backward search algorithm to look for a subset of features whose union is maximally associated with an outcome of interest, based on (currently) one of four scoring functions (**Kolmogorov-Smirnov**, **Conditional Mutual Information**, **Wilcoxon**, and **custom-defined**). To test whether the strength of the association between the set of features and the observed input scores (e.g., pathway activity, drug sensitivity, etc.) is greater than it would be expected by chance, **CaDrA** supports permutation-based significance testing. Importantly, the permutation test iterates over the entire search procedure (e.g., if `top_N = 7`, each permutation iteration will consist of running the search over the top 7 features).

# Load packages

```r
library(CaDrA)
```

# Load required datasets

1. A `binary features matrix` also known as `Feature Set` (such as somatic mutations, copy number alterations, chromosomal translocations, etc.) The 1/0 row vectors indicate the presence/absence of ‘omics’ features in the samples. The `Feature Set` can be a matrix or an object of class **SummarizedExperiment** from **SummarizedExperiment** package) 
2. A vector of continuous scores (or `Input Scores`) representing a functional response of interest (such as protein expression, pathway activity, etc.)

```{r load.data}
# Load pre-simulated feature set 
# See ?sim_FS for more information
data(sim_FS)

# Load pre-computed input-score
# See ?sim_Scores for more information
data(sim_Scores)
```

# Find a subset of features that maximally associated with a given outcome of interest

Here we are using **Kolmogorow-Smirnow** (KS) scoring method to search for best features

```{r ks.method}
candidate_search_res <- CaDrA::candidate_search(
  FS = sim_FS,
  input_score = sim_Scores,
  method = "ks_pval",          # Use Kolmogorow-Smirnow scoring function 
  method_alternative = "less", # Use one-sided hypothesis testing
  weights = NULL,              # If weights is provided, perform a weighted-KS test
  search_method = "both",      # Apply both forward and backward search
  top_N = 7,                   # Number of top features to kick start the search
  max_size = 10,               # Allow at most 10 features in meta-feature matrix
  best_score_only = FALSE      # Return all results from the search
)
```

# Visualize best meta-features result

```{r ks.meta.plot}
# Extract the best meta-feature result
topn_best_meta <- CaDrA::topn_best(topn_list = candidate_search_res)

# Visualize meta-feature result
CaDrA::meta_plot(topn_best_list = topn_best_meta)
```

# Perform permutation-based testing

```{r}
# Set seed for permutation-based testing
set.seed(123)

perm_res <- CaDrA::CaDrA(
  FS = sim_FS, 
  input_score = sim_Scores, 
  method = "ks_pval",             # Use Kolmogorow-Smirnow scoring function 
  method_alternative = "less",    # Use one-sided hypothesis testing
  weights = NULL,                 # If weights is provided, perform a weighted-KS test
  search_method = "both",         # Apply both forward and backward search
  top_N = 7,                      # Repeat the search with the top N features
  max_size = 10,                  # Allow at most 10 features in the meta-feature matrix
  n_perm = 100,                   # Number of permutations to perform
  perm_alternative = "one.sided", # One-sided permutation-based p-value alternative type
  plot = FALSE,                   # We will plot later
  ncores = 2                      # Number of cores to perform parallelization
)
```

# Visualize permutation result

```{r ks.permutation.plot}
# Visualize permutation results
permutation_plot(perm_res = perm_res)
```

# SessionInfo

```{r RsessionInfo}
sessionInfo()
```

---
title: "How to run CaDrA within a Docker Environment"
output: rmarkdown::html_document
vignette: >
  %\VignetteIndexEntry{How to run CaDrA within a Docker Environment}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

# Software requirements

- Git version >= 2.21
- Docker version >= 20.10

Don't have Git installed, see [Git Guides](https://github.com/git-guides/install-git)

Don't have Docker installed, see [Docker Engine](https://docs.docker.com/engine/install/)

# Build Docker image of `CaDrA`

## (1) Clone this repository

```bash
git clone https://github.com/montilab/CaDrA
```

## (2) Navigate to `CaDrA` folder where `Dockerfile` is stored and build its Docker image. 

```bash
cd CaDrA
docker build -t montilab/cadra:latest .
```

**`-t`**: add a tag to an image such as the version of the application, e.g. *montilab/cadra:1.0.0* or *montilab/cadra:latest* <br>

### (3) After the build is completed, check if the image is built successfully

```bash
docker images

REPOSITORY      TAG        IMAGE ID        CREATED        SIZE
montilab/cadra  latest     2c22887402d3    2 hours ago    2.46GB
```

# Run `CaDrA` container with its built image

```bash
docker run --name cadra -d -p 8787:8787 -e PASSWORD=CaDrA montilab/cadra:latest
```

**`--name`**: give an identity to the container <br>
**`-d`**: run container in detached mode <br>
**`-p`**: map host port to container port **[host_port]:[container_port]** <br>
**`-e`**: set a default password to access RStudio Server

For more information about the Docker syntax, see [Docker run reference](https://docs.docker.com/engine/reference/run/)

Check if the container is built successfully

```bash
docker ps

CONTAINER ID   IMAGE                    COMMAND       CREATED        STATUS        PORTS                    NAMES
b37b6b19c4e8   montilab/cadra:latest    "/init"       5 hours ago    Up 5 hours    0.0.0.0:8787->8787/tcp   cadra
```

# Run `CaDrA` on RStudio Server hosted within a Docker environment

Using your preferred web browser, go to http://localhost:8787. You will be prompted to log into Rstudio Server. Enter the following credentials:

username: rstudio <br>
password: CaDrA

When the Rstudio Server is opened, copy the following commands and run them in the R console. The script is used to search for candidate drivers that associated with the YAP/TAZ Activity in the BrCA dataset that provided with the package.

```bash
# Load R packages
library(CaDrA)
library(SummarizedExperiment)

## Read in BRCA GISTIC+Mutation object
utils::data(BRCA_GISTIC_MUT_SIG)
eset_mut_scna <- BRCA_GISTIC_MUT_SIG

## Read in input score
utils::data(TAZYAP_BRCA_ACTIVITY)
input_score <- TAZYAP_BRCA_ACTIVITY

## Samples to keep based on the overlap between the two inputs
overlap <- base::intersect(base::names(input_score), base::colnames(eset_mut_scna))
eset_mut_scna <- eset_mut_scna[,overlap]
input_score <- input_score[overlap]

## Binarize FS to only have 0's and 1's
SummarizedExperiment::assay(eset_mut_scna)[SummarizedExperiment::assay(eset_mut_scna) > 1] <- 1.0

## Pre-filter FS based on occurrence frequency
eset_mut_scna_flt <- CaDrA::prefilter_data(
  FS = eset_mut_scna,
  max_cutoff = 0.6,  # max event frequency (60%)
  min_cutoff = 0.03  # min event frequency (3%)
) 

# Run candidate search
topn_res <- CaDrA::candidate_search(
  FS = eset_mut_scna_flt,
  input_score = input_score,
  method = "ks_pval",          # Use Kolmogorow-Smirnow scoring function 
  method_alternative = "less", # Use one-sided hypothesis testing
  weights = NULL,              # If weights is provided, perform a weighted-KS test
  search_method = "both",      # Apply both forward and backward search
  top_N = 7,                   # Evaluate top 7 starting points for each search
  max_size = 7,                # Maximum size a meta-feature matrix can extend to
  do_plot = FALSE,             # Plot after finding the best features
  best_score_only = FALSE      # Return all results from the search
)

## Fetch the meta-feature set corresponding to its best scores over top N features searches
topn_best_meta <- CaDrA::topn_best(topn_res)

# Visualize the best results with the meta-feature plot
CaDrA::meta_plot(topn_best_list = topn_best_meta, input_score_label = "YAP/TAZ Activity")

# Evaluate results across top N features you started from
CaDrA::topn_plot(topn_res) 
```

<br>

Any questions or issues? Please report them on our [github issues](https://github.com/montilab/CaDrA/issues).

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/CTNBB1_reporter.R
\docType{data}
\name{CTNBB1_reporter}
\alias{CTNBB1_reporter}
\title{Transcriptional Activity of Beta-Catenin in Cancers}
\format{
Consists of a vector of continuous scores of B-catenin
activity across 82 cancer cell lines. The mutation and copy number 
associated with this sample cohorts can be found in 
\code{CCLE_MUT_SCNA} dataset.
}
\usage{
data(CTNBB1_reporter)
}
\value{
a vector of continuous scores
}
\description{
A vector of continuous scores represents the activation of B-catenin across
multiple cancer cell lines
}
\references{
Kim, J., Botvinnik, O., Abudayyeh, O. et al.
Characterizing genomic alterations in cancer by complementary
functional associations.
Nat Biotechnol 34, 539–546 (2016).
\href{https://doi.org/10.1038/nbt.3527}{https://doi.org/10.1038/nbt.3527}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cadra.R
\name{CaDrA}
\alias{CaDrA}
\title{CaDrA Search}
\usage{
CaDrA(
  FS,
  input_score,
  method = c("ks_pval", "ks_score", "wilcox_pval", "wilcox_score", "revealer", "knnmi",
    "correlation", "custom"),
  method_alternative = c("less", "greater", "two.sided"),
  cmethod = c("spearman", "pearson"),
  custom_function = NULL,
  custom_parameters = NULL,
  weights = NULL,
  search_start = NULL,
  top_N = 1,
  search_method = c("both", "forward"),
  max_size = 7,
  n_perm = 1000,
  perm_alternative = c("one.sided", "two.sided"),
  obs_best_score = NULL,
  smooth = TRUE,
  plot = FALSE,
  ncores = 1,
  cache = FALSE,
  cache_path = NULL,
  verbose = FALSE
)
}
\arguments{
\item{FS}{a matrix of binary features or a SummarizedExperiment class object
from SummarizedExperiment package where rows represent features of interest
(e.g. genes, transcripts, exons, etc...) and columns represent the samples.
The assay of FS contains binary (1/0) values indicating the presence/absence
of omics features.}

\item{input_score}{a vector of continuous scores representing a phenotypic
readout of interest such as protein expression, pathway activity, etc.

NOTE: \code{input_score} object must have names or labels that match
the column names of \code{FS} object.}

\item{method}{a character string specifies a scoring method that is
used in the search. There are 6 options: (\code{"ks_pval"} or \code{ks_score}
or \code{"wilcox_pval"} or \code{wilcox_score} or
\code{"revealer"} (conditional mutual information from REVEALER) or
\code{"knnmi"} (K-Nearest Neighbor Mutual Information Estimator from knnmi) or
\code{"correlation"} or
\code{"custom"} (a user-defined scoring method)).
Default is \code{ks_pval}.}

\item{method_alternative}{a character string specifies an alternative
hypothesis testing (\code{"two.sided"} or \code{"greater"} or \code{"less"}).
Default is \code{less} for left-skewed significance testing.

NOTE: This argument only applies to \code{ks_pval} and \code{wilcox_pval}
method}

\item{cmethod}{correlation method to use - spearman or pearson. 
Default is "spearman".

NOTE: This argument only applies to \code{correlation} method}

\item{custom_function}{If method is \code{"custom"}, specifies
a user-defined function here. Default is \code{NULL}.

NOTE: \code{custom_function} must take \code{FS} and \code{input_score}
as its input arguments and its final result must return a vector of row-wise
scores where its labels or names match the row names of \code{FS} object.}

\item{custom_parameters}{If method is \code{"custom"}, specifies a list of
additional arguments (excluding \code{FS} and \code{input_score}) to be
passed to \code{custom_function}. For example:
custom_parameters = list(alternative = "less"). Default is \code{NULL}.}

\item{weights}{If method is \code{ks_score} or \code{ks_pval}, specifying a
vector of weights will perform a weighted-KS testing. Default is \code{NULL}.

NOTE: \code{weights} must have names or labels that match the labels of
\code{input_score}.}

\item{search_start}{a vector of character strings (separated by commas)
specifies feature names in the FS object to start the search with.
If \code{search_start} is provided, then \code{top_N} parameter will be
ignored and vice versa. Default is \code{NULL}.}

\item{top_N}{an integer specifies the number of features to start the
search over. By default, it starts with the feature that has the highest
best score (top_N = 1).

NOTE: If \code{top_N} is provided, then \code{search_start} parameter
will be ignored and vice versa. If top_N > 10, it may result in a longer
search time.}

\item{search_method}{a character string specifies an algorithm to filter out
the best candidates (\code{"forward"} or \code{"both"}). Default is
\code{both} (i.e., backward and forward).}

\item{max_size}{an integer specifies a maximum size that a meta-feature can
extend to do for a given search. Default is \code{7}.}

\item{n_perm}{an integer specifies the number of permutations to perform.
Default is \code{1000}.}

\item{perm_alternative}{an alternative hypothesis type for calculating
permutation-based p-value. Options: one.sided, two.sided. Default is
\code{one.sided}.}

\item{obs_best_score}{a numeric value corresponding to the best observed
score. This value is used to compare against the \code{n_perm} calculated best
scores. Default is \code{NULL}. If set to NULL, we will compute the observed
best score based on the given parameters.}

\item{smooth}{a logical value indicates whether or not to add a smoothing
factor of 1 to the calculation of permutation-based p-value. This option is
used to avoid a returned p-value of 0. Default is \code{TRUE}.}

\item{plot}{a logical value indicates whether or not to plot the empirical
null distribution of the permuted best scores. Default is \code{FALSE}.}

\item{ncores}{an integer specifies the number of cores to perform
parallelization for permutation-based testing. Default is \code{1}.}

\item{cache}{a logical value determines whether or not to cache the
permuted best scores. This helps to save time for future loading instead
of re-computing the permutation-based testing every time.
Default is \code{FALSE}.}

\item{cache_path}{a path to cache permuted best scores. Default is \code{NULL}.
If NULL, the cache path is set to system home directory
(e.g. \code{$HOME/.Rcache}) for future loading.}

\item{verbose}{a logical value indicates whether or not to print the
diagnostic messages. Default is \code{FALSE}.}
}
\value{
a list of 4 objects: \code{key}, \code{perm_best_scores},
\code{obs_best_score}, \code{perm_pval}

-\code{key}: a list of parameters that was used to cache the
results of the permutation-based testing. This is useful as the
permuted best scores can be recycled to save time for future loading.

-\code{perm_best_scores}: a vector of permuted best scores obtained
by performing \code{candidate_search} over \code{n_perm} iterations of
permuted input scores.

-\code{obs_best_score}: a user-provided best score or an observed best score
obtained by performing \code{candidate_search} on a given dataset and input
parameters. This value is later used to compare against the permuted best
scores (\code{perm_best_scores}).

\code{perm_pval}: a permutation-based p-value obtained by calculating
sum(perm_best_scores > obs_best_score)/n_perm

NOTE: If smooth = TRUE, a smoothing factor of 1 will be added to the
calculation of \code{perm_pval}.

e.g. (sum(perm_best_scores > obs_best_score) + 1) / (n_perm + c)

This is just to not return a p-value of 0
}
\description{
Perform permutation-based testings on a sample of permuted input scores
using \code{candidate_search} as the main iterative function for each run.
}
\examples{

# Load pre-computed feature set
data(sim_FS)

# Load pre-computed input-score
data(sim_Scores)

# Set seed for permutation
set.seed(21)

# Define additional parameters and start the search function
cadra_result <- CaDrA(
  FS = sim_FS, input_score = sim_Scores, method = "ks_pval",
  weights = NULL, method_alternative = "less", top_N = 1,
  search_start = NULL, search_method = "both", max_size = 7,
  n_perm = 10, perm_alternative = "one.sided", plot = FALSE,
  smooth = TRUE, obs_best_score = NULL,
  ncores = 1, cache = FALSE, cache_path = NULL
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cadra_functions.R
\name{prefilter_data}
\alias{prefilter_data}
\title{Pre-filter features}
\usage{
prefilter_data(FS, max_cutoff = 0.6, min_cutoff = 0.03, verbose = FALSE)
}
\arguments{
\item{FS}{a matrix of binary features or a SummarizedExperiment class object 
from SummarizedExperiment package where rows represent features of interest 
(e.g. genes, transcripts, exons, etc...) and columns represent the samples. 
The assay of FS contains binary (1/0) values indicating the presence/absence 
of ‘omics’ features.}

\item{max_cutoff}{a numeric value between 0 and 1 describing the absolute
prevalence of a feature across all samples in the FS object which the
feature will be filtered out. Default is 0.6 (feature that occur in
60 percent or more of the samples will be removed)}

\item{min_cutoff}{a numeric value between 0 and 1 describing the absolute
prevalence of a feature across all samples in the FS object which the
feature will be filtered out. Default is 0.03 (feature that occur in
3 percent or less of the samples will be removed)}

\item{verbose}{a logical value indicates whether or not to print the
diagnostic messages. Default is \code{FALSE}.}
}
\value{
A SummarizedExperiment object with only the filtered-in features
given the filtered thresholds
}
\description{
Pre-filter a dataset prior running \code{candidate_search} to avoid
testing features that are too prevalent or too sparse across samples in
the dataset
}
\examples{

# Load pre-computed feature set
data(sim_FS)

# Filter out features having < 3\% and > 60\% prevalence across all samples
# by (default)
sim_FS_filt1 <- prefilter_data(FS = sim_FS)

# Change the min cut-off to 1\% prevalence, instead of the default of 3\%
sim_FS_filt2 <- prefilter_data(FS = sim_FS, min_cutoff  = 0.01)

# Change the max cut-off to 65\% prevalence, instead of the default of 60\%
sim_FS_filt3 <- prefilter_data(FS = sim_FS, max_cutoff = 0.65)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/calc_rowscore.R
\name{calc_rowscore}
\alias{calc_rowscore}
\title{Calculate row-wise scores of a given binary feature set based on
a given scoring method}
\usage{
calc_rowscore(
  FS,
  input_score,
  meta_feature = NULL,
  method = c("ks_pval", "ks_score", "wilcox_pval", "wilcox_score", "revealer", "knnmi",
    "correlation", "custom"),
  method_alternative = c("less", "greater", "two.sided"),
  cmethod = c("spearman", "pearson"),
  custom_function = NULL,
  custom_parameters = NULL,
  weights = NULL,
  do_check = TRUE,
  verbose = FALSE,
  ...
)
}
\arguments{
\item{FS}{a matrix of binary features or a SummarizedExperiment class object
from SummarizedExperiment package where rows represent features of interest
(e.g. genes, transcripts, exons, etc...) and columns represent the samples.
The assay of FS contains binary (1/0) values indicating the presence/absence
of omics features.}

\item{input_score}{a vector of continuous scores representing a phenotypic
readout of interest such as protein expression, pathway activity, etc.

NOTE: \code{input_score} object must have names or labels that match the
column names of \code{FS} object.}

\item{meta_feature}{a vector of one or more features representing known
causes of activation or features associated with a response of interest
(\code{e.g. input_score}). Default is NULL.}

\item{method}{a character string specifies a scoring method that is
used in the search. There are 6 options: (\code{"ks_pval"} or \code{ks_score}
or \code{"wilcox_pval"} or \code{wilcox_score} or
\code{"revealer"} (conditional mutual information from REVEALER) or
\code{"knnmi"} (k-Nearest Neighbor Mutual Information Estimator from knnmi) or
\code{"correlation"} (based on simple correlation - pearson or spearman) or
\code{"custom"} (a user-defined scoring method)).
Default is \code{ks_pval}.}

\item{method_alternative}{a character string specifies an alternative
hypothesis testing (\code{"two.sided"} or \code{"greater"} or \code{"less"}).
Default is \code{less} for left-skewed significance testing.

NOTE: This argument only applies to \code{ks_pval} and \code{wilcox_pval}
method}

\item{cmethod}{correlation method to use - spearman or pearson. Default is "spearman"
#' NOTE: This argument only applies to \code{correlation} method only}

\item{custom_function}{if method is \code{"custom"}, specifies
a user-defined function here. Default is \code{NULL}.

NOTE: \code{custom_function} must take \code{FS} and \code{input_score}
as its input arguments, and its final result must return a vector of row-wise
scores where its labels or names matched the row names of \code{FS} object.}

\item{custom_parameters}{if method is \code{"custom"}, specifies a list of
additional arguments (excluding \code{FS} and \code{input_score}) to be
passed to \code{custom_function}. For example:
custom_parameters = list(alternative = "less"). Default is \code{NULL}.}

\item{weights}{If method is \code{ks_score} or \code{ks_pval}, specifying a
vector of weights will perform a weighted-KS testing. Default is \code{NULL}.

NOTE: \code{weights} must have names or labels that match the names or labels
of \code{input_score}.}

\item{do_check}{a logical value indicates whether or not to validate if the
given parameters (\code{FS} and \code{input_score}) are valid inputs.
Default is \code{TRUE}.}

\item{verbose}{a logical value indicates whether or not to print the
diagnostic messages. Default is \code{FALSE}.}

\item{...}{additional parameters to be passed to \code{custom_function}}
}
\value{
return a vector of row-wise positive scores where it is ordered from
most significant to least significant (e.g. from highest to lowest values)
and its labels or names must match the row names of \code{FS} object
}
\description{
Calculate row-wise scores of a given binary feature set based on
a given scoring method
}
\examples{

# Create a feature matrix
mat <- matrix(c(1,0,1,0,0,0,0,0,1,0,
                0,0,1,0,1,0,1,0,0,0,
                0,0,0,0,1,0,1,0,1,0), nrow=3)

colnames(mat) <- 1:10
row.names(mat) <- c("TP_1", "TP_2", "TP_3")

# Create a vector of observed input scores
set.seed(42)
input_score = rnorm(n = ncol(mat))
names(input_score) <- colnames(mat)

# Run the ks method
ks_rowscore_result <- calc_rowscore(
  FS = mat,
  input_score = input_score,
  meta_feature = NULL,
  method = "ks_pval",
  method_alternative = "less",
  weights = NULL
)

# Run the wilcoxon method
wilcox_rowscore_result <- calc_rowscore(
  FS = mat,
  input_score = input_score,
  meta_feature = NULL,
  method = "wilcox_pval",
  method_alternative = "less"
)

# Run the revealer method
revealer_rowscore_result <- calc_rowscore(
  FS = mat,
  input_score = input_score,
  meta_feature = NULL,
  method = "revealer"
)

# Run the revealer method
knnmi_rowscore_result <- calc_rowscore(
  FS = mat,
  input_score = input_score,
  meta_feature = NULL,
  method = "knnmi"
)

# Run the correlation method
 corr_result <- calc_rowscore(
   FS = mat,
   input_score = input_score,
   meta_feature = NULL,
   method = "correlation",
   cmethod = "spearman"
)

# A customized function using ks-test function
customized_ks_rowscore <- function(FS, input_score, meta_feature=NULL, alternative="less"){

  # Check if meta_feature is provided
  if(!is.null(meta_feature)){
    # Getting the position of the known meta features
    locs <- match(meta_feature, row.names(FS))

    # Taking the union across the known meta features
    if(length(locs) > 1) {
      meta_vector <- as.numeric(ifelse(colSums(FS[locs,]) == 0, 0, 1))
    }else{
      meta_vector <- as.numeric(FS[locs,])
    }

    # Remove the meta features from the binary feature matrix
    # and taking logical OR btw the remaining features with the meta vector
    FS <- base::sweep(FS[-locs, , drop=FALSE], 2, meta_vector, `|`)*1

    # Check if there are any features that are all 1s generated from
    # taking the union between the matrix
    # We cannot compute statistics for such features and thus they need
    # to be filtered out
    if(any(rowSums(FS) == ncol(FS))){
      warning("Features with all 1s generated from taking the matrix union ",
              "will be removed before progressing...\n")
      FS <- FS[rowSums(FS) != ncol(FS), , drop=FALSE]
    }
  }

  # KS is a ranked-based method
  # So we need to sort input_score from highest to lowest values
  input_score <- sort(input_score, decreasing=TRUE)

  # Re-order the matrix based on the order of input_score
  FS <- FS[, names(input_score), drop=FALSE]

  # Compute the scores using the KS method
  ks <- apply(FS, 1, function(r){
    x = input_score[which(r==1)];
    y = input_score[which(r==0)];
    res <- ks.test(x, y, alternative=alternative)
    return(c(res$statistic, res$p.value))
  })

  # Obtain score statistics
  stat <- ks[1,]

  # Obtain p-values and change values of 0 to the machine lowest value
  # to avoid taking -log(0)
  pval <- ks[2,]
  pval[which(pval == 0)] <- .Machine$double.xmin

  # Compute the -log(pval)
  # Make sure scores has names that match the row names of FS object
  scores <- -log(pval)
  names(scores) <- rownames(FS)

  return(scores)

}

# Search for best features using a custom-defined function
custom_rowscore_result <- calc_rowscore(
  FS = mat,
  input_score = input_score,
  meta_feature = NULL,
  method = "custom",
  custom_function = customized_ks_rowscore,
  custom_parameters = NULL
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/meta_plot.R
\name{meta_plot}
\alias{meta_plot}
\title{Candidate Drivers Search Plot}
\usage{
meta_plot(topn_best_list, input_score_label = NULL, plot_title = NULL)
}
\arguments{
\item{topn_best_list}{a list of objects returned from \code{candidate_search} 
corresponding to the search of top N features given by top_N value.
The topn_best_list contains the best meta-feature matrix, its 
corresponding best score, its observed input scores, rank of the best 
features based on their scores, marginal best scores, and cumulative 
best scores.}

\item{input_score_label}{a label that references to the \code{input_score}
variable that was used to compute the top N best features. 
Default is \code{NULL}.}

\item{plot_title}{a title to the plot. Default is \code{NULL}.}
}
\value{
3 plots stacked on top of each other: 
1. a density diagram of observed input scores sorted from highest to lowest 
2. a tile plot of the top features within the meta-feature set 
3. a KS enrichment plot of the meta-feature set (this correspond to the 
logical OR of the features)
}
\description{
By utilizing the top N results obtained from \code{candidate_search},
we can find the best meta-feature among the top N searches using
\code{topn_best}. \code{meta_plot} is then used to produce graphics
including a tile plot for the top meta-features that associated with  
a molecular phenotype of interest (e.g. input_score), 
the KS enrichment plot of the meta-features, 
and lastly, a density diagram of the distribution of the observed
input scores sorted from largest to smallest at the top.
}
\examples{

# Load pre-computed Top-N list generated for sim_FS dataset
data(topn_list)

# With the results obtained from top-N evaluation,
# We can find the combination of features that gives the best score in
# top N searches
topn_best_meta <- topn_best(topn_list = topn_list)

# Now we can plot this set of best meta-feature
meta_plot(topn_best_list = topn_best_meta)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/BRCA_GISTIC_MUT_SIG.R
\docType{data}
\name{BRCA_GISTIC_MUT_SIG}
\alias{BRCA_GISTIC_MUT_SIG}
\title{Genomic Data from TCGA BRCA MUT + GISTIC}
\format{
An object of class \code{SummarizedExperiment} from 
\code{SummarizedExperiment} package
containing an assay of 16,873 rows (features) and 951 columns (samples)
see \code{SummarizedExperiment} for more details.
}
\usage{
data(BRCA_GISTIC_MUT_SIG)
}
\value{
a SummarizedExperiment object
}
\description{
A SummarizedExperiment object consists of 16,873 genomic features 
across 951 samples.
}
\references{
Kartha VK, Kern JG, Sebastiani P, Zhang L,
Varelas X, Monti S (2019) CaDrA: A computational framework for performing
candidate driver analyses using binary genomic features.
(\href{https://www.frontiersin.org/articles/10.3389/fgene.2019.00121/full}{Frontiers in Genetics})
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/topn_best.R
\name{topn_best}
\alias{topn_best}
\title{Top 'N' Best Meta-Features}
\usage{
topn_best(topn_list)
}
\arguments{
\item{topn_list}{A nested list of objects that are returned 
from \code{candidate_search} using the following parameters:
\code{FS = sim_FS}, \code{input_score = sim_Scores}, 
\code{top_N = 7}, \code{method = "ks_pval"}, \code{alternative = "less"}, 
\code{search_method = "both"}, \code{max_size = 10}, and 
\code{best_score_only = FALSE}.}
}
\value{
A list of objects containing the best meta-feature matrix, its 
corresponding best score, its observed input scores, rank of best 
meta-features based on their scores, its marginal and cumulative best scores.
}
\description{
Take the resulting list of meta-features returned from 
\code{candidate_search} over top N feature searches and 
fetch the meta-feature with the best score.
}
\examples{

# Load pre-computed Top-N list generated for sim_FS dataset
data(topn_list)

# Get the best meta-features list
topn_best_meta <- topn_best(topn_list = topn_list)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sim_FS.R
\docType{data}
\name{sim_FS}
\alias{sim_FS}
\title{Simulated Genomic Data}
\format{
An object of class \code{SummarizedExperiment} from
\code{SummarizedExperiment} package containing 
an assay of 1000 rows (features)
and 100 columns (samples). Each row is represented by 
a vector of binary values (1/0)
indicating the presence/absence of the feature in the samples.

See \code{?SummarizedExperiment} for more details.
}
\usage{
data(sim_FS)
}
\value{
a SummarizedExperiment object
}
\description{
A simulated SummarizedExperiment object that comprises of 1000 genomic
features (rows) and 100 sample profiles (columns).
Each row is represented by a vector of binary values (1/0)
indicating the presence/absence of the feature in the samples.
This simulated data includes 10 left-skewed (i.e. True Positive or TP)
and 990 uniformly-distributed (i.e. True Null or TN) features.
}
\references{
Kartha VK, Kern JG, Sebastiani P, Zhang L,
Varelas X, Monti S (2019) CaDrA: A computational framework for performing
candidate driver analyses using binary genomic features.
(\href{https://www.frontiersin.org/articles/10.3389/fgene.2019.00121/full}{Frontiers in Genetics})
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cadra_functions.R
\name{generate_permutations}
\alias{generate_permutations}
\title{Random permutation matrix generator}
\usage{
generate_permutations(input_score, n_perm)
}
\arguments{
\item{input_score}{a vector of continuous scores of a molecular phenotype of 
interest such as protein expression, pathway activity, etc.
NOTE: The \code{input_score} object must have names or labels to track 
samples by.}

\item{n_perm}{a number of permutations to generate. This determines
the number of rows in the permutation matrix.}
}
\value{
a matrix of values where each row contains scores of a single 
permuted \code{input_score}.
}
\description{
Produces a random permutation score matrix given a vector of sample-specific
scores representing a phenotypic readout of interest such as protein 
expression, pathway activity, etc.
}
\examples{

# Load pre-simulated scores
data(sim_Scores)

# Set seed for permutation
set.seed(123)

# Define number of permutations
n_perm = 1000

# Generate permuted scores
perm_matrix <- generate_permutations(
  input_score = sim_Scores,
  n_perm = n_perm
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/topn_plot.R
\name{topn_plot}
\alias{topn_plot}
\title{Top 'N' Plot}
\usage{
topn_plot(topn_list)
}
\arguments{
\item{topn_list}{a list of objects obtained from \code{candidate_search} 
using the following parameters: \code{FS = sim_FS}, 
\code{input_score = sim_Scores}, \code{top_N = 7}, 
\code{method = "ks_pval"}, \code{alternative = "less"}, 
\code{search_method = "both"}, \code{max_size = 10},
and \code{best_score_only = FALSE}.}
}
\value{
a heatmap of overlapping meta-features across top N 
feature searches
}
\description{
Generate a heatmap representation of overlapping meta-features across
top N feature searches using \code{candidate_search} function
}
\examples{

# Load pre-computed Top-N list generated for sim_FS dataset
data(topn_list)

# Get the overlapping top N plot
topn_plot(topn_list = topn_list)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/perm_res.R
\docType{data}
\name{perm_res}
\alias{perm_res}
\title{Pre-computed permutation results for simulated data (\code{sim_FS})}
\format{
A list of objects returned from \code{CaDrA} function. The resulting 
object contains a list of key parameters that was used to run the
permutation-based testing, a vector of permuted best scores for 
a given n_perm, an observed best score, and a permuted p-value.

To visualize the Empirical Null Distribution of the permuted best scores over 
n_perm iterations, just pass the resulting list to \code{permutation_plot}.

See \code{permutation_plot} for more details.
}
\usage{
data(perm_res)
}
\value{
a list of objects returned from \code{CaDrA} function
}
\description{
The permutation result returned from \code{CaDrA} 
using pre-simulated dataset
(\code{FS = sim_FS}), pre-simulated input scores 
(\code{input_score = sim_Scores}), 
\code{top_N = 7}, \code{method = "ks_pval"}, \code{alternative = "less"}, 
\code{search_method = "both"}, \code{max_size = 10},
\code{obs_best_score = NULL} and \code{n_perm = 1000} 
as inputs to the function.
}
\examples{

# Load the pre-computed permutation results for sim_FS
data(perm_res)

# Plot the Empirical Null Distribution of the permuted best scores
# against its observed best score
permutation_plot(perm_res = perm_res)

}
\references{
Kartha VK, Kern JG, Sebastiani P, Zhang L,
Varelas X, Monti S (2017) CaDrA: A computational framework for performing
candidate driver analyses using binary genomic features.
(\href{https://www.frontiersin.org/articles/10.3389/fgene.2019.00121/full}{Frontiers in Genetics})
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/candidate_search.R
\name{candidate_search}
\alias{candidate_search}
\title{Candidate Search}
\usage{
candidate_search(
  FS,
  input_score,
  method = c("ks_pval", "ks_score", "wilcox_pval", "wilcox_score", "revealer", "knnmi",
    "correlation", "custom"),
  method_alternative = c("less", "greater", "two.sided"),
  cmethod = c("spearman", "pearson"),
  custom_function = NULL,
  custom_parameters = NULL,
  weights = NULL,
  search_start = NULL,
  top_N = 1,
  search_method = c("both", "forward"),
  max_size = 7,
  best_score_only = FALSE,
  do_plot = FALSE,
  verbose = FALSE
)
}
\arguments{
\item{FS}{a matrix of binary features or a SummarizedExperiment class object
from SummarizedExperiment package where rows represent features of interest
(e.g. genes, transcripts, exons, etc...) and columns represent the samples.
The assay of FS contains binary (1/0) values indicating the presence/absence
of omics features.}

\item{input_score}{a vector of continuous scores representing a phenotypic
readout of interest such as protein expression, pathway activity, etc.

NOTE: \code{input_score} object must have names or labels that match the
column names of \code{FS} object.}

\item{method}{a character string specifies a scoring method that is
used in the search. There are 7 options: (\code{"ks_pval"} or \code{ks_score}
or \code{"wilcox_pval"} or \code{wilcox_score} or
\code{"revealer"} (conditional mutual information from REVEALER) or
\code{"knnmi"} (K-Nearest Neighbor Mutual Information Estimator from knnmi) or
\code{"correlation"} (based on simple correlation - pearson or spearman) or
\code{"custom"} (a user-defined scoring method)).
Default is \code{ks_pval}.}

\item{method_alternative}{a character string specifies an alternative
hypothesis testing (\code{"two.sided"} or \code{"greater"} or \code{"less"}).
Default is \code{less} for left-skewed significance testing.

NOTE: This argument only applies to \code{ks_pval} and \code{wilcox_pval} method}

\item{cmethod}{correlation method to use - spearman or pearson. 
Default is "spearman".

NOTE: This argument only applies to \code{correlation} method only}

\item{custom_function}{if method is \code{"custom"}, specifies
a user-defined function here. Default is \code{NULL}.

NOTE: \code{custom_function} must take FS and input_score as its
input arguments and its final result must return a vector of row-wise scores
where its labels or names match the row names of \code{FS} object.}

\item{custom_parameters}{if method is \code{"custom"}, specifies a list of
additional arguments (excluding \code{FS} and \code{input_score})
to be passed to the \code{custom_function}. For example:
custom_parameters = list(alternative = "less"). Default is \code{NULL}.}

\item{weights}{if method is \code{ks_score} or \code{ks_pval}, specifying a
vector of weights will perform a weighted-KS testing. Default is \code{NULL}.

NOTE: \code{weights} must have names or labels that match the labels of
\code{input_score}.}

\item{search_start}{a vector of character strings (separated by commas)
specifies feature names in the \code{FS} object to start the search with.
If \code{search_start} is provided, then \code{top_N} parameter will be
ignored and vice versa. Default is \code{NULL}.}

\item{top_N}{an integer specifies the number of features to start the
search over. By default, it starts with the feature that has the highest
best score (top_N = 1).

NOTE: If \code{top_N} is provided, then \code{search_start} parameter
will be ignored and vice versa. If top_N > 10, it may result in a longer
search time.}

\item{search_method}{a character string specifies an algorithm to filter
out the best features (\code{"forward"} or \code{"both"}). Default is
\code{both} (i.e. backward and forward).}

\item{max_size}{an integer specifies a maximum size that a meta-feature
can extend to do for a given search. Default is \code{7}.}

\item{best_score_only}{a logical value indicates whether or not to return
the best score corresponding to each top N searches only.
Default is \code{FALSE}.}

\item{do_plot}{a logical value indicates whether or not to plot the
overlapping features of the resulting meta-feature matrix.

NOTE: plot can only be produced if the resulting meta-feature matrix contains
more than 1 feature (e.g. length(search_start) > 1 or top_N > 1).
Default is \code{FALSE}.}

\item{verbose}{a logical value indicates whether or not to print the
diagnostic messages. Default is \code{FALSE}.}
}
\value{
If \code{best_score_only = TRUE}, the heuristic search will return
the best feature whose its union meta-feature matrix has the highest score
among the \code{top_N} feature searches.
If \code{best_score_only = FALSE}, a list of objects pertaining to
\code{top_N} feature searches will be returned. For each top_N feature search,
the candidate search will contain 7 objects: (1) its best meta-feature matrix
(\code{feature_set}), (2) its observed input scores (\code{input_score}),
(3) its corresponding best score pertaining to the union meta-feature
matrix (\code{score}), (4) names of the best meta-features (\code{best_features}),
(5) rank of the best meta-features in term of their best scores (\code{best indices}),
(6) marginal scores of the best meta-features (\code{marginal_best_scores}),
(7) cumulative scores of the best meta-features (\code{cumulative_best_scores}).
}
\description{
Performs heuristic search on a set of binary features to determine whether
there are features whose union is more skewed (enriched at the extremes)
than either features alone. This is the main functionality of
the \code{CaDrA} package.
}
\details{
NOTE: The legacy function \code{topn_eval} is equivalent to the recommended
\code{candidate_search} function
}
\examples{

# Load pre-computed feature set
data(sim_FS)

# Load pre-computed input scores
data(sim_Scores)

# Define additional parameters and run the function
candidate_search_result <- candidate_search(
  FS = sim_FS, input_score = sim_Scores,
  method = "ks_pval", method_alternative = "less", weights = NULL,
  search_start = NULL, top_N = 3, search_method = "both",
  max_size = 7, best_score_only = FALSE
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sim_scores.R
\docType{data}
\name{sim_Scores}
\alias{sim_Scores}
\title{Simulated Input Scores}
\format{
A vector of continuous scores randomly generated 
from \code{rnorm(n=ncol(sim_FS), mean=0, sd=1)} with \code{set.seed(123)} 
based on the number of samples in the
simulated dataset (sim_FS)
}
\usage{
data(sim_Scores)
}
\value{
a vector of continuous scores
}
\description{
A simulated vector of continuous scores generated from 
\code{rnorm(n=ncol(sim_FS), mean=0, sd=1)} with \code{set.seed(123)} 
based on the number of samples in the
simulated dataset (sim_FS)
}
\references{
Kartha VK, Kern JG, Sebastiani P, Zhang L,
Varelas X, Monti S (2019) CaDrA: A computational framework for performing
candidate driver analyses using binary genomic features.
(\href{https://www.frontiersin.org/articles/10.3389/fgene.2019.00121/full}{Frontiers in Genetics})
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TAZYAP_BRCA_ACTIVITY.R
\docType{data}
\name{TAZYAP_BRCA_ACTIVITY}
\alias{TAZYAP_BRCA_ACTIVITY}
\title{YAP/TAZ Activity in TCGA BRCA dataset}
\format{
consists of a vector of continuous scores of YAP/TAZ activity
across 951 profiles. The mutation and copy number associated with this sample
cohorts can be found in \code{BRCA_GISTIC_MUT_SIG} dataset.
}
\usage{
data(TAZYAP_BRCA_ACTIVITY)
}
\value{
a vector of continuous scores
}
\description{
A vector of continuous scores represents oncogenic YAP/TAZ activity
in human breast carcinomas
}
\references{
Kartha VK, Kern JG, Sebastiani P, Zhang L,
Varelas X, Monti S (2019) CaDrA: A computational framework for performing
candidate driver analyses using binary genomic features.
(\href{https://www.frontiersin.org/articles/10.3389/fgene.2019.00121/full}{Frontiers in Genetics})
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/permutation_plot.R
\name{permutation_plot}
\alias{permutation_plot}
\title{Permutation Best Scores Plot}
\usage{
permutation_plot(perm_res)
}
\arguments{
\item{perm_res}{a list of objects returned from \code{CaDrA} function.
The returning object contains a list of key parameters that are used to run
the permutation-based testing, a vector of permuted best scores for a given 
\code{n_perm}, an observed best score, and a computed permutation p-value.}
}
\value{
a density plot
}
\description{
Plot the Empirical Null Distribution of Permutation Best Scores returned from
\code{CaDrA} function
}
\examples{

# Load pre-computed permutation results
data(perm_res)

# Plot the permutation results
permutation_plot(perm_res)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/CCLE_MUT_SCNA.R
\docType{data}
\name{CCLE_MUT_SCNA}
\alias{CCLE_MUT_SCNA}
\title{Genomic Data from CCLE MUT + SCNA}
\format{
An object of class \code{SummarizedExperiment} from 
\code{SummarizedExperiment} package
containing a matrix of 17,724 rows (features) and 82 columns (samples).
See \code{SummarizedExperiment} for more details.
}
\usage{
data(CCLE_MUT_SCNA)
}
\value{
a SummarizedExperiment object
}
\description{
A SummarizedExperiment object consists of 17,724 genomic features across 
82 samples.
}
\references{
Kim, J., Botvinnik, O., Abudayyeh, O. et al.
Characterizing genomic alterations in cancer by complementary functional
associations. Nat Biotechnol 34, 539–546 (2016).
\href{https://doi.org/10.1038/nbt.3527}{https://doi.org/10.1038/nbt.3527}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/topn_list.R
\docType{data}
\name{topn_list}
\alias{topn_list}
\title{Top-N Results for Simulated Data (\code{sim_FS})}
\format{
A list of objects returned from \code{candidate_search} including 
a set of best meta-feature matrix, its corresponding best score, its 
observed input scores, rank of the best features based on their scores, 
marginal best scores, and cumulative best scores. pertaining to each 
top N feature searches.

See \code{\link[CaDrA]{candidate_search}} for more information.
}
\usage{
data(topn_list)
}
\value{
a list of objects returned from \code{candidate_search} function
}
\description{
A list of objects returned from \code{candidate_search} 
using simulated dataset \code{FS = sim_FS}, \code{input_score = sim_Scores}, 
\code{top_N = 7}, \code{method = "ks_pval"}, \code{alternative = "less"}, 
\code{search_method = "both"}, \code{max_size = 10}, and 
\code{best_score_only = FALSE}.
}
\details{
NOTE: \code{max_size} is set to 10 as we would like to account
for the presence of 10 left-skewed (i.e. true positive or TP) features 
in \code{sim_FS} dataset.
}
\examples{

# Load pre-computed Top-N list generated for sim_FS and sim_Scores dataset
data(topn_list)

# Fetch the first meta-feature
topn_list[[1]]$feature_set

# Fetch the second meta-feature
topn_list[[2]]$feature_set

# Retrieve the meta-feature with the best score among top_N = 7 runs
topn_best_meta <- topn_best(topn_list = topn_list)

# Visualize the best meta-feature using meta_plot function
meta_plot(topn_best_list = topn_best_meta)

# Visualize overlap of meta-features across top_N = 7 
# using topn_plot function
topn_plot(topn_list = topn_list)

}
\references{
Kartha VK, Kern JG, Sebastiani P, Zhang L,
Varelas X, Monti S (2019) CaDrA: A computational framework for performing
candidate driver analyses using binary genomic features.
(\href{https://www.frontiersin.org/articles/10.3389/fgene.2019.00121/full}{Frontiers in Genetics})
}
\keyword{datasets}
